<h3>Jomres 9.21.3 08/01/2020</h3>

<span class="label label-warning">Change</span> Removed some unnecessary code that was preventing deletion of properties via componentArgs and REST API
<span class="label label-warning">Change</span> Improved how errors are output by the api when in dev mode.
<span class="label label-warning">Change</span> Improved PUT method handling
<span class="label label-warning">Change</span> Disabled some automatic plugin installation functionality that can cause some problems and isn't really necessary.
<span class="label label-warning">Change</span> Added some throttling to ensure that syndicate servers don't get spammed by api hits quite as much.
<span class="label label-warning">Change</span> Guest email address and phone number added to timeline on-hover popup.
<span class="label label-warning">Change</span> Added code to prevent the session handler from creating rows in the sessions table when queries appear to come from localhost (guzzle calls to self for deferred or asynchronous jobs).
<span class="label label-warning">Change</span> 03379 scripts updated so that property uid can be passed via component args. This allows the channel manager property import functionality to store images using the Jomres framework which ensures that resource types etc are respected within the context of Jomres.
<span class="label label-warning">Change</span> Added code to handle channel management framework plugins
<span class="label label-warning">Change</span> Added stripe_connect_return as a task that wp should not allow redirections on.
<span class="label label-warning">Change</span> Added french lang files to joomla cms plugin

<span class="label label-important label-danger">Fix</span> Fixed a bug in syndicate guests details handling.
<span class="label label-important label-danger">Fix</span> Resolved an issue with creating seeds of property feature categories.
<span class="label label-important label-danger">Fix</span> Added code to check for crawler, and if not a crawler then it's ok to trigger scheduled tasks. Bots just create too much work/too many sessions.
<span class="label label-important label-danger">Fix</span> Fixed an issue on new installations where a column is missing.
<span class="label label-important label-danger">Fix</span> Re-added some template output for edit booking guest details so that in the event that the account details haven't been updated, their booking information still shows.
<span class="label label-important label-danger">Fix</span> Fixed a bug when extras quantities are not being stored at contracts table (thanks Rod)
<span class="label label-important label-danger">Fix</span> Removed updating of the is_localhost flag as it's no longer necessary and updaters who's installations aren't properly running the table update functionality (possibly due to timeouts) are having problems running their newly updated Jomres installations.
<span class="label label-important label-danger">Fix</span> Fixed an issue where pdfs are not deleted on property details update
<span class="label label-important label-danger">Fix</span> Added some pdf files that were causing new bookings to fail.

<h3>Jomres 9.21.2 19/11/2019</h3>

<span class="label label-important label-danger">Fix</span> Fixed an issue where schema content could appear in property details pages.

<h3>Jomres 9.21.1 18/11/2019</h3>

<span class="label label-important label-danger">Fix</span> Sometimes, being a good developer of a system means knowing when to cut your losses and abandon a feature that you've spent many hours on. Ripped out the Package management feature, which was designed to make Jomres smaller and the system more secure. Unfortunately the implementation was troublesome and I've decided to revert to previous methodology whereby node modules and vendor packages are included in Jomres Core instead of as package files.


<h3>Jomres 9.21.0 18/11/2019</h3>

<span class="label label-success">Feature</span> Added functionality to mark guests as "no show". This information is then passed to the app server so that together Jomres syndicate site owners can get information about potential guests.
<span class="label label-success">Feature</span> Added complete new schema templates and script for MRPs and SRPs.
<span class="label label-success">Feature</span> Added ability to add menu options based on searching by property feature.
<span class="label label-success">Feature</span> Added ability for Jomres Call Api class (class that calls the local api) to handle headers. New channel management REST API code requires having the channel name in the headers.

<span class="label label-warning">Change</span> Improved api routing so that files like aaa_bbb_ccc_ddd which correspond to endpoints like jomres/api/aaa/bbb/ccc/ddd/@id can be found and used. Preserves older style of routing for existing api feature plugins.
<span class="label label-warning">Change</span> Tweaked functionality so that if gmaps api key not saved, then user not encouraged to save the key, and panels are no longer visible.
<span class="label label-warning">Change</span> Tweaked how check syndicate domains handles exceptions
<span class="label label-warning">Change</span> Tweaked optin save record functionality to not bother if IP number is localhost.
<span class="label label-warning">Change</span> Changed functionality so that localhost sessions are cleaned up more quickly. With the addition of a variety of features Jomres calls itself more often and this is causing the session table to grow more quickly in the past so we'll clean up more quickly too.
<span class="label label-warning">Change</span> Added guest name and booking number to add note and add service to bill screens.
<span class="label label-warning">Change</span> Added guest name to cancel booking output, refactored cancellation script to use a new class.
<span class="label label-warning">Change</span> Code comments and a couple of not needed methods removed.
<span class="label label-warning">Change</span> Disabled some logging that didn't need to be in place.
<span class="label label-warning">Change</span> Refactored the internal call api class.
<span class="label label-warning">Change</span> Modified list guests page because the guest's email address not being immediately visible was bugging me.
<span class="label label-warning">Change</span> Added functionality to ensure that we're not adding our own property to the list of properties in the network.
<span class="label label-warning">Change</span> Changed a logging level in get syndication properties script
<span class="label label-warning">Change</span> Improved syndicated properties display in small screens
<span class="label label-warning">Change</span> Tweaked new guest creation by manager so that a cms user is already created if one does not already exist with that email address.

<span class="label label-important label-danger">Fix</span> Decoded some sanitisation of telephone numbers.
<span class="label label-important label-danger">Fix</span> Resolved an issue that jsitemaps was having building sitemaps for Jomres.
<span class="label label-important label-danger">Fix</span> Fixed a bug when users needed to click two times in order to go to next month.

<h3>Jomres 9.20.0 31/10/2019</h3>

<span class="label label-success">Feature</span> Added significant update to user handling within Jomres to allow for private and public user data and user profiles.
<span class="label label-success">Feature</span> Users are now able to add "About me" information which is added to their profile page, and define Preferences (which are prefilled in the special requirements field of the Booking Confirmation form). Their Edit Account page now prompts them to enter such private information as driving license, passport and IBAN number (suggested only, not mandatory).
<span class="label label-success">Feature</span> Private data is viewable by the user themselves, their hosts when they've made a booking at a property, and super managers only.
<span class="label label-success">Feature</span> List Bookings/Invoices/Guests pages offer links to the guest's profiles, and in the List Guests page a receptionist or manager can add a review of the guest, which is visible in the Guest's profile page. This means that when managers/hosts are viewing booking requests they can view both the guest's reviews of other properties, plus other host's reviews of the guest. They can also view the guest's About me section and the private data, all of which should help managers when they're deciding whether or not to approve a booking.
<span class="label label-success">Feature</span> The guest's profile (including private data) are also viewable in the Guest tab of the view booking page.

<span class="label label-success">Feature</span> New syndication stats panel added to cpanel


<span class="label label-warning">Change</span> Changed syndication network range from 1 - 20km for finding first choice properties to display.
<span class="label label-warning">Change</span> Improved performance of get_properties syndicate cron job, had to disable checking of images because the process would take too long
<span class="label label-warning">Change</span> Made some log items debug only due to the amount of log files they were creating.
<span class="label label-warning">Change</span> Updated the install plugin manager prompts to highlight if ioncube is not available and then recommend that the plugin manager not be installed if the user does not have a one-off license and moved the license nag to Site Configuration.
<span class="label label-warning">Change</span> Disabled Gmap if api key not set as it triggers js errors now, which prevent the main menu from running.
<span class="label label-warning">Change</span> Removed the hashes file as it's not needed and chunky. It was only used by the file system integrity check which itself is unreliable so there's no point in shuffling those bytes around the interwebs.


<span class="label label-warning">Change</span> Fixed a minor bug in a cron job.
<span class="label label-warning">Change</span> Wordpress changed stuff, so I fixed stuff. (The new page editor was trying to call index.php in the Jomres dir, causing an error so tweaked that to include the index.php above). Added warnings about installing a Bootstrap theme and provided a link to the Leohtian theme on jomres.net for those who don't have a preferred theme.

<h3>Jomres 9.19.2 28/10/2019</h3>

<span class="label label-success">Feature</span> Improved syndication functionality, added new table for property distances, when the show syndication script attempts to show syndicated properties a min and max distances setting is applied and any properties that fall within that window are selected to be shown. This allows the guest to see properties in the general area (currently between 50 & 100km) whilst not showing the current property's neighbours who may also be competitors.

<span class="label label-important label-danger">Fix</span> Updated PUT method handling to ensure that it doesn't throw notices when form data is empty.
<span class="label label-important label-danger">Fix</span> Added check to see if API definition exists, if it does and it's an API call, we suppress some output.
<span class="label label-important label-danger">Fix</span> Improved performance and exception handling of syndicate cron tasks
<span class="label label-important label-danger">Fix</span> Improved core package handling to ensure graceful fallback in the event of a sha not being built correctly.


<h3>Jomres 9.19.1 21/10/2019</h3>

<span class="label label-warning">Change</span> Added functionality to silently add plugins if required by REST API
<span class="label label-warning">Change</span> Installer scripts updated to remove space check

<span class="label label-important label-danger">Fix</span> Removed a usort section of code that was preventing normal mode tariffs from being saved.


<h3>Jomres 9.19.0 18/10/2019</h3>

<span class="label label-success">Feature</span> Added the Jomres Syndication Network functionality which lists your properties on other Jomres based sites, giving you the opportunity to advertise your properties at no extra cost, across the world. No personal data is recorded or revealed, just the url to the Jomres site and the number of properties it has.
<span class="label label-success">Feature</span> Added feature where API functionality can offer built-in API methods. 


<span class="label label-warning">Change</span> Added code to delete property script to allow deletion of properties through componentArgs, meaning it can be called as a discreet script, rather than always being intended to be run through the browser.
<span class="label label-warning">Change</span> Added  ROW_FORMAT=DYNAMIC to the query that creates the propertys table.
<span class="label label-warning">Change</span> Updated language files to emphasise that property managers must always be existing cms users.

<span class="label label-important label-danger">Fix</span> Fixed an issue where stars selection was not added to paging urls in list properties.
<span class="label label-important label-danger">Fix</span> Asynchronous deferred tasks were causing some slowdowns to added a solution to possibly use wget to trigger deferred tasks instead.
<span class="label label-important label-danger">Fix</span> Improved how list bookings page searches for guest names & email addresses
<span class="label label-important label-danger">Fix</span> Modified booking engine so that a double check is done on price to ensure that an edge case doesn't result in 0 price tariffs being presented in the booking form.
<span class="label label-important label-danger">Fix</span> Fixed some issues in REST API functionality created by the previous update's changes to file paths.

<h3>Jomres 9.18.0 02/09/2019</h3>

<span class="label label-success">Feature</span> Added new package handling functionality that reduces the size of Jomres Core, putting Node and Composer files into their own packages which are then downloaded and installed automatically by Jomres. 
<span class="label label-success">Feature</span> System French language files significantly updated, plus hard-coded lables in a handful of files removed and replaced with placeholder strings for patTemplate so that everything can be translated. All plugins updated with French language files. Many thanks for your hard work regarding this, Stephane. 

<span class="label label-warning">Change</span> Added referrer to list bookings page
<span class="label label-warning">Change</span> Modified translate lang file strings page to output the constant name as this makes the strings more identifiable
<span class="label label-warning">Change</span> Modified calendar generator so that black booking date picker automatically jumps to next date in "end" calendar.
<span class="label label-warning">Change</span> Added Core Package Management to Jomres to allow us to treat Vendor and Node Modules as separate packages, reducing the size of Jomres Core. This is required because these directories in particular make Jomres much larger than it needs to be. It also allows us to apply vuln fixes without forcing complete updates of Jomres. Todo : Make the installer page a bit prettier and fire the installation process through ajax.
<span class="label label-warning">Change</span> Modified booking engine so that unavailable dates are shown in departure calendar as well as arrival calendar, in booking form.
<span class="label label-warning">Change</span> Modified booking engine to prevent managers from inadvertently re-using email addresses of existing guests.
<span class="label label-warning">Change</span> Modfied property type handling. If a property type has no published properties, you will be able to unpublish it. Added a sanity check so that if a manager is attempting to modify a property who's property type is not published, they are advised to either contact the site admin, or change the property type.
<span class="label label-warning">Change</span> Updated the system so that if a property prevents a feature from being deleted, the system will give useful feedback as to which properties cause the problem.
<span class="label label-warning">Change</span> Added a new language definition and changed the delete property type handling so that property uids that prevent a property type from being deleted are shown.
<span class="label label-warning">Change</span> Added reason notification if a property type cannot be unpublished.
<span class="label label-warning">Change</span> Updated logging in mailer to log to own channel with more information.
<span class="label label-warning">Change</span> Added a check to see if a bot is trying to post to the completebk page without going through the booking form.
<span class="label label-warning">Change</span> Changed how integrity check is done, thanks Rod.
<span class="label label-warning">Change</span> Removed jr_ucwords from admin area menu generation because it's not valid in all languages.
<span class="label label-warning">Change</span> Updated subscription links in admin area for Jomres Trial/Subscription

<span class="label label-important label-danger">Fix</span> Fixed an issue where the no image sanity check wasn't returning the required message when no image had been uploaded.
<span class="label label-important label-danger">Fix</span> Added a missing table for initial installation process.
<span class="label label-important label-danger">Fix</span> Fixed a notice warning When an external plugin has a 01011 class but there is not a "LASTMINUTE" override with in the response
<span class="label label-important label-danger">Fix</span> Modified availability calendar functionality to ensure that default calendar months to show setting from default property settings is honoured.
<span class="label label-important label-danger">Fix</span> Tweaked slideshow.html so that it behaves properly on mobile.
<span class="label label-important label-danger">Fix</span> Tweaked edit tariffs normal to ensure that room/property types are listed in a more natural order.
<span class="label label-important label-danger">Fix</span> Tweaked a query that creates multiple rooms, ensuring that the query converts strings to integers when trying to find the highest room number.


<h3>Jomres 9.17.1 24/04/2019</h3>

<span class="label label-warning">Change</span> Modified show property room type script so that if there are no slideshow images for that room type (which there will not be if the room type was created by site admin, then don't show the no-image slideshow. This is a stop-gap change until I can figure out a better solution.
<span class="label label-warning">Change</span> Tweaked javascript/css loader script so that editable javascript files are always included. Allows us to include custom buttons in jomres.js for the inline editing feature.
<span class="label label-warning">Change</span> Improved how new filtering for guest names works so that other columns correctly have their filters applied.
<span class="label label-warning">Change</span> Added checks for application/json so that the ajax definition can be set if required by looking at the http accept headers.
<span class="label label-warning">Change</span> Added some tweaks to site config settings saving functionality to support upcoming channel manager functionality & saving multiple accounts.
<span class="label label-warning">Change</span> Node modules and obsolete file handling updated
<span class="label label-warning">Change</span> Tweaked image uploader to ensure that spaces and brackets are removed from file names.
<span class="label label-warning">Change</span> Added last_minute_overlay.html and code to allow site owners to display discount information on the photo view search results.
<span class="label label-warning">Change</span> Added a flag to skip the gdpr consent form if set in the url, so that FB urls etc can show the property description etc rather than the "consent to store data" message.

<span class="label label-important label-danger">Fix</span> Disabled some functionality that has caused several users to have duplicate users in the guest profiles table, causing bookings to fail.
<span class="label label-important label-danger">Fix</span> Removed lots of fonts from mpdf because they were making the Nightly package too large.
<span class="label label-important label-danger">Fix</span> Fix issue where some users were seeing javascript error on list bookings page
<span class="label label-important label-danger">Fix</span> Modified show property room type script so that tariff price displays consistently.
<span class="label label-important label-danger">Fix</span> Added some additional input filtering the prevent fatal errors that could arise in some circumstances.
<span class="label label-important label-danger">Fix</span> Fixed a notice caused by missing images.

<h3>Jomres 9.17.0 26/02/2019</h3>

<span class="label label-success">Feature</span> Invoices can now be exported as PDF files. 
<span class="label label-success">Feature</span> Terms and conditions are automatically converted to PDF and added to booking confirmation emails. 

<span class="label label-warning">Change</span> Updated currency codes, using CUC instead of CUP as this is more relevant to travellers.
<span class="label label-warning">Change</span> Modified admin area stats so that pending invoice payment bookings are counted when generating stats because some users do not mark invoices as paid.
<span class="label label-warning">Change</span> Added classic-loader.gif to assets css dir.
<span class="label label-warning">Change</span> Improved property bookings list by including custom invoice numbers where appropriate in the invoice id column.
<span class="label label-warning">Change</span> Improved functionality where if review functionality is disabled, reviews button isn't shown in guest bookings list.
<span class="label label-warning">Change</span> Added gatekeeping to check for visitors allowed to book online when feature disabled.
<span class="label label-warning">Change</span> Bootstrap 3 version updated.
<span class="label label-warning">Change</span> Improved room type functionality so that it uses custom text strings.
<span class="label label-warning">Change</span> Improved custom text handling. Added a site config option that allows you to choose which custom text should have priority if there is a definition for both individual properties and site-wide. Defaults to giving property strings priority. Improved buttons in inline editing to use font awesome classes.

<span class="label label-important label-danger">Fix</span> Implemented functionality that should fix the "can't filter by guest name in list bookings and list invoices pages" problems.
<span class="label label-important label-danger">Fix</span> Fixed a couple of minor notices.
<span class="label label-important label-danger">Fix</span> Resolved an issue where one installation wouldn't fire the correct task (save_property)
<span class="label label-important label-danger">Fix</span> Fixed error when saving account details for the first time 
<span class="label label-important label-danger">Fix</span> Fixed disabled wiseprice note adding to booking when plugin not installed/used. 


<h3>Jomres 9.16.1 18/01/2019</h3>

<span class="label label-success">Feature</span> Added functionality to show new surcharges in the Show Room and Booking form pages.

<span class="label label-warning">Change</span> Added surcharge language strings to other language files.

<span class="label label-important label-danger">Fix</span> Removed test code inadvertently left in place that was causing invoices to fail to be created.


<h3>Jomres 9.16.0 15/01/2019</h3>

<span class="label label-success">Feature</span> Added bootstrap notify lib and functionality to show messages in a popup in the booking form so that they're always visible even when scrolled down.
<span class="label label-success">Feature</span> Added functionality to auto-login a user to the CMS after they are created as a registered user.
<span class="label label-success">Feature</span> Added functionality that allow property managers to create custom invoice numbers, including formatted numbers like NNN/DATE etc.
<span class="label label-success">Feature</span> Surcharges for individual rooms. This allows property managers to say that a specific room costs X extra because, for example, it's a penthouse suite or it has a particular amenity. Feature can be configured in the Edit Room page (Micromanage and Advanced tariff editing modes).

<span class="label label-warning">Change</span> Modified ui availability calendar so that from view property page we can set the start day / month / year to correspond to search options selected in the search module/widget.
<span class="label label-warning">Change</span> Modified shortcodes so that 06005 scripts can also be included.
<span class="label label-warning">Change</span> In reviews, the "cons" field is now no longer required.
<span class="label label-warning">Change</span> Tweaked new functionality to ensure that 0 prices aren't included when figuring room type price ranges.
<span class="label label-warning">Change</span> nl-NL.php file updated, thanks Coen.
<span class="label label-warning">Change</span> Tweaked save profiles script so that session data is immediately updated to use new details.
<span class="label label-warning">Change</span> Modified booking engine so that if booker is a manager, they can disable forced extras.

<span class="label label-important label-danger">Fix</span> Resolved an issue where BS2 booking form elements were untappable in small screens. Many thanks Rod for your help in tracking this little blighter down.
<span class="label label-important label-danger">Fix</span> Tweaked media centre script so that room type image upload isn't an option if it's disabled in the admin area.
<span class="label label-important label-danger">Fix</span> Tweaked temp booking handler so that carriage returns in booking engine data doesn't cause json decode to fail.
<span class="label label-important label-danger">Fix</span> Fixed an issue when is not possible to load external css or js in WP
<span class="label label-important label-danger">Fix</span> Tweaked the GDPR consent form for BS2 as it would refuse to close when consent given or denied.

<h3>Jomres 9.15.0 04/12/2018</h3>

<span class="label label-important label-danger">Fix</span> Updated upload handler to use new code that fixes unauthenticated arbitrary file upload vulnerability in Blueimp jQuery-File-Upload library

<span class="label label-success">Feature</span> Updated show property room type script to show slideshow images, and room type name and description. Repurposed an old template that had recently been abandoned to show this content.
<span class="label label-success">Feature</span> Added room type price ranges to show_property_room_types script and templates.
<span class="label label-success">Feature</span> Modified booking engine so that room type list shows room type images.
<span class="label label-success">Feature</span> Improved show_property_room_type script to use administrator entered room type title and description if it's an admin created room type
<span class="label label-success">Feature</span> Booking form classic rooms list updated to show room type images as well as room images. This helps to address an occasional request that users not be forced to upload so many images (one or more for each room) by allowing them to remove the room image markup altogether from the booking_form_classic_roomslist.html and booking_form_classic_roomslist_selected.html templates and showing just the room type image instead.
<span class="label label-success">Feature</span> Updated cron job tab to show schedule and last ran time of job.

<span class="label label-warning">Change</span> Modified room class table to allow more content in room type description.
<span class="label label-warning">Change</span> Modified rating functionality to allow the scores to be more fine-grained.
<span class="label label-warning">Change</span> Disabled a GDPR related decision as the info stored is not PII, and the optin option doesn't appear until much later.
<span class="label label-warning">Change</span> Added paths to backtrace of patTemplate to see which script is being run (could be a customised version, which the older code would not reveal)

<span class="label label-important label-danger">Fix</span> Resolved an issue where when generating multiple rooms, the last room number was re-used incorrectly.
<span class="label label-important label-danger">Fix</span> Fixed an issue with pagination and SEF (sh404SEF) urls
<span class="label label-important label-danger">Fix</span> Added booking number and booking number text to script that displays invoices.

<h3>Jomres 9.14.0 31/10/2018</h3>

<span class="label label-success">Feature</span> Added ability for guests to semi-anonymise their reviews.
<span class="label label-success">Feature</span> Added review reply feature. Managers can now respond to reviews.

<span class="label label-warning">Change</span> Updated show property room type script and show property rooms to receive room type id and filter based on those if required.
<span class="label label-warning">Change</span> Updated shortcode information for show property room type script.
<span class="label label-warning">Change</span> Modified calendar scripts to render better in small screens
<span class="label label-warning">Change</span> Show property header script updated so that the price output uses the same method as the List Properties script, because list properties can take advantage of plugins for calculating prices. Provides consistency in pricing output between the two pages.
<span class="label label-warning">Change</span> Minicomponent readme updated with webhook trigger numbers and summary.
<span class="label label-warning">Change</span> Added booking form content to $output variable in viewproperty script, and added markup to comments section of the notabs template.  {BOOKING_FORM} // Yes, that booking form. show_booking_form_in_property_details setting from Site Config needs to be set to Yes for the form to show.
<span class="label label-warning">Change</span> Added css definitions to make the date picker a bit bigger.
<span class="label label-warning">Change</span> Re-added converted price details to output price function so that value is shown in both selected and native currencies.
<span class="label label-warning">Change</span> Tweaked GDPR functionality so that if GDPR consent policies are not used, then the "given consent" method returns true every time.
<span class="label label-warning">Change</span> Tweaked booking engine so that no rooms message is not hidden.
<span class="label label-warning">Change</span> Improved a language string so that it makes sense when seen on the control panel.

<span class="label label-important label-danger">Fix</span> Improved get booking url function to ensure that the = symbol isn't santitised.
<span class="label label-important label-danger">Fix</span> Fixed an issue due to BS4 related changes where when site is set to BS2 (a rarity nowadays, as BS2 isn't as responsive as BS3) then the fullscreen view would render the Jomres Main Menu vertically instead of horizontally.
<span class="label label-important label-danger">Fix</span> Resolved an issue with a historic section of a query that's no longer relevant due to GDPR related changes. Thanks Juan.
<span class="label label-important label-danger">Fix</span> Tweaked how we find the bs version for setting up tabs in property config on older BS2 sites.
<span class="label label-important label-danger">Fix</span> Fixed an issue that preventing the system from downloading the plugin manager (a free plugin) if the license key wasn't set.

<h3>Jomres 9.13.0 12/09/2018</h3>

<span class="label label-success">Feature</span> Added functionality to allow guests to login via a modal in the booking form.
<span class="label label-success">Feature</span> Added "Edit guest" link to edit booking page.

<span class="label label-warning">Change</span> Modified jomres_properties.class.php so that on update, hyphen html entities are converted back to hyphens when saving lat/long.
<span class="label label-warning">Change</span> Removed an email check that was causing more problems then it resolved.
<span class="label label-warning">Change</span> Added output to admin area script so that if there are no reviews to see, a message is shown.
<span class="label label-warning">Change</span> Dobooking extras updated to add commented out extra description.
<span class="label label-warning">Change</span> Added a variety of J4 administrator area BS4 changes.
<span class="label label-warning">Change</span> Tweaked jr_user class to create a new guest profile record if it doesn't exist, because dashboard widgets need a row in profiles table before they can be saved as a manager's selection.
<span class="label label-warning">Change</span> Replaced spaces with tabs. Seriously, what lunatic wants spaces everywhere? Tabs FTW.
<span class="label label-warning">Change</span> Tweaked sanity check to not show reviews nag on dobooking or confirmbooking tasks.
<span class="label label-warning">Change</span> Added a functions_exists check in one of the filters in case a user somehow manages to include the filter script twice.
<span class="label label-warning">Change</span> Added whatsapp link to property header template that will only show on mobile devices.
<span class="label label-warning">Change</span> Added a check to jomres_reviews.class.php to ensure that we only attempt to log a contract uid if it's actually set.
<span class="label label-warning">Change</span> Tweaked where the Store booking details process is triggered during handlereq phase.
<span class="label label-warning">Change</span> Tweaked view invoice script so that non-booking invoices can always be viewed by managers.
<span class="label label-warning">Change</span> Added Balance payments supported flag as TRUE if it's an admin area configured payments plugin. Not sure how that will impact 3rd party plugins, however.
<span class="label label-warning">Change</span> Added functionality that should release requested rooms when a previously unlogged in user logs in.
<span class="label label-warning">Change</span> Tweaked cms specific urls in J to adopt the itemId when passed
<span class="label label-warning">Change</span> Tweaked a class to adjust to new constant names for property details.

<span class="label label-important label-danger">Fix</span> Tweaked how admin area review approval works so that the publish/unpublish icon changes correctly.
<span class="label label-important label-danger">Fix</span> Fixed a couple of notice triggers in roomlocks class.
<span class="label label-important label-danger">Fix</span> Modified add service to bill functionality to ensure that negative figures are safely added instead of being sanitised, as blunt force trauma to bills isn't nice :(
<span class="label label-important label-danger">Fix</span> Resolved an issue where widgets cannot be loaded if property manager has not yet saved their account details.
<span class="label label-important label-danger">Fix</span> Fixed an issue where the wrong table name was used after previous GDPR related changes.
<span class="label label-important label-danger">Fix</span> Resolved an issue when pulling existing guest data from the database in the booking form.
<span class="label label-important label-danger">Fix</span> Resolved an issue where guest name filters wouldn't work post GDPR changes.
<span class="label label-important label-danger">Fix</span> Tweaked functionality that was preventing existing guests from updating their data to the profiles table when creating a new booking.


<h3>Jomres 9.12.0 02/07/2018</h3>

<span class="label label-success">Feature</span> Added feature to allow property managers to create room types in the frontend. A new setting in Site Config > Misc tab allows managers to enable/disable this setting. Another new setting in the same place allows site administrators to decide if these room types should show in search dropdown fields. This is an oft-requested feature that I am confident will be very popular.
<span class="label label-success">Feature</span> Added functionality to easily hook in machine learning plugins to automagically translate Jomres language strings. A new DeepL Jomres plugin will be available in the plugin manager.

<span class="label label-warning">Change</span> Modified jomreslanguage class so that arbitrary names can be set and javascript not used.
<span class="label label-warning">Change</span> Forced to modify how custom text strings are stored for property name, address and description texts. The older style, without the property uid, caused global strings that would overwrite property names, descriptions etc when machine translation is used.
<span class="label label-warning">Change</span> Modified how Advanced tariff names are pulled from the db, fixes an issue where tariff names are not shown in Advanced mode.
<span class="label label-warning">Change</span> Added functionality to convert old style property details content text from definitions such as _JOMRES_CUSTOMTEXT_PROPERTY_NAME to the more recent _JOMRES_CUSTOMTEXT_PROPERTY_NAME_X This has been done so that machine translation of strings doesn't force global text strings in the custom text field for property details content.
<span class="label label-warning">Change</span> Added a new note to the timeline modal popup regarding re-using email addresses.

<span class="label label-important label-danger">Fix</span> Removed a reference to a database column that should no longer have existed.
<span class="label label-important label-danger">Fix</span> Fixed consent form wrapper to improve scrolling of modal in BS2 templates.
<span class="label label-important label-danger">Fix</span> Tweaked some code because blockui being triggered when gdpr functionality is disabled.
<span class="label label-important label-danger">Fix</span> Resolved an issue with hyphens being set incorrectly when editing properties and using the default lat/long settings.

<h3>Jomres 9.11.2 13/06/2018</h3>

<span class="label label-warning">Change</span> Added code to the webhook watcher script to try to find a super property manager's id if we cannot find a normal manager's id for a property.
<span class="label label-warning">Change</span> Changed how we find a reviewer's name so that manager created reviews (which personally I dislike, but some users love) also show the correct name. Saves a query too.
<span class="label label-warning">Change</span> Use of "secret" in cron tasks removed. It's not necessary and is unreliable.
<span class="label label-warning">Change</span> README.md updated with access level notes
<span class="label label-warning">Change</span> Added a sanity check for ZipArchive
<span class="label label-warning">Change</span> Modified webhook functionality so that it can handle webhooks where no manager id is set.
<span class="label label-warning">Change</span> nl-NL.php language file fully updated, thanks Ruud.

<span class="label label-important label-danger">Fix</span> Added jr_import('jomres_encryption'); to show_property_reviews script
<span class="label label-important label-danger">Fix</span> Modified media centre handler so that if 'undefined' is passed by a hinky browser, the resource id is set to 0.
<span class="label label-important label-danger">Fix</span> Resolved a bug with new GDPR related functionality that could cause 500 errors in obscure ways when making bookings.
<span class="label label-important label-danger">Fix</span> Fixed a bug in new GDPR related functionality that prevented us from building the existing guests dropdown in the booking form.
<span class="label label-important label-danger">Fix</span> Improved the BS2 modal so that it plays nice with the other elements of the page.
<span class="label label-important label-danger">Fix</span> Removed port from function that finds the current url.


<h3>Jomres 9.11.1 30/05/2018</h3>

<span class="label label-warning">Change</span> Tweaked bs2 gdpr consent form so that it opens in a modal like bs3.
<span class="label label-important label-danger">Fix</span> GDPR consent improved to trigger in booking form, removes consent bar. BlockUI used to disable the booking form until consent given.

<span class="label label-important label-danger">Fix</span> Tweaked how lat/long details are found as new input filtering to defend against http://georgemauer.net/2017/10/07/csv-injection.html borks some lat/long settings in property details.
<span class="label label-important label-danger">Fix</span> Added some str_replace's to unmangle + symbols that have been converted to html entities too early. Ensures that + symbols sent in the booking form are not listed as real + symbols in the guest list (csv threat for spreadsheets)
<span class="label label-important label-danger">Fix</span> Added headers to Guzzle call to self when triggering deferred (asynchronous) tasks in Jomres. Recently beds24 users had reported that automatic notifications to Beds24 had not been being sent, but manual notifications had worked. Analysis of logs had shown error reports of 403 from the webserver, which we suspected was being returned by mod_security. It looks like a new mod_security rule has been introduced recently which has caused it. Setting the headers in Guzzle resolves it for at least one user.

<h3>Jomres 9.11.0 21/05/2018</h3>

<span class="label label-success">Feature</span> Jomres updated to be compliant with the GDPR
<span class="label label-success">Feature</span> GDPR compliant guest data encryption added
<span class="label label-success">Feature</span> System modified so that it always creates new users on booking. This allows us to be GDPR compliant because then they can be traced to a login and their details removed.
<span class="label label-success">Feature</span> Functionality updated so that invoice buyers and sellers details are encrypted.
<span class="label label-success">Feature</span> System modified so that the "Create new user on booking" feature is automatically set to Yes and cannot be unset. This allows us to unambiguously tie invoices to CMS users, and it ensures that the guests can request that their details be removed by logging in. New tables added so that invoice buyer's and seller's details are captured at the time of the invoice creation so regardless of how their details are changed at a later date, the information required for an invoice is securely and immutably stored and records both the buyer and the seller's details as they were presented at that time.
<span class="label label-success">Feature</span> Added scripts to convert existing invoice PII to encoded data using the jrportal_invoices class
<span class="label label-success">Feature</span> Added functionality that will convert existing invoices into encoded data during upgrade.
<span class="label label-success">Feature</span> Added a cron job to delete booking data archive details over 60 days old to be GDPR compliant
<span class="label label-success">Feature</span> GDPR automatic booking and invoice deletion functionality added. Managers can configure how long it is until a booking's rows are deleted from the database, including PII and invoice related rows. Typically a year. Non-booking invoices are treated differently, for example in Germany invoices should be retained for 10 years therefore invoices (such as commission or subscription invoices), which are not related to a booking, can be retained for much longer if required.
<span class="label label-success">Feature</span> Added gdpr consent form(s). Added optin table. Renamed cron job so that it's run last. Added gdpr optin consent class. This functionality, among other things, describes the data that is stored in the Jomres section of the website and allows visitors to opt-in or out.
<span class="label label-success">Feature</span> Added GDPR compliant consent handling. Blocked users who have not consented from viewing booking form, login, registration and various other pages.
<span class="label label-success">Feature</span> Provided a form to give feedback for users who have not given consent and gives them the option to change permissions.
<span class="label label-success">Feature</span> Made consent form show in modal on BS3 & BS4
<span class="label label-success">Feature</span> Prevented the system from storing IP number and location information when consent not received or consent explicitly forbidden.
<span class="label label-success">Feature</span> Added menu option to access consent form
<span class="label label-success">Feature</span> Added functionality to allow users to view the GDPR my data page, download said data as JSON, and delete own data.
<span class="label label-success">Feature</span> Added functionality to allow site admins to redact/anonymise guest data.
<span class="label label-success">Feature</span> Added switch to allow site admins to disable GDPR functionality. When the GDPR functionality is disabled, users are automatically opted-in to their data being collected.
<span class="label label-success">Feature</span> Added "empty temp dir" tool to tools area.
<span class="label label-success">Feature</span> Added logging to cron jobs so that if secret keys used are incorrect then this will appear in the Core application log. Could be the cause of some people's session tables getting too large.

<span class="label label-warning">Change</span> Run legacy db tables updates too when checking db integrity
<span class="label label-warning">Change</span> Added nl2br to video tutorial descriptions because some of them benefit from being longer.
<span class="label label-warning">Change</span> Modified dobooking.php so that it can accept dates presented with hyphens
<span class="label label-warning">Change</span> Improved cms plugin installers to double check if jomres dir is writable.
<span class="label label-warning">Change</span> Showplugins updated so that if plugin manager wasn't updated properly and registry rebuilt, we will catch that.
<span class="label label-warning">Change</span> Improved Joomla cms plugin installer for J4 compatibility
<span class="label label-warning">Change</span> Modified defaults so that conversion feature is off until it is enabled, and prices inclusive option is on by default.
<span class="label label-warning">Change</span> Implemented hardening against potential CSV inject attacks ( http://georgemauer.net/2017/10/07/csv-injection.html )
<span class="label label-warning">Change</span> Clean temp js files when rebuilding registry on install/upgrade too.
<span class="label label-warning">Change</span> Added a safe mode warning to cpanel because.....Rod.
<span class="label label-warning">Change</span> Added support to access control feature to control property settings tabs too.
<span class="label label-warning">Change</span> Property managers now no longer able to set the Email field to an optional field in the booking form.
<span class="label label-warning">Change</span> Modified how secret passed to cron jobs is decoded as strict input filtering is not required ( as it's not stored ) and new CSV protection functionality borks the = symbol during input filtering.
<span class="label label-warning">Change</span> Added code to empty the sessions directory if session handler is database in session cleanup script
<span class="label label-warning">Change</span> Modified booking engine so that invalid email addresses (e.g. because it has been anonymised ) trigger a redirect to the edit account page, if the user is registered but not a manager.
<span class="label label-warning">Change</span> Obsoleted nusoap library, adopted php native soap (for calling VIES to get vat number validity)
<span class="label label-warning">Change</span> Tweaked output prices so that if arrival and departure dates are the same, then in property lists the date span is reset to 1 for the purpose of calculating output prices displayed in lists.
<span class="label label-warning">Change</span> Tweaked how override contact numbers are parsed before output to refactor sanitised + symbols
<span class="label label-warning">Change</span> Modified data available to the show property reviews template, instead of outputting username ( which is now always their email address ) instead we will output their full name.

<span class="label label-important label-danger">Fix</span> List bookings ajax and list invoices ajax modified to ensure that they do not try to convert prices because the conversion on valid prices results in incorrect prices.
<span class="label label-important label-danger">Fix</span> Solved a problem with extra names not being translated in contract details
<span class="label label-important label-danger">Fix</span> Fixed an issue where newly created users who have filled their profile details, their details were not copied to the session

<h3>Jomres 9.10.2 27/03/2018</h3>

<span class="label label-warning">Change</span> Removed singleton specific code from all classes that don`t need it. There is only one singleton in Jomres, jomres_singleton_abstract class and this is the container for all other classes instances.
<span class="label label-warning">Change</span> Deferred tasks modified to use Guzzle.
<span class="label label-warning">Change</span> Added setting to change token lifetime.
<span class="label label-warning">Change</span> Added database update script to remove old tokens.
<span class="label label-warning">Change</span> Added the ability to pre-filter room types in the booking form.
<span class="label label-warning">Change</span> Added support for the availability calendar to use the week start day setting.
<span class="label label-warning">Change</span> Improved jquery ui availability calendar css.
<span class="label label-warning">Change</span> Improved how we check if Jomres is installed. If db tables are created but no properties exist, we`ll consider that Jomres is not properly installed and execute the installation routine.
<span class="label label-warning">Change</span> Modified the create multiple room script so that maximum rooms are now 1000 and max guests are 100.

<span class="label label-important label-danger">Fix</span> Several language files updated to show correct link to email template editing page in manual.
<span class="label label-important label-danger">Fix</span> Fixed an issue with a couple of dots too many, thanks kopfnuss.
<span class="label label-important label-danger">Fix</span> Resolved an issue where token not deleted when client deleted.
<span class="label label-important label-danger">Fix</span> Solved a problem with fixed arrival days in property details jquery ui calendar not showing colours.
<span class="label label-important label-danger">Fix</span> Fixed a bug that prevented new property features to be created.
<span class="label label-important label-danger">Fix</span> Solved a problem with redirects on update.
<span class="label label-important label-danger">Fix</span> Solved a notice in label translations.

<h3>Jomres 9.10.1 14/03/2018</h3>

<span class="label label-important label-danger">Fix</span> Fixed a bug in the new installer that didn't come to light until after testing.


<h3>Jomres 9.10.0 14/03/2018</h3>

<span class="label label-success">Feature</span> Installation process completely rewritten and modernised.
<span class="label label-success">Feature</span> Added a feature where property managers can elect to hide the property street from display to normal users. Users who have created a booking for that property can see the full address details.
<span class="label label-success">Feature</span> Added availability calendar modal to SRP properties booking form too
<span class="label label-success">Feature</span> Added support for downloading Nightly builds.


<span class="label label-warning">Change</span> Modified list properties so that EDIT_LINK could be added to list properties output for managers to quickly edit a property.
<span class="label label-warning">Change</span> Updated booking form to honour the "do not show inline calendars" setting from property config > property details tab.
<span class="label label-warning">Change</span> Added code to detect that Jomres has been moved to a new server and rebuild the registry.
<span class="label label-warning">Change</span> Tweaked frontend nag so that it doesn't show up if is an ajax call.
<span class="label label-warning">Change</span> Modified ui availability calendar so that if fixed arrival day setting is used then other days will not be clickable.
<span class="label label-warning">Change</span> Both MRP and SRP calendars updated so that bookable dates are highlighted, and other dates disabled, when fixed day of week booking set.
<span class="label label-warning">Change</span> Modified date input feature for search modules so that if site is set to a single property installation then the first published property has it's settings used and if fixed arrival day is set to Yes then to set the search module's calendar to disable other days.
<span class="label label-warning">Change</span> Extended POA price feature to show in lists.
<span class="label label-warning">Change</span> Updated the jquery ui themes path
<span class="label label-warning">Change</span> pt-PT datepicker code updated
<span class="label label-warning">Change</span> Added jquery chained js back to jomres assets
<span class="label label-warning">Change</span> Added an experimental feature to optimize images for the web on upload.
<span class="label label-warning">Change</span> Custom flight methods updated to add "exit"s after the response has been sent.
<span class="label label-warning">Change</span> Added functionality that allows PUT requests through the API to behave like POST requests.
<span class="label label-warning">Change</span> Added functionality to allow downloading of development versions of Jomres thru the CMS in future versions (currently Joomla only)
<span class="label label-warning">Change</span> Added detection of Joomla debugging setting, which allows installation of development versions of Jomres onto new installations of Joomla.
<span class="label label-warning">Change</span> Removed a script that shows license failures in the frontend. No longer needed now that the plugin manager is ioncube encoded for subscriptions.
<span class="label label-warning">Change</span> Added a check for a missing class which can sometimes trip users up when moving installations to a new server.
<span class="label label-warning">Change</span> Added translation support for datatables Column Visibility button.


<span class="label label-important label-danger">Fix</span> Solved a problem with media centre existing images that don`t have thumbnails created.
<span class="label label-important label-danger">Fix</span> Resolved an issue where reviews would not save in test mode.
<span class="label label-important label-danger">Fix</span> Solved a problem where personal guest discounts were not reflected on invoices.
<span class="label label-important label-danger">Fix</span> Added jquery chained js back to jomres assets.
<span class="label label-important label-danger">Fix</span> Solved a problem with short language codes.
<span class="label label-important label-danger">Fix</span> Updated the jquery ui themes path.
<span class="label label-important label-danger">Fix</span> Solved a problem with charts selection when sef enabled.
<span class="label label-important label-danger">Fix</span> Modified a string in the French language file as the single quote causes problems with booking notes table when a guest is booked out.
<span class="label label-important label-danger">Fix</span> Modified the core showplugin script to ensure that it passes the php version, without it the wrong encoded version of the plugin manager was being returned.

<h3>Jomres 9.9.19 24/01/2018</h3>

<span class="label label-success">Feature</span> Added a new feature to copy booking emails sent to property managers to site admins too. Setting can be found in Site Configuration -> Booking Form tab.

<span class="label label-warning">Change</span> Updated dependencies

<span class="label label-important label-danger">Fix</span> Installer updated to cope with mysql installations that mangle table name cases.
<span class="label label-important label-danger">Fix</span> Solved a notice in integration.php

<h3>Jomres 9.9.18 22/01/2018</h3>


<span class="label label-success">Feature</span> Added a new setting to Tariffs and Currencies tab which allows property managers to save a basic price that would be shown if no prices can otherwise be determined. When properties are shown in a list, the system will attempt to find a valid price from configured tariffs based on either today's date, or if dates were used in a search, then based on those dates. If it cannot, then it will show POA (Price on application), meaning that the guest should contact you to get a price. If you want, you can configure a price here that will be shown instead of the POA text. This figure would be a "fallback" price to display if no other price can be determined.
<span class="label label-success">Feature</span> Updated a feature that allows you to include a script's output in a template without modifing the calling script's corresponding minicomponent.
<span class="label label-success">Feature</span> Updated template override functionality to 1. Allow templates to reside in /plugin_name/templates/bootstrapN/ directories as well as the plugin's root and 2. Allow template overrides to have property type overrides underneath /plugin_name/templates/bootstrapN/, such as /plugin_name/templates/bootstrapN/P where P is the property type id.
<span class="label label-success">Feature</span> Added a feature whereby property features can be configured to not show in search lists.
<span class="label label-success">Feature</span> Moved all jomres core js, css, images, templates and map_styles to /assets dir and updated all paths accordingly. This begins the process of preparing for Joomla 4 and Bootstrap 4.
<span class="label label-success">Feature</span> Most javascript files are now managed via npm ( npm is the package manager for JavaScript ). Results in a larger footprint, but libraries are updated regularly.

<span class="label label-warning">Change</span> Modified how we get the site url. The previous function used would not return https as the protocol part of the url, even if the site was being accessed via https ( so far this has only appeared on wpengine ) which resulted in weird behaviour like being unable to save the license key. Changing the function fixes this.
<span class="label label-warning">Change</span> Instead of relying on the monolog library, added code to the logging class to create logging directories where required.
<span class="label label-warning">Change</span> Tweaked dobooking.php to adjust how we can hand off the property uid to the booking engine.
<span class="label label-warning">Change</span> Updated datatables for jquery 3, joomla 4 only
<span class="label label-warning">Change</span> Added functionality that forces a re-installation the Jomres plugin manager. Without this upgraders will need to manually update 40 or so (to date) updated plugins for .18, which would be tiresome for users and result in lots of tickets.
<span class="label label-warning">Change</span> Tweaked image urls to use relative path without domain to increase speed
<span class="label label-warning">Change</span> Added a new trigger point to add settings from plugins to debugging tab

<span class="label label-important label-danger">Fix</span> Fixed some notices caused by deleted cms users that have reviews posted or are still set as partners in jomres
<span class="label label-important label-danger">Fix</span> Solved a problem with how percentage extra prices are displayed in property details

<h3>Jomres 9.9.17 12/12/2017</h3>

<span class="label label-warning">Change</span> Added cancellation reason output support to booking email templates
<span class="label label-warning">Change</span> basic_contract_details class updated to include last_changed and referrer db columns.
<span class="label label-warning">Change</span> Improved redirect url handling to base64 encode urls. Without encoding urls, redirect url tasks are treated as the real task, causing tariff exporting functionality in the Beds24 plugin to not work.

<span class="label label-warning">Change</span> Fixed a link in emails
<span class="label label-warning">Change</span> Fixed a notice in property list triggered when the budget feature is disabled
<span class="label label-warning">Change</span> Solved a problem with searched dates always being reset on the booking form
<span class="label label-warning">Change</span> Solved a problem with guest types when amending bookings

<h3>Jomres 9.9.16 20/11/2017</h3>

<span class="label label-success">Feature</span> Added room names and numbers to Amend Booking panel in booking form when editing a booking.
<span class="label label-success">Feature</span> Added functionality to allow payment gateways to pass transaction ids and payment methods to invoice line items.
<span class="label label-success">Feature</span> Email Admin when Jomres has a New Update

<span class="label label-warning">Change</span> Made the version check a cron job
<span class="label label-warning">Change</span> Removed a depreciated setting from jomres_config.php
<span class="label label-warning">Change</span> Added PROPERTY_NAME_FULL to property list templates.
<span class="label label-warning">Change</span> Small improvement when detecting the localhost ip
<span class="label label-warning">Change</span> Added ability to add extra information to developer output on fatal error, and added query details to jomres_database.class.php
<span class="label label-warning">Change</span> Moved where the 00015 trigger point is fired in viewproperty script.
<span class="label label-warning">Change</span> Added ability to pass "redirect_url" in $_REQUEST and let jomresRedirect function use that instead of the url passed by the calling method.
<span class="label label-warning">Change</span> Added support for displaying transaction id and gateway in admin invoices too, plus some minor layout tweaks
<span class="label label-warning">Change</span> Removed an unneeded global in the en-GB language file
<span class="label label-warning">Change</span> Modified the link to the max input vars explanation page to point to a new page in the manual.
<span class="label label-warning">Change</span> Added a button to close the jomres review message that shows up in admin cpanel
<span class="label label-warning">Change</span> Removed a require in logging class that's no longer needed.
<span class="label label-warning">Change</span> Improved logging of missing classes caused sometimes by incomplete updates
<span class="label label-warning">Change</span> Moved where we check if the request is an ajax call in integration.php

<span class="label label-important label-danger">Fix</span> Fixed a notice in view booking page caused by deleting guest types
<span class="label label-important label-danger">Fix</span> Resolved a notice in booking insert regarding channel_manager_booking flag.


<h3>Jomres 9.9.15 06/11/2017</h3>

<span class="label label-warning">Change</span> Added a flag to mark if a booking is from a channel manager or not. Depending on this, the commission plugin will add or not add the booking commission line item to the unissued invoice.
<span class="label label-warning">Change</span> Changed how balance is calculated in booking emails. Only calculate balance if deposit was paid. If not, the full amount is the balance.
<span class="label label-warning">Change</span> Improved rooms dropdown in media centre to include room type too, beside room name and number
<span class="label label-warning">Change</span> Added a default value for channel_manager_booking in the temp booking handler.
<span class="label label-warning">Change</span> Added a warning to the showplugins script to alert if the zipArchive extension is not installed in PHP
<span class="label label-warning">Change</span> Changed what happens after the key is saved by the auto installer. Forces the license cache file to be updated more quickly.
<span class="label label-warning">Change</span> Modified how guest type numbers are retrieved when editing a booking.
<span class="label label-warning">Change</span> Tweaked a backtrace to provide more information.
<span class="label label-warning">Change</span> Better sanitize the uploaded images filenames
<span class="label label-warning">Change</span> Renamed shortcode_parser class to jomres_shortcode_parser to avoid naming conflicts with 3rd party wp plugins
<span class="label label-warning">Change</span> Removed 3 obsolete classes
<span class="label label-warning">Change</span> Added automatic cleanup on uninstall functionality.
<span class="label label-warning">Change</span> Added review request to admin control panel.

<span class="label label-important label-danger">Fix</span> Fixed an issue where autoloader wasn't being called by api
<span class="label label-important label-danger">Fix</span> Fixed an incorrect path that prevented the authorisation url for oauth authorisation requests
<span class="label label-important label-danger">Fix</span> Solved a problem with map height not being applied properly
<span class="label label-important label-danger">Fix</span> Creative way to catch errors related to classes that don`t exist anymore, for example when upgrading Jomres, so they won`t throw a fatal error anymore and allow updating. Composer update done too.
<span class="label label-important label-danger">Fix</span> Solved a problem with joomla menu item urls which had duplicated ? sign.
<span class="label label-important label-danger">Fix</span> Solved a problem related to duplicate last minute discount on invoices.

<h3>Jomres 9.9.14 10/10/2017</h3>

<span class="label label-warning">Change</span> Implemented new code that allows site admins to register trial license keys through the administrator area.
<span class="label label-warning">Change</span> Removed api vendor dir as now all api libraries are included in the core
<span class="label label-warning">Change</span> Added property publish method to jomres properties class. Improved property config so that we won`t get all property configs from db, but just the configs for the properties we need

<span class="label label-important label-danger">Fix</span> Solved a partner discount incorrect amount on invoices
<span class="label label-important label-danger">Fix</span> Improved installer to remove duplicate records from jomres custom text table and after that add a unique index to prevent future duplicates.

<h3>Jomres 9.9.13 29/09/2017</h3>

<span class="label label-important label-danger">Fix</span> Fixed an issue when creating new Joomla users in J! 3.8  Thanks Rod.
<span class="label label-important label-danger">Fix</span> Solved a bug on fresh installs which prevented the proper creation of guest profiles table
<span class="label label-important label-danger">Fix</span> Solved a problem with default value of language_context on fresh installs
<span class="label label-important label-danger">Fix</span> Solved a problem in jomres settings table which prevented an index being created because the akey column length was higher than 1000 bytes, so changed the akey column length to varchar(100). Should be more than enough for any setting name.

<h3>Jomres 9.9.12 27/09/2017</h3>

<span class="label label-warning">Change</span> Flight library moved to top level vendor directory
<span class="label label-warning">Change</span> manager_properties_none.html updated to produce output to advise user to use a different property manager for webhooks.
<span class="label label-warning">Change</span> Plugin images re-added to plugin list as they're now (mostly) on an ssl enabled server.
<span class="label label-warning">Change</span> Added an option to property types to set if this property type allows stars classification or not. Depending on this, the stars input will be shown/not shown in edit property page.
<span class="label label-warning">Change</span> Added BOOKING_LENGTH output to emails (number of days/nights)

<span class="label label-important label-danger">Fix</span> Modified api, a change to dependencies broke the api's ability to find the http_build_url function that was recently moved.
<span class="label label-important label-danger">Fix</span> When amending a booking from dashboard, check availability even if this is just a room switch. It may happen that the currently checked in guest with a departure overdue may not be in the current view. Thanks Jad Makhlouta for pointing this out.
<span class="label label-important label-danger">Fix</span> Return empty array if no custom fields are available for this property type id
<span class="label label-important label-danger">Fix</span> Removed output_filters function override because we use that function even before the 00001 trigger point


<h3>Jomres 9.9.11 19/09/2017</h3>

<span class="label label-warning">Change</span> Changed where we trigger 00001
<span class="label label-warning">Change</span> Improved how we pass the selected number of guests from search modules to the first guest type dropdown on the booking form
<span class="label label-warning">Change</span> Added http_build_url class to dependencies
<span class="label label-warning">Change</span> Jomres cron jobs will also be triggered when needed on non jomres specific pages that have jomres plugins as modules/widgets.
<span class="label label-warning">Change</span> Improved how we get the property details url on Joomla when we have a specific Joomla menu item for a property.
<span class="label label-warning">Change</span> Price output function modified to use and display only 2 decimals
<span class="label label-warning">Change</span> Sort images by filename when getting their details from db
<span class="label label-warning">Change</span> Only show video tutorials in frontend if using bootstrap templates
<span class="label label-warning">Change</span> Modified how guest cancellations are performed so that they're using a standard class, and ensure that the webhook is triggered.

<span class="label label-important label-danger">Fix</span> Resolved an issue in Joomla 3.8 caused by changes to Joomla's version file that would prevent Jomres from working.
<span class="label label-important label-danger">Fix</span> Solved a problem with property details sef urls in emails (joomla only)
<span class="label label-important label-danger">Fix</span> Solved a problem with properties being displayed twice in list properties tables
<span class="label label-important label-danger">Fix</span> Solved a recaptcha problem on contact form. Removed recaptha v1 code as the lib was removed previously anyway.
<span class="label label-important label-danger">Fix</span> Solved a problem with html purifier stripping down all html in strong mode, including the allowed html tags
<span class="label label-important label-danger">Fix</span> Removed a blank space after user and pass in new user email
<span class="label label-important label-danger">Fix</span> Fixed an issue with description search returning wrong results due a missing property_ors in the 2nd query.
<span class="label label-important label-danger">Fix</span> Solved a problem with existing room descriptions not being updated for the currently active language.


<h3>Jomres 9.9.10 31/08/2017</h3>

<span class="label label-warning">Change</span> Changed how we upload user profile images to make it consistent with media centre uploads, so we can use db image details, s3 and cloudfront integrations. Existing user images need to be reuploaded. Added support for adding hidden media centre resources that can be used internally and don`t show up in media centre dropdowns. First use for this is user images.
<span class="label label-warning">Change</span> Modified feedback message handling so that it also uses redirect messages.
<span class="label label-warning">Change</span> Changed position of the user feedback div in admin area
<span class="label label-warning">Change</span> Broke user initialisation into own method as we need a way to re-initialise a user programatically sometimes.
<span class="label label-warning">Change</span> Modified 99994 trigger so that all  99994 triggers are called after redirection not just one specific webhook trigger.
<span class="label label-warning">Change</span> Improved the jomres_properties class to ensure that created properties custom text always uses the newly created property uid.
<span class="label label-warning">Change</span> Fixed a bug in new category searching functionality

<span class="label label-important label-danger">Fix</span> Solved a problem related to duplicate coupon discount on invoices
<span class="label label-important label-danger">Fix</span> Solved a problem related to widget selector showing up on search results pages
<span class="label label-important label-danger">Fix</span> Fixed a typo that was preventing some deferred tasks from running
<span class="label label-important label-danger">Fix</span> Added missing property categories output in bootstrap 2 and jquery ui templates
<span class="label label-important label-danger">Fix</span> Solved a problem in the installer related to language context default value

<h3>Jomres 9.9.9 21/08/2017</h3>

<span class="label label-success">Feature</span> Added support for property categories. This is a simple feature that allows managers to create property categories, which can then be added as both menu options to Joomla, or added as shortcodes to articles/pages in both Joomla and Wordpress.
<span class="label label-success">Feature</span> Added changes to allow us to have global coupon codes (created by site admins) that apply to all properties.
<span class="label label-success">Feature</span> Added a minimum deposit value setting to property configuration. If the deposit calculated is less than N figure, then the N figure is used to define the deposit.
<span class="label label-success">Feature</span> Added the language context feature to language file translation page in jomres admin cpanel. This way we can have property type specific language strings, without needing to have property type specific language files (which are mostly duplicate language strings, very few really different). Everything is stored in db, so it`s upgrade safe.
<span class="label label-success">Feature</span> Added support to save media centre image details in db to avoid scanning dirs each time a page loads to find all images.
<span class="label label-success">Feature</span> Added Amazon S3 and CloudFront integration for images.
 
<span class="label label-warning">Change</span> Invoice webhooks updated
<span class="label label-warning">Change</span> Added support to view only invoice line items and transactions, will be used later.
<span class="label label-warning">Change</span> Added a constant for jomres core-minicomponents dir
<span class="label label-warning">Change</span> Don`t show delete property menu item if this manager has access only to one property
<span class="label label-warning">Change</span> Added deposit ref to deposit line item on invoices
<span class="label label-warning">Change</span> Added a new administrator area video showing property creation, to help new users understand that they need to log into the frontend.
<span class="label label-warning">Change</span> Added support for composer and autoloading external libraries
<span class="label label-warning">Change</span> Removed adodb and used php date and mktime functions. Added monolog to dependencies
<span class="label label-warning">Change</span> Added a define for the updates path
<span class="label label-warning">Change</span> Added a jomres class that checks availability for dates and room uids
<span class="label label-warning">Change</span> Added a new generic black booking insert class
<span class="label label-warning">Change</span> Added a new ical import library
<span class="label label-warning">Change</span> Removed some unneeded cache files
<span class="label label-warning">Change</span> Tweaked sockets timeouts because we don`t need to wait too long for a response
<span class="label label-warning">Change</span> Removed a specific check for classes in custom_code dir, as that dir is already available in the classes registry
<span class="label label-warning">Change</span> Added cpanel task to excluded tasks in access control, as this is the cpanel default frontpage
<span class="label label-warning">Change</span> Removed property type specific language files. Now we can have property type specific language strings saved in db, so no need to duplicate an entire file for each property type.
<span class="label label-warning">Change</span> Added property categories tutorial video
<span class="label label-warning">Change</span> Added Armenian language file to system. Thanks Hamlet.
<span class="label label-warning">Change</span> Removed the unused bootstrap-tour js files
<span class="label label-warning">Change</span> Disabled image rotation based on exif meta data
<span class="label label-warning">Change</span> Added feature to allow devs to rerun the plugin installer script without needing to reinstall a plugin. Useful when creating plugins and you want to recreate database tables.
<span class="label label-warning">Change</span> Removed some unused options (component wrapped) and cleaned up code
<span class="label label-warning">Change</span> Added video tutorials to BS2 top.html.
<span class="label label-warning">Change</span> Updated css so that the video tutorials button would stand out more as even some of our more regular users had failed to see that it exists.
<span class="label label-warning">Change</span> Added an ioncube version test to plugin manager installer.

<span class="label label-important label-danger">Fix</span> Fixed an issue where the guest's cancel booking button text would not appear.
<span class="label label-important label-danger">Fix</span> Solved a problem that`s sometimes encountered with jintour properties and coupons
<span class="label label-important label-danger">Fix</span> Solved some bugs that prevented subscriptions being updated properly
<span class="label label-important label-danger">Fix</span> Fixed how coupons are displayed in price summary, tax was added on top of the discount.
<span class="label label-important label-danger">Fix</span> Solved a js error when we drag an event to cancel it and cancellation can`t be made
<span class="label label-important label-danger">Fix</span> Fixed an issue that prevented us from moving bookings to another property. Seems there was a bug in place in some code since before 2009 (!). Thanks Jad

<h3>Jomres 9.9.8 31/07/2017</h3>

<span class="label label-success">Feature</span> Property Completion highlighting. Properties that have been completed ( IE prices updated, images uploaded etc ) are now highlighted to site administrations that they're now ready for approval ( if the feature is enabled ). Similar highlighting added to frontend property lists so that property managers can see those properties that are still awaiting completion.
<span class="label label-success">Feature</span> Context sensitive video tutorials added to system, both administrator area and frontend. Videos are done without voice-overs or text so that they are largely language agnostic, language file can be copied and edited by site admins if required for other languages.

<span class="label label-warning">Change</span> Repurposed an old setting to use it to disable avl calendars in property details
<span class="label label-warning">Change</span> Made property list default to paging instead of live scrolling
<span class="label label-warning">Change</span> Undone a previous change which makes label translations save the xx language shortcode instead of xx-XX language code, causing translated text not to be pulled from db when selecting by xx-XX language code.
<span class="label label-warning">Change</span> Sanity check messages will be displayed on all pages, without excepted tasks
<span class="label label-warning">Change</span> Removed some unimportant warnings from administrator area.
<span class="label label-warning">Change</span> Cleanup up some unneeded notices, clarified the license status messages and added action buttons
<span class="label label-warning">Change</span> If IPInfoDB api key is not set, we`ll not default to EUR anymore, instead we`ll default to the currency set in site configuration.
<span class="label label-warning">Change</span> Removed the simple/advanced config toggle, not very popular as folks seem to miss the advanced settings in property configuration. 
<span class="label label-warning">Change</span> Combined all map related settings in site config to one google map tab only.
<span class="label label-warning">Change</span> Made the fullscreen view available on small screens too and removed an unused setting
<span class="label label-warning">Change</span> Added shortlist/favourites shortcode.
<span class="label label-warning">Change</span> Made the FAQ a menu item in the jomres control panel help section and removed the button.

<span class="label label-important label-danger">Fix</span> Fixed a bug in how we prepare the rates and mindays arrays before creating the tariffs

<h3>Jomres 9.9.7 20/07/2017</h3>

<span class="label label-success">Feature</span> Webhooks Core and API Core moved into main application. There are a lot of ways that we can use this functionality, however having these particular two features as plugins is more of a hinderance than a help, therefore they've been moved into the core.


<span class="label label-warning">Change</span> Modified the shortcode parser so that if a class exists, don't include the file. This doesn't address any bugs in Jomres, instead it addresses the possibility of triggering an error if a developer or designer should create a fatal error by copying a minicomponent, e.g. to create a backup of a file.
<span class="label label-warning">Change</span> Updated shortcodes instructions to make sure that feature uids information is correct.
<span class="label label-warning">Change</span> Updated how Jomres Pricing information is retrieved.
<span class="label label-warning">Change</span> Added a check for filesize being zero when installing the plugin manager.
<span class="label label-warning">Change</span> Tweaked menus to not show some options if upcoming property limitations are applied.


<h3>Jomres 9.9.6 12/07/2017</h3>

<span class="label label-warning">Change</span> Our implementation of OAuth2 scripts updated to extend the lifetime of the tokens, and allow implicit token issuing.
<span class="label label-warning">Change</span> Changed property type class so that property types are retrieved in alphabetical order.
<span class="label label-warning">Change</span> Modified patErrorManager to record an error in the event of problems because it will provide us with backtracing information.
<span class="label label-warning">Change</span> Modified jomres_properties class so that new properties default room will get a basic room type, meaning that Micromanage editing mode can be used right off the bat.
<span class="label label-warning">Change</span> Tweaked an error message to clarify it's source.
<span class="label label-warning">Change</span> Added payment method as booking note.
<span class="label label-warning">Change</span> Monolog and OAuth2 libs updated.
<span class="label label-warning">Change</span> Tweaked rest api authorize controller so that if it returns an error about return urls, it tells you which url it's expecting, versus what was sent.
<span class="label label-warning">Change</span> Added support for auth free access to the REST API functionality. This feature allows us to offer additional REST API functionality that doesn't demand client id & secret keypairs, so that there are fewer barriers between your clients and your API.
<span class="label label-warning">Change</span> Made the search misc menu item visible to receptionists or above. No need for this menu to be visible to guests.
<span class="label label-warning">Change</span> Cancellation threashold now available for tour property bookings too.
<span class="label label-warning">Change</span> Removed Read More javascript functionality as it's not an elegant solution.
<span class="label label-warning">Change</span> Added Jomres price plans to main menu
<span class="label label-warning">Change</span> Renamed Upgrades to Updates. Upgrades has always been the wrong word to use in this context.
<span class="label label-warning">Change</span> Added license name to output content of Site Config license data.
<span class="label label-warning">Change</span> Exchange rates : Added a check for $json to see if it's false ( connection errors can cause this ).
<span class="label label-warning">Change</span> Updated a task in approval urls with the next task name
<span class="label label-warning">Change</span> Added a unique css class to each property that can be used to customize css for each property uid individually
<span class="label label-warning">Change</span> Updated show property map shortcode data to include map_zoom

<span class="label label-important label-danger">Fix</span> Fixed a notice in Show Plugins referring to third party plugins.
<span class="label label-important label-danger">Fix</span> Fixed notices that may appear in booking form and confirmation if an older tax rate has been deleted when building extras info.
<span class="label label-important label-danger">Fix</span> Fixed some bugs in new Norwegian language file.
<span class="label label-important label-danger">Fix</span> Solved a problem related to receptionists not being able to see the booking details
<span class="label label-important label-danger">Fix</span> Cart/booking number was being incorrectly reset to 0, so changed how it could be detected. Thanks Juan Antonio
<span class="label label-important label-danger">Fix</span> Small tweak to solve duplicate tour name in invoices
<span class="label label-important label-danger">Fix</span> Solved a problem when getting the gateways for commission and subscription invoices
<span class="label label-important label-danger">Fix</span> Solved a problem on booking page related to empty strings being handled as arrays
<span class="label label-important label-danger">Fix</span> Fixed an issue where log files might not appear in log list.
<span class="label label-important label-danger">Fix</span> Solved a property comparison problem which caused all checkboxes on the page to be checked if checked
<span class="label label-important label-danger">Fix</span> Solved a problem related to how coupon discounts are added to invoices
<span class="label label-important label-danger">Fix</span> Solved a geocoding related problem where country was always reset to DE

<span class="label label-info">Wordpress</span> Added ability for editinplace admin script to pass language to the updateCustomText function as get_showtime("lang") was reporting the wrong language.

<h3>Jomres 9.9.5 19/06/2017</h3>

<span class="label label-warning">Change</span> Huge update to Norwegian language file. Thanks Edvin.
<span class="label label-warning">Change</span> Modified an error trigger so that double booking exceptions can only be triggered by the processpayment task.
<span class="label label-warning">Change</span> Added shortcode information about the new property task. ( Jomres ASAModule mambot has also been updated to support this ).

<span class="label label-important label-danger">Fix</span> Re-added the (previously obsoleted) jomres_formatBytes function as some older automatically generated language files need it. Without it they'll throw a fatal error when users upgrade from 9.9.3 to 9.9.4


<h3>Jomres 9.9.4 13/06/2017</h3>

<span class="label label-warning">Change</span> Improved viewproperty so that if Show Only Availability calendar setting is used, then we properly use settings from Property Details configuration options.
<span class="label label-warning">Change</span> Improved edit property type script so that fallback markers are properly found and displayed.
<span class="label label-warning">Change</span> Installer modified because one of our client's firewalls 403'd when it saw >> in the POST data.
<span class="label label-warning">Change</span> Moved the town and marker uploaders to the core to simplify things
<span class="label label-warning">Change</span> Re-enabled the property type dropdown on the edit property page, folks seem to need it.
<span class="label label-warning">Change</span> Whenever the property type is changed, we`ll delete all rooms, tariffs and property settings. This also resets availability.
<span class="label label-warning">Change</span> Modified region related functionality so that if a property has an incorrect region id then the property is not returned in the search results, and it is unpublished. This is better than throwing a fatal error, and being unpublished highlights to the manager that it's not currently available. 
<span class="label label-warning">Change</span> Added a new trigger to allow plugins to add their own warnings to the Jomres Control Panel.
<span class="label label-warning">Change</span> Changed log cleanup frequency to hourly.
<span class="label label-warning">Change</span> Added functionality to allow 3rd party developers to offer links to documents that provide current version information. ( Plugin manager )
<span class="label label-warning">Change</span> Removed some very old unused functions
<span class="label label-warning">Change</span> Romanian VAT updated
<span class="label label-warning">Change</span> Improved agent details layout
<span class="label label-warning">Change</span> Timeline menu hidden for real estate properties
<span class="label label-warning">Change</span> We'll silently switch from mysql to mysqli if function doesn't exist instead of faithfully following Joomla's configuration.php file. It looks like that's what J is doing as of 3.7.x and it makes sense.
<span class="label label-warning">Change</span> Removed plugin images from plugin manager as they can point to http sites, resulting in mixed content warnings.

<span class="label label-important label-danger">Fix</span> Tweaked the initial set timeout function to be a little more friendly for shared hosting packages.
<span class="label label-important label-danger">Fix</span> Notice fixes
<span class="label label-important label-danger">Fix</span> Removed some redundant code which caused an error when paying for approved bookings
<span class="label label-important label-danger">Fix</span> Removed a slash which was breaking property feature tooltip images in basic search modules.
<span class="label label-important label-danger">Fix</span> Solved a booking form error by removing some redundant code.
<span class="label label-important label-danger">Fix</span> Guest types class updated to allow float values in the Variance field ( used to, new class was incorrect ).

<h3>Jomres 9.9.3 01/06/2017</h3>

<span class="label label-important label-danger">Fix</span> We disabled the dropdown to choose property types in the previous version. In the past, regardless of whether or not the dropdown was disabled, the value of the dropdown would still be sent by the browser. It would appear that current versions of browsers no longer send the content of that dropdown, which triggers an error when saving any property.
<span class="label label-important label-danger">Fix</span> Fixed notices in weekly occupancy percentages script.
<span class="label label-important label-danger">Fix</span> Fixed an issue when manually creating new guests.

<h3>Jomres 9.9.2 01/06/2017</h3>

<span class="label label-important label-danger">Fix</span> Solved a redirect problem when installing jomres
<span class="label label-important label-danger">Fix</span> Fixed an issue with property list paging.
<span class="label label-important label-danger">Fix</span> Fixed an issue where dashboard settings wouldn't be saved when a guest profile hasn't been created for a manager yet.
<span class="label label-important label-danger">Fix</span> Warn about the ipinfodb and openexchangerates api keys only if "use currency conversion" is enabled in site config.
<span class="label label-important label-danger">Fix</span> Removed a query that`s not needed.

<h3>Jomres 9.9.1 30/05/2017</h3>

<span class="label label-success">Feature</span> Added jomres frontend control panel widgets. The Jomres Dashboard ( now renamed to frontend Control Panel ) is now dynamic, meaning you can add/remove widgets to the Property Manager's control panel as well as use Drag and Drop to move them around.
<span class="label label-success">Feature</span> Disabled option to change property type after a property has been created. 

<span class="label label-warning">Change</span> Changed datatables scripts so they won`t interfere with mod security rules
<span class="label label-warning">Change</span> tweaked the reinstall all plugins message when no license key set
<span class="label label-warning">Change</span> Improved how and when we get all regions from db
<span class="label label-warning">Change</span> Added region to property details sanity check and removed postcode and tel as they`re not used by everybody or on all properties
<span class="label label-warning">Change</span> Replaced hardcoded /jomres/uploadedimages path with it`s defined constant
<span class="label label-warning">Change</span> Replaced hardcoded /jomres/temp path with it`s defined constant
<span class="label label-warning">Change</span> Removed usage reporting and tweaked the api keys warning colours in admin cpanel
<span class="label label-warning">Change</span> Removed unused site config settings
<span class="label label-warning">Change</span> Made the cms user register/login separate tasks that redirect to the cms registration/login form. This allows us to control the menu register/login jomres menu items access levels too
<span class="label label-warning">Change</span> Added guest_uid index to contracts table
<span class="label label-warning">Change</span> Improved jomres sessions handling
<span class="label label-warning">Change</span> Tweaked edit guests page so that the blacklist option and text will show up only when editing existing guests.
<span class="label label-warning">Change</span> Updated jquery ui
<span class="label label-warning">Change</span> Slightly increased the delay value when searching in datatables
<span class="label label-warning">Change</span> Updated chart js
<span class="label label-warning">Change</span> Slovenian regions added to countries.php so that new installations will have regions installed.
<span class="label label-warning">Change</span> Made the bookings chart the default chart selected on reports
<span class="label label-warning">Change</span> Added chart fixed height support to be used later
<span class="label label-warning">Change</span> Changed regions class so that when region id is 0 or blank, we`ll return an empty string instead of throwing an error.
<span class="label label-warning">Change</span> Made sure that properties can be published/unpublished on user suspension only if the user has a manager/receptionist user role.
<span class="label label-warning">Change</span> Modified frontend functionality so that dashboard ( to be renamed timeline ) is part of a subset of cpanel templates.
<span class="label label-warning">Change</span> Menu option added to put weekly percentage view into reports menu option.
<span class="label label-warning">Change</span> Creating the object using j05000 script to allow dobooking method override.
<span class="label label-warning">Change</span> Added request_log call to jomres.php to be triggered if in development mode.
<span class="label label-warning">Change</span> Changed a language definition for book now because SEF urls with different strings for the book now text wont work on different property types.
<span class="label label-warning">Change</span> Tweak to make sure we also reset the logged in manager to non manager when it doesn`t have any properties assigned
<span class="label label-warning">Change</span> Added some code that will remove orphan rooms for properties that have had their property types changed, and an extra sanity check. These will remain commented out as in 9.9.1 we are removing the ability to change property types, however the change will remain in case we reverse this decision.

<span class="label label-important label-danger">Fix</span> Fixed a bug in access control and added the 00035 property details tabs/blocks to access control. This allows us to set property details blocks/tabs specific access levels.
<span class="label label-important label-danger">Fix</span> Temp fix for php 7.1 session ids which have max 256 chars. Jomres sessions only allow 50 chars, so we`ll substr the first 50 chars of session id
<span class="label label-important label-danger">Fix</span> Resolved an issue where wire transfer couldn't trigger 00605 to send emails.
<span class="label label-important label-danger">Fix</span> Fixed a bug in DT ajax options
<span class="label label-important label-danger">Fix</span> Made public a function that is called in j06002edit_tariffs_normal.class.php
<span class="label label-important label-danger">Fix</span> Fixed a notice on jomres install related to jr user not being ready.
<span class="label label-important label-danger">Fix</span> Fixed notices for when markers are not created for a property type.
<span class="label label-important label-danger">Fix</span> Tweaked view agent to only show agent name in browser title if task is set to view_agent.
<span class="label label-important label-danger">Fix</span> Fixed a bug in the normal tariff editing mode that tries to address an edge case created by switching property types.
<span class="label label-important label-danger">Fix</span> Solved access control problem for viewproperty and dobooking menus and tasks.

<span class="label label-info">Wordpress</span> Changed some variable names in datatables ajax request so they won`t conflict with WP public query vars

<h3>Jomres 9.9.0 16/05/2017</h3>

<span class="label label-success">Feature</span> Added new tariffs handling class. This brings several benefits for future development, with respect to the new booking engine and API development.
<span class="label label-success">Feature</span> Refactored both front and backend menu systems. Plugin settings moved to Site Configuration and entire administrator area rebuilt to be more logical.
<span class="label label-success">Feature</span> Session handling completely refactored to store data in the database, not files. Performance improvement.
<span class="label label-success">Feature</span> Region name handling refactored. Performance improvement. 
<span class="label label-success">Feature</span> Added country flags as css to lower the number of requests on pages that display the country flags (eg: top destinations)
<span class="label label-success">Feature</span> Improved countries handling so they won`t all be loaded on each page, instead they`ll be loaded all only on demand.
<span class="label label-success">Feature</span> Added Radial percentage bars added to Dashboard to easily see this week's occupancy levels.
<span class="label label-success">Feature</span> Added room descriptions inputs and outputs.
<span class="label label-success">Feature</span> Added Guest Blacklisting feature.
<span class="label label-success">Feature</span> Added reviews details to admin cpanel overview
<span class="label label-success">Feature</span> Added booking notes to dashboard popup.
<span class="label label-success">Feature</span> Improved the admin cpanel frontpage. Layout adjusted.

<span class="label label-warning">Change</span> Considerable language file update, old definitions removed.
<span class="label label-warning">Change</span> Many minicomponents trigger numbers changed so that they are now 06000/06001/06002/06005 instead of their older numbers.
<span class="label label-warning">Change</span> Made the crons run using async sockets so they won`t slow down the page
<span class="label label-warning">Change</span> Moved cron job settings to site config. Updated to use logging only in development mode.
<span class="label label-warning">Change</span> Removed mobile detect class as it`s not needed anymore
<span class="label label-warning">Change</span> Modified how we scan for class files to greatly improve speed
<span class="label label-warning">Change</span> Added a classes registry file
<span class="label label-warning">Change</span> Improved languages handling so we won`t need to scan for languages on each page load
<span class="label label-warning">Change</span> Improved how we clean up tmp js files, we were doing it twice when saving site config
<span class="label label-warning">Change</span> Removed jomres array caching and done micro optimization to avoid unnecessary counting of arrays
<span class="label label-warning">Change</span> Improved speed on how we call and check if a specific event exists, so we won`t go through each record in the registry, instead directly check if a specific key is set in the registry array.
<span class="label label-warning">Change</span> Change how we handle minicomponents registry. The array key has been changed from [XXXXXminicomponent_name] to [XXXXX][minicomponent_name]. Now we can quickly find all minicomponents by trigger point instead of going through the entire minicomponent registry array all the time.
<span class="label label-warning">Change</span> Modified functions related to checking Jomres version so that their return values have more scope.
<span class="label label-warning">Change</span> Added coupon code classes
<span class="label label-warning">Change</span> Removed the jomres admin dir and moved the last file in it to functions dir
<span class="label label-warning">Change</span> Modified agent view script to change page title to their name.
<span class="label label-warning">Change</span> Removed the unused site config cal_output setting
<span class="label label-warning">Change</span> Moved sms clickatell classes from the core to their plugin
<span class="label label-warning">Change</span> Renamed the Properties site config tab to Portal Functionality
<span class="label label-warning">Change</span> Improved languages class so it won`t require scanning the languages dir anymore
<span class="label label-warning">Change</span> Readme.md file added to minicomponents dir for developers, provides descriptions of what the different trigger numbers do.
<span class="label label-warning">Change</span> Delete Business changed in lang files to Delete Property.
<span class="label label-warning">Change</span> Removed product tour files from repo. tour_target divs will need to be removed from template files at a later time.
<span class="label label-warning">Change</span> Show logfile removed as it's not used.
<span class="label label-warning">Change</span> Cancel booking changed from manager to reception tasks.
<span class="label label-warning">Change</span> Added some back tracing for when a class doesn't exist.
<span class="label label-warning">Change</span> Removed the original price tooltip.
<span class="label label-warning">Change</span> Removed the unused plugin check code
<span class="label label-warning">Change</span> Added user agent to sockets
<span class="label label-warning">Change</span> Modified plugin manager so that blue update button does not show if plugins do not need updating.
<span class="label label-warning">Change</span> Modified invoices so that the mark as paid button will be available only if the booking is approved
<span class="label label-warning">Change</span> Language. Changed Businesses to Properties in table header of control panel.
<span class="label label-warning">Change</span> Removed the advanced site config option
<span class="label label-warning">Change</span> Solved a layout problem when latest jomres version number can`t be obtained.
<span class="label label-warning">Change</span> Added Armenian Dram to our currency codes list.
<span class="label label-warning">Change</span> Language. Changed "Available logs" to "Log files" in language files.
<span class="label label-warning">Change</span> Completely rebuilt the frontend menu. Changed how access control behaves: now tasks can be controlled and this will control the visible menu items too.
<span class="label label-warning">Change</span> Removed an obsolete asamodule report file, as this functionality is now expanded on by the Shortcodes reporting feature.
<span class="label label-warning">Change</span> Made access control feature a plugin

<span class="label label-important label-danger">Fix</span> Updated the Arabic jquery-ui localization file to fix day names
<span class="label label-important label-danger">Fix</span> Solved a fullscreen view problem in joomla that prevented the editor from working correctly.
<span class="label label-important label-danger">Fix</span> Fixed how jintour tours tax is calculated when inserting the line items on invoices
<span class="label label-important label-danger">Fix</span> Fixed an issue of multiple records being created for same invoice at invoice payments ref table
<span class="label label-important label-danger">Fix</span> Fixed rounding problem when adding service to bill and prices are set to gross
<span class="label label-important label-danger">Fix</span> Solved a typo that was causing an out of memory error
<span class="label label-important label-danger">Fix</span> Fixed a bug in save guests where guest mos/cms id would get reset to zero when guest is saved by a property manager.
<span class="label label-important label-danger">Fix</span> Solved a problem with guest existing id not being reset on a new quick booking made from the dashboard modal
<span class="label label-important label-danger">Fix</span> Fixed a bug where room types for some other property uids couldn`t be loaded if we`re currently on the property details page
<span class="label label-important label-danger">Fix</span> Modified the url that the file system integrity check points to, was old svn, now points to github.

<span class="label label-info">Wordpress</span> Solved a problem with js running before document ready on wp, which has the jomres js files in the footer

<h3>Jomres 9.8.29 29/03/2017</h3>

<span class="label label-success">Feature</span> Added new deferred task handling functionality.
<span class="label label-success">Feature</span> Added a new feature to allow each manager to set an external booking url if they want to use a 3rd party website for booking.

<span class="label label-warning">Change</span> Made the slideshow property details url to be a sef url
<span class="label label-warning">Change</span> Added backtracing to debug level logging.
<span class="label label-warning">Change</span> Added a number of changes that resolve hack warnings for users with no gateways installed.
<span class="label label-warning">Change</span> Added a booking management class to help us with various booking related tasks like guests checkin, checkout, etc.
<span class="label label-warning">Change</span> Added code to prevent calls to site being able to prevent further processing by dint of, for example, timing out. This allows us to implement deferred message handling functionality.
<span class="label label-warning">Change</span> Added code to show room uids in dashboard if set to development mode.
<span class="label label-warning">Change</span> Moved the Cancellation Threashold setting in a more appropriate position in property configuration
<span class="label label-warning">Change</span> Turkish language file updated.

<span class="label label-important label-danger">Fix</span> Solved some minor layout problems in Media Centre
<span class="label label-important label-danger">Fix</span> Solved some minor problems with some text when editing mode was enabled

<span class="label label-info">Wordpress</span> Solved a problem with the search on WP caused by a typo in the variable name when setting the jomres page_id


<h3>Jomres 9.8.28 16/03/2017</h3>

<span class="label label-warning">Change</span> Updated the insertbooking webhook booking_added to be triggered only if the booking is approved or doesn`t require approval.
<span class="label label-warning">Change</span> Reformatted the ajax response for dashboard events
<span class="label label-warning">Change</span> Improved speed in admin cpanel by caching the installed plugins list used by the j07020 file that counts plugin updates
<span class="label label-warning">Change</span> Small tweaks to custom text handling, added a few more checks to make sure we have the property custom text loaded even on non jomres pages
<span class="label label-warning">Change</span> Updated the get_booking_url and get_property_details_url functions to use additional url params

<span class="label label-important label-danger">Fix</span> Solved a problem with booking enquiries that caused a gateways error, because enquiries don`t use payment gateways.
<span class="label label-important label-danger">Fix</span> Solved a problem with the way room features are saved in db when no room feature was selected
<span class="label label-important label-danger">Fix</span> Solved a problem with the amend booking redirect url when sef enabled
<span class="label label-important label-danger">Fix</span> Solved a notice when saving normal mode tariffs


<h3>Jomres 9.8.27 08/03/2017</h3>

<span class="label label-warning">Change</span> Refactored gateway handling to, among other things, ensure that paypal override setting doesn't override all other gateways.
<span class="label label-warning">Change</span> Added support for overriding the property details url and improved the booking form url function. 
<span class="label label-warning">Change</span> Added support to create jomres joomla menus that point to property details page. This will allow us not to have duplicate urls when a joomla menu item is created for a property details page. In this case, the joomla url will be used, not the jomres default one. Also, allows us to have specific joomla modules assigned only to this property details page.
<span class="label label-warning">Change</span> Tweaked the media centre uploader to allow both jpg and png files to be uploaded. Previously png files would be converted to jpg files, now they're left as pngs, which preserves their transparency.

<span class="label label-warning">Change</span> Small tweak to allow single person supplement to be a negative value too.
<span class="label label-warning">Change</span> Improved sorting by room number on the dashboard.
<span class="label label-warning">Change</span> Made the google maps api load in async mode. Thanks Rod.
<span class="label label-warning">Change</span> Adjusted the occupancy percentages in the mrp calendar.
<span class="label label-warning">Change</span> Changed reviews agree/disagree buttons to be available for not logged in users too.
<span class="label label-warning">Change</span> Updated copyright year at the bottom of the admin cpanel.
<span class="label label-warning">Change</span> Changed how api handles exceptions ( makes development easier )
<span class="label label-warning">Change</span> Updated media centre to remove upload contexts and simplify things for 3rd party developers.
<span class="label label-warning">Change</span> Commented some obsolete js caching code that was causing a scandir on each page load.
<span class="label label-warning">Change</span> Added a new media centre feature that gets images uploaded by admins (site images) so plugins don`t need specific code to scan those dirs.
<span class="label label-warning">Change</span> Removed the map markers obsolete class.
<span class="label label-warning">Change</span> Moved the code that handles zipping logs bigger then 1M to the logs cleanup cron job, so it won`t run on each page load but only once per day.
<span class="label label-warning">Change</span> Made the geolocation files cleanup a cron job that runs daily and empties the geolocation dir.
<span class="label label-warning">Change</span> Changed how debug mode is set in Joomla/Wordpress API.
<span class="label label-warning">Change</span> Disabled a check in the installer for extraservices table name, it's been long enough now.
<span class="label label-warning">Change</span> Added RTL auto detection to dashboard
<span class="label label-warning">Change</span> Added a simple function to search for a contract uid based on the booking number.
<span class="label label-warning">Change</span> Added a function to get a map marker src
<span class="label label-warning">Change</span> Some aesthetics tweaks to dates on invoices
<span class="label label-warning">Change</span> Improved guest's view of bookings to cope with empty property uids.

<span class="label label-important label-danger">Fix</span> Fixed the dashboard trash broken layout in bootstrap 2 templates.
<span class="label label-important label-danger">Fix</span> Fixed a typo that was causing a fatal error in the srp calendar.
<span class="label label-important label-danger">Fix</span> Tweaked sanity check messages to not take region into account when warning the user about missing property data, because some countries don`t have regions.
<span class="label label-important label-danger">Fix</span> Solved a problem related to api language in WP.
<span class="label label-important label-danger">Fix</span> Changed how m0 enabled search options are handled on WP

<h3>Jomres 9.8.26 14/02/2017</h3>

<span class="label label-warning">Change</span> Removed some unused functions
<span class="label label-warning">Change</span> Modified the BS3 contact owner form so that name limit is increased to 50 characters.
<span class="label label-warning">Change</span> Updated the jomresMailer function to solve a problem when emails not being sent if ssl certificates are self signed by hosting providers.
<span class="label label-warning">Change</span> Added a column in list bookings to display who made the booking
<span class="label label-warning">Change</span> Added code to automatically enable searching on various options if search module is set to jomSearch_m0. This is because they can only be enabled through editing configuration.php, as the settings in site config no longer exist.
<span class="label label-warning">Change</span> Modified dashboard to improve layout of the drag to trash sliding panel.
<span class="label label-warning">Change</span> Modified tooltip functionality so that urls can be passed to the output templates. Allows setting of search urls for room types and property features.
<span class="label label-warning">Change</span> Added search urls to non-categorised property features.
<span class="label label-warning">Change</span> Added joomla router functionality for room types and property features search urls
<span class="label label-warning">Change</span> Added ajax countries/regions dropdowns for real estate edit property pages
<span class="label label-warning">Change</span> Added bitcoin to exchange rates conversions that can be offered.
<span class="label label-warning">Change</span> Added a define for jomres temp dir
<span class="label label-warning">Change</span> Tweaked media centre so that some popups show to the left of the button instead of the right, better for smaller screens.
<span class="label label-warning">Change</span> Modified the webhook position on saving new guest type
<span class="label label-warning">Change</span> Added a new function that, in the core of Jomres, simply returns the booking link page. It does, however, allow us to override the url to the booking page programmatically through plugins if desired.
<span class="label label-warning">Change</span> Completely rewritten the guest handling functionality
<span class="label label-warning">Change</span> Made the cancellation threshold option available to jintour properties too
<span class="label label-warning">Change</span> Tweaked the default visible columns in list bookings to have the "booking made by" hidden by default and the "approved" column visible by default
<span class="label label-warning">Change</span> Changed the way we use JInput to filter request vars when sef enabled
<span class="label label-warning">Change</span> Added support for overriding the set_booking_number function
<span class="label label-warning">Change</span> Partners page updated in Jomres admin area.
<span class="label label-warning">Change</span> Moved the guest firstname and surname to the guest details tab in registered users view booking page
<span class="label label-warning">Change</span> Removed the int casting of the booking number, to allow custom booking numbers to use chars too.
<span class="label label-warning">Change</span> Updated the currency code for Ugandan Schilling

<span class="label label-important label-danger">Fix</span> Spanish language file updated to resolve a javascript issues that a carriage return can cause.
<span class="label label-important label-danger">Fix</span> Discovered that guest details passed through the form which contained an apostrophe are getting mangled, so we unmangle them then sanitise them properly before passing them to the booking engine.
<span class="label label-important label-danger">Fix</span> Fixed duplicate images showing in old BS2 tooltips.
<span class="label label-important label-danger">Fix</span> Solved a problem with modals on the booking form being behind backdrop on specific room-tariff configurations

<span class="label label-info">Wordpress</span>  Solved a mailer problem on WP when class SMTP already exists

<h3>Jomres 9.8.25 09/01/2017</h3>

<span class="label label-warning">Change</span> Modified a variety of webhook names for consistency.
<span class="label label-warning">Change</span> Added a tweak to logging to ensure that browser console notification messages aren't attempted if the call is an API call.
<span class="label label-warning">Change</span> Removed a duplicate definition
<span class="label label-warning">Change</span> Added some ( disabled ) checks for ssl. Strictly speaking the site admin should force api access to go via ssl, I'll leave this in place for now while I consider whether it should be added.
<span class="label label-warning">Change</span> Added a note to basic invoice details for use by remote services that might need an aide-memoire for what each invoice status means.
<span class="label label-warning">Change</span> Improved patTemplate dump to show the override path when a cms template override is used
<span class="label label-warning">Change</span> Reviews class. Improved webhook calls to include property uid.
<span class="label label-warning">Change</span> Reviews class. Added note regarding "fields" and their meaning which can then be passed back by API scripts.

<span class="label label-important label-danger">Fix</span> Fixed an issue in property access class for api as new user role changes broke it :(
<span class="label label-important label-danger">Fix</span> Solved a problem related to room type in the verbose tariff details
<span class="label label-important label-danger">Fix</span> Solved a js error on the dashboard
<span class="label label-important label-danger">Fix</span> Changed phpmailer to use jomres_phpmailerException class

<h3>Jomres 9.8.24 27/12/2016</h3>

<span class="label label-important label-danger">Fix</span> PHPMailer 5.2.19 was found to have it's own vulnerability, eventually resulting in PHPMailer 5.2.21, so Jomres has been updated with this version.

<h3>Jomres 9.8.23 27/12/2016</h3>

<span class="label label-important label-danger">Fix</span> Fixed a bug in the installer.

<h3>Jomres 9.8.22 27/12/2016</h3>

<span class="label label-important label-danger">Fix</span> PHP Mailer library updated to 5.2.19 from 5.2.9 due to critical remote code execution bug in previous versions

<span class="label label-success">Feature</span> Added webhook functionality, specifically code to generate webhooks, that the Webhook Core would fire.
<span class="label label-success">Feature</span> Updated the dashboard js to have proper built in touch devices support.
<span class="label label-success">Feature</span> Improved logging, logs now sent to browser console and modified logging class so that further information can be sent to an extra field, which offers cleaner log views.

<span class="label label-warning">Change</span> Properly format the date in the booking notes tab
<span class="label label-warning">Change</span> Some small changes to make some js run only on document ready
<span class="label label-warning">Change</span> Removed a setting not used in wp, saves an unneeded query
<span class="label label-warning">Change</span> Added a new tab in Plugin Manager for webhooks plugins
<span class="label label-warning">Change</span> Disabled a log in input filtering
<span class="label label-warning">Change</span> Added support for changing the jomres language (from the jomres language switcher)in the frontend even if the cms language remains the same.

<span class="label label-important label-danger">Fix</span> Changed where jomres_decode is done in jr_gettext.php to solve a problem in label translations.
<span class="label label-important label-danger">Fix</span> Fixed a js error on dashboard in fullscreen view
<span class="label label-important label-danger">Fix</span> Fixed a potential cause of notices if none of the properties chosen for comparison have property features assigned to them.
<span class="label label-important label-danger">Fix</span> Solved a js error related to regions dropdown on bootstrap 2, on the property registration page
<span class="label label-important label-danger">Fix</span> Solved a bug in generic booking amend class that affected the rooms^tariffs pairs when a booking was amended by drag&drop from the dashboard. Thanks Rod
<span class="label label-important label-danger">Fix</span> Further changes to solve decimal problems on invoices.
<span class="label label-important label-danger">Fix</span> Fixed a bug where property types could be unpublished even if still used by properties in the system

<h3>Jomres 9.8.21 Version skipped</h3>

<h3>Jomres 9.8.20 01/12/2016</h3>

<span class="label label-warning">Change</span> Writability check panel removed as it`s not useful anymore 
<span class="label label-warning">Change</span> Added a link next to the username input on the edit profiles page to edit the cms user profile
<span class="label label-warning">Change</span> Improved managers listing so deleted users from the cms that still have access rights to jomres will be marked with an orange label
<span class="label label-warning">Change</span> Removed some very old obsolete files 

<span class="label label-important label-danger">Fix</span> Fixed a bug where registered users can't create a new property because their access level was set to the wrong value.

<h3>Jomres 9.8.19 28/11/2016</h3>

<span class="label label-success">Feature</span> Added Markdown handling functionality to Jomres. 
This allows non-super property managers to format text in a simple way without being able to add html to the page. Allowing property managers to enter html in property decriptions is fraught with danger ( Cross site scripting being the main worry), which is why we've always defaulted to the most stringent settings on a default installation. This isn't very friendly for new users, however, or property managers that want to apply some formatting but the site has left the Input Filtering setting to Paranoid. Markdown handling allows non-super managers to add basic formatting to text inputs ( for example Property Details, Checkin times ) without sacrificing security. Two new libraries have been added, one to display a Markdown editor in the Edit Property page ( relevant inputs ) called SimpleMDE and a second ( Parsedown )to parse text before it's output to the page. 

<span class="label label-success">Feature</span> Improved the Media Centre.
Made media centre drop down buttons larger and gave the primary and secondary dropdowns their own classes to make them stand out more.
Rooms list added "room" text next to number.
Removed old image link from the images list, instead resource types are able to offer a "Preview" link, which, if available will show an example of the resource in property page inside a modal.
Added additional instructions to give clarity for the usage of the buttons.

<span class="label label-success">Feature</span> Added functionality to allow us to show the main menu in selected locations. 
This allows us to show the Jomres main menu in other places ( See Shortcodes info page ). It doesn't disable the menu from displaying in the Jomres content area, however.

<span class="label label-warning">Change</span> Jomres Core files updated to use PSR2 coding standards.
<span class="label label-warning">Change</span> Show plugins, Upgrade button renamed to Update.
<span class="label label-warning">Change</span> Modified input filtering to preserve line breaks in text that's saved to the database. Related to Markdown.
<span class="label label-warning">Change</span> API updated to log an error instead of output it.
<span class="label label-warning">Change</span> Added cms specific function to get username by id.
<span class="label label-warning">Change</span> Modified the license message position in plugin manager.
<span class="label label-warning">Change</span> Minor language file tweak for th-TH.
<span class="label label-warning">Change</span> Added new property features classes.
<span class="label label-warning">Change</span> Completely rebuilt Jomres user roles. Receptionist access level changed from 1 -> 50, manager 2->70, super property manager was having access level 2 and pu set to 1, now it`s 90. Provides scope for future improvements.

<span class="label label-important label-danger">Fix</span> Fixed a typo that prevented us from adding new users in Joomla when making a booking.
<span class="label label-important label-danger">Fix</span> Resolved an issue with users being unable to add new property types.
<span class="label label-important label-danger">Fix</span> Modified call to Mobile_Detect class, to check that the class doesn't already exist ( other extensions use the same class, so this could cause conflicts ).
<span class="label label-important label-danger">Fix</span> Modified contact owner so that the template has it's own version of placeholders that don't have javascript that will cause confusion if the editing mode is enabled.
<span class="label label-important label-danger">Fix</span> Fixed a query that was failing in some cases, thanks Rod ( Invoices class ).
<span class="label label-important label-danger">Fix</span> Solved resource/room cloning problem.
<span class="label label-important label-danger">Fix</span> Fixed a notice for users that deleted all tax rates.

<h3>Jomres 9.8.18 11/11/2016</h3>

<span class="label label-warning">Change</span> Resolved an issue where cron jobs were throwing notices on installation/upgrade.
<span class="label label-warning">Change</span> Modified the registry class to remove javascript caches whenever the registry is rebuilt.
<span class="label label-warning">Change</span> Added performance improvements to list reviews script in admin area.
<span class="label label-warning">Change</span> Added functionality that detects the type of device, if device is not a desktop then drag and dropping of bookings isn't allowed. Fat fingered souls rejoice!

<span class="label label-warning">Change</span> Tourist tax plugin code added to the core of the system.
<span class="label label-warning">Change</span> Added tweaks to WP url handling to avoid some wp redirectsion from non-sef to sef urls
<span class="label label-warning">Change</span> Added minor tweaks to cron class for layout and checking if a variable is empty.
<span class="label label-warning">Change</span> Fixed a couple of notices that can show in the dashboard if a booking is moved into a room where there are no tariffs for said room's type.
<span class="label label-warning">Change</span> Modified property header to use the property description in the meta data if meta data isn't set. 
<span class="label label-warning">Change</span> Added a couple of tweaks to new marker related functionality that allows for how handling of deleted markers is handled.
<span class="label label-warning">Change</span> Updated control panel welcome language strings.
<span class="label label-warning">Change</span> Show Profiles page renamed to Property Managers ( Administrator area page ).
<span class="label label-warning">Change</span> Minor layout tweak to control panel message output.
<span class="label label-warning">Change</span> Updated the key check to correctly return false if a key's state can't always be determined.
<span class="label label-warning">Change</span> Added a license status message to the plugin manager.
<span class="label label-warning">Change</span> Removed plugin check from sys info script.
<span class="label label-warning">Change</span> Added an option to have a blank commission rate to the commission rate dropdown.


<h3>Jomres 9.8.17 04/11/2016</h3>

<span class="label label-success">Feature</span> Added functionality to allow different map markers. Allows us to assign different map markers for different property types and for them to show ( naturally ) on the extended maps map.
<span class="label label-success">Feature</span> Added a longtext class and appropriate javascript so that tab contents can be limited to N characters.
<span class="label label-success">Feature</span> Updated the ajax notification loader. Previously it was configured to change the cursor on ajax activity, however mobile devices don't have cursors, so swapped it out for a nice font awesome spinner instead. Now users can see the the ajax search is doing something. Likewise, property managers can see the activity notification.


<span class="label label-warning">Change</span> Added full Jomres version to relevant files.
<span class="label label-warning">Change</span> Reverted a recent change to an API script vis directory scanning as API doesn't always have access to Jomres framework so the custom scandir function will not be available.
<span class="label label-warning">Change</span> Removed some trailing ?> from files.
<span class="label label-warning">Change</span> Polish changed to be without BOM
<span class="label label-warning">Change</span> Modified a setting description in site config to be more CMS agnostic.
<span class="label label-warning">Change</span> Fixed a typo linking to deligence.

<span class="label label-important label-danger">Fix</span> Amended the new user creation function as J changes mean that in some mysql modes the insert user query will fail.
<span class="label label-important label-danger">Fix</span> Improved how meta data is returned to Wordpress.

<span class="label label-info">Wordpress</span> Improved minicomponent registry to allow Jomres to search child templates for minicomponents.
<span class="label label-info">Wordpress</span> Updated a CMS specific script to correctly pull wordpress module settings.

<h3>Jomres 9.8.16 25/10/2016</h3>

<span class="label label-warning">Change</span> Removed exchange rates cron script as it's no longer required.
<span class="label label-warning">Change</span> Made the exchange rates class a singleton.
<span class="label label-warning">Change</span> Modified list guests ajax script to account for mysql strict ONLY_FULL_GROUP_BY settings.
<span class="label label-warning">Change</span> Tweaked a query in list invoices ajax script to resolve some mysql notices.
<span class="label label-warning">Change</span> Added a tweak to decode apostrophes to their proper form in email subjects.
<span class="label label-warning">Change</span> Tweaked tabletools handling so that when clicking on xls link the page name is used when naming the file.
<span class="label label-warning">Change</span> Booking confirmation page updated, amend booking element changed from a submit button to a link. It doesn't need to be a submit form, and it's recently stopped redirecting back to the booking form.
<span class="label label-warning">Change</span> Tweaked a search query that sorts properties in descending order. Removed that ordering.
<span class="label label-warning">Change</span> Added trimming to property names in photo view only to preserve photo view page layout.

<span class="label label-important label-danger">Fix</span> Fixed an issue with Leohtian templates not showing modules on front page. It was caused by an incorrectly merged PR in Joomla breaking B/C
<span class="label label-important label-danger">Fix</span> Modified how new CMS users are created, fixes a problem with WP.
<span class="label label-important label-danger">Fix</span> Removed caching from property uids, solves a language switcher problem in admin cpanel
<span class="label label-important label-danger">Fix</span> Testing a tweak to jomresURL function. Joomla 3.6.3 routing has changed how urls are returned, causing issues with various forms being built incorrectly.

<h3>Jomres 9.8.15 18/10/2016</h3>

<span class="label label-success">Feature</span> Added filesystem integrity check feature.

<span class="label label-warning">Change</span> Improved caching of geolocation caching, seems our performance problems were caused by throttling by the remote service.
<span class="label label-warning">Change</span> Added a new input filter results cache for testing. 
<span class="label label-warning">Change</span> Added further speed improvements to registry. Also made the registry readable. We just include_once, no more unserialize on each page load.
<span class="label label-warning">Change</span> Added small change to get property names multi so that even without caching the query won`t be executed more times on the same page for the same property uids
<span class="label label-warning">Change</span> Modified how property names are found. Performance improvement.
<span class="label label-warning">Change</span> Modified functionality so that on redirect we explicitly close database connections. All the documentation says we shouldn't need to, but this is a test to see if we can reduce the number of connections left open.
<span class="label label-warning">Change</span> Replaced scandir with more efficient home-rolled function.
<span class="label label-warning">Change</span> Improved an estimate generation method in the booking engine, major speed improvement for properties with many tariffs.
Changed how we checked to see if an array is empty, instead of counting. Minor performance boost.

<span class="label label-warning">Change</span> Added phone number to Contact Owner form.
<span class="label label-warning">Change</span> Added alert-danger for BS3 users in edit booking script.
<span class="label label-warning">Change</span> Updated add service to bill function so that if the prices are set to gross option is set, then the price is initially figured to nett before being added.
<span class="label label-warning">Change</span> Added a change to the invoice class to see if it helps resolve some rounding issues.
<span class="label label-warning">Change</span> Added colours to invoice labels status.
<span class="label label-warning">Change</span> Improved English language API key directions to provide urls to servers.
<span class="label label-warning">Change</span> Improved layout of log file information.
<span class="label label-warning">Change</span> Modified exchange rate handling functionality so that if we can't d/l data, we still build a partial file. This prevents various parts of the system re-trying to rebuild this data, we'll just have to accept that for today, we can't convert prices. When the system tries again the next day, more complete data should be available.
<span class="label label-warning">Change</span> Added code to die if the call is a heartbeat call from the booking engine then just die, further processing is pointless.


<span class="label label-important label-danger">Fix</span> Changed booking engine so that if deposit required is first night then tax is properly included in the price.
<span class="label label-important label-danger">Fix</span> Resolved a problem with editing properties in WP
<span class="label label-important label-danger">Fix</span> Added a change to how property features are saved in the db as it was affecting property cloning.

<span class="label label-info">Wordpress</span> Added Wordpress functionality that creates a new page with jomres:xx-XX if it doesn't already exist. Negates the need for managers to add pages manually.
<span class="label label-info">Wordpress</span> Added calls to jomres/classes/jomres_database.class.php so that we can monitor WP DB usage.
<span class="label label-info">Wordpress</span> Check if we are in admin area...so that in wp it won`t happen that the framework.php is loaded (because of wp plugins which use actions like 'init' which are available also in admin area - this doesn`t happen on joomla) and does the queries/stuff instead of admin.php.

<h3>Jomres 9.8.14 05/10/2016</h3>

<span class="label label-important label-danger">Fix</span> Improved how we access some singletons to resolve some people's intermittent performance problems.

<h3>Jomres 9.8.13 03/10/2016</h3>

<span class="label label-success">Feature</span> Added functionality that allows us to dynamically add shortcode data to the system, passed directly from minicomponents. 
<span class="label label-success">Feature</span> Repurposed ASAModule report to output information about shortcodes. 
<span class="label label-success">Feature</span> Added a shortcode parser that can return shortcode data.


<span class="label label-warning">Change</span> Updated help pages in admin area. New security protocols on jomres.net pages were preventing help pages from showing in iframes.
<span class="label label-warning">Change</span> Improved plugin manager to only show the reinstall button when the key is valid.
<span class="label label-warning">Change</span> Removed some redundant help scripts as they're no longer needed.
<span class="label label-warning">Change</span> Added a number of changes to get around the Mysql 5.7 Strict NO_ZERO_DATES limitation.
<span class="label label-warning">Change</span> Removed Joomla3.x specific versions of library files, which were created back in 2012 in anticipation of more significant version changes given Joomla's past history of significant backward compatability changes. As J3.x is now much more B/C friendly these are no longer required. The downside is that anybody running a very old version of J3.x might have problems running Jomres, but in this day and age it's trivially easy to upgrade Joomla.
<span class="label label-warning">Change</span> Added changes relating to how we cleanup sessions.
<span class="label label-warning">Change</span> Improved and simplified the media centre class.
<span class="label label-warning">Change</span> Tweaked how directories are built on recursive directory scans.

<span class="label label-important label-danger">Fix</span> Fix intermittent 404 error in wp when submitting a booking.
<span class="label label-important label-danger">Fix</span> Fixed a bug where the media centre could find the wrong images for a property, consolidated how directories are scanned ( modest performance improvement ).
<span class="label label-important label-danger">Fix</span> Changed how two columns are modified during upgrade so that they don't throw mysql errors.


<h3>Jomres 9.8.12 20/09/2016</h3>

<span class="label label-success">Feature</span> Added permit number to Property Details fields for users in those countries that must show a permit/registration number.

<span class="label label-warning">Change</span> Added a Reinstall all plugins button for users upgrading from Trial to Full versions.
<span class="label label-warning">Change</span> Tweaked API routing allowing clients to send the token in the url.
<span class="label label-warning">Change</span> Changed the manage properties icon to a building.
<span class="label label-warning">Change</span> Tweaked addplugin to ensure php version is sent when requesting plugins.
<span class="label label-warning">Change</span> Tweaked a path used when installing mambots.
<span class="label label-warning">Change</span> Added a new javascript function that allows printing of individual divs.
<span class="label label-warning">Change</span> Added API key checks.

<span class="label label-important label-danger">Fix</span> Fixed an issue in API where a request for a function could throw a fatal error.
<span class="label label-important label-danger">Fix</span> Made some API changes so that if a variable isn't empty it doesn't fire a notice.
<span class="label label-important label-danger">Fix</span> Fixed an issue where Black bookings weren't labelled in black in the dashboard.

<h3>Jomres 9.8.11 09/09/2016</h3>

<span class="label label-warning">Change</span> At Rod's request, added componentArgs to optional trigger at the end of show_property_header script.
<span class="label label-warning">Change</span> Modified which variable is checked in j00030search.class.php to help Rod out.
<span class="label label-warning">Change</span> Updated log file viewing to use table tools.
<span class="label label-warning">Change</span> 15 char limit in contact owner form upped to 150 characters.
<span class="label label-warning">Change</span> Added translatable Jintour descriptions
<span class="label label-warning">Change</span> Updated log file viewing to use table tools.
<span class="label label-warning">Change</span> Updated Russian language file, thanks Dmitry.
<span class="label label-warning">Change</span> Added info class to plugin description text
<span class="label label-warning">Change</span> Updated Turkish Lira currency to TRY from TRL
<span class="label label-warning">Change</span> Refactored a new function that didn't work when array keys were not consecutive.
<span class="label label-warning">Change</span> Improved modal display behaviour in BS2.
<span class="label label-warning">Change</span> Updated cron log to clean up old log files > 30 days old.
<span class="label label-warning">Change</span> Changed the order in which users are created on new installations.
<span class="label label-warning">Change</span> Modified list booking ajax script so that Black Bookings aren't included in the list.
<span class="label label-warning">Change</span> Small tweak to ensure sites with just one language type don't try to render the language context dropdown like switches.
<span class="label label-warning">Change</span> Improved sanity checks so that rooms are always set as todo if required.
<span class="label label-warning">Change</span> Ensured all if statements are wrapped in curly braces in jomres.js
<span class="label label-warning">Change</span> Added logging to mailer and a quick check to warn that the To address hasn't been set to test email sending script.
<span class="label label-warning">Change</span> Modified mailer to send log messsages to Mailer context in logging.
<span class="label label-warning">Change</span> Added a check to see if a definition has already been set in Wordpress jomres.php
<span class="label label-warning">Change</span> Improved a query in show confirmation regarding how it finds gateways.

<span class="label label-important label-danger">Fix</span> Fixed a notice that appears when shortcodes are used in templates and there's no second argument.
<span class="label label-important label-danger">Fix</span> Modified how tabs are shown (property config) so that they use random ids instead of language strings. The tab id must be unique otherwise the tab contents will not show.
<span class="label label-important label-danger">Fix</span> Fixed issues where wrong table prefix was used in the installer to create sample data.

<h3>Jomres 9.8.10 11/08/2016</h3>

<span class="label label-success">Feature</span> Added a FAQ to the administrator area.
<span class="label label-success">Feature</span> Added manager area FAQ.
<span class="label label-success">Feature</span> Modified Wordpress updating so that using the WP system to upgrade Jomres will trigger the web installer at the appropriate time.

<span class="label label-warning">Change</span> Improved sample property data and logic to ensure that the Trash Tables feature can be used in the installer.
<span class="label label-warning">Change</span> Modified error reporting level in installer.
<span class="label label-warning">Change</span> Ensured calls to 07020 ( menu badges ) are done only once.
<span class="label label-warning">Change</span> Resolved a duplicate call problem in cpanel.
<span class="label label-warning">Change</span> Modified logging class to reduce the number of queries.
<span class="label label-warning">Change</span> Added logging to admin.php
<span class="label label-warning">Change</span> Changed the point that logging is starts so that we can include the username where available.
<span class="label label-warning">Change</span> Added a new implode function that gives us more control over input validation.
<span class="label label-warning">Change</span> Improved contact owner script to use new validation js.
<span class="label label-warning">Change</span> Improved booking form input validation responses.
<span class="label label-warning">Change</span> Set the minimum_deposit_percentage default to 0. Thanks Ally.
<span class="label label-warning">Change</span> Removed and disabled pattemplate caching feature settings, as they don't play nicely with template overrides, specifically property type or property uid specific templates.

<span class="label label-important label-danger">Fix</span> Fixed a notice in insert booking script.
<span class="label label-important label-danger">Fix</span> Fixed a notice in editguest script.
<span class="label label-important label-danger">Fix</span> Resolved an issue where third party extras could show tax twice.
<span class="label label-important label-danger">Fix</span> Fixed an issue where wrong date set in booking form when availability calendar links clicked.
<span class="label label-important label-danger">Fix</span> Updated router.php to resolve an issue when JCH installed.
<span class="label label-important label-danger">Fix</span> Fixed a problem with the Wordpress trigger script that requires a new version.

<h3>Jomres 9.8.9 05/08/2016</h3>

<span class="label label-success">Feature</span> Updated Jomres to offer Joomla installer updating.

<span class="label label-warning">Change</span> Added booking balance output to emails.
<span class="label label-warning">Change</span> Added a default setting for minimum deposit.
<span class="label label-warning">Change</span> Added a default option to set currency code if it can't be found when trying to detect a user's country.
<span class="label label-warning">Change</span> Modified how extra names are saved so that they can be translated.

<span class="label label-important label-danger">Fix</span> Fixed some notices in basic property details caused by a property not having rooms or accommodation tax set.
<span class="label label-important label-danger">Fix</span> Resolved an issue with js not being loaded if only jomres shortcodes is installed (and not jomres search widget too).
<span class="label label-important label-danger">Fix</span> Resolved a number of notices.


<h3>Jomres 9.8.8 01/08/2016</h3>

<span class="label label-success">Feature</span> Added an option to disable sending emails to managers on errors, expanded notes regarding logging.
<span class="label label-success">Feature</span> Added the ability for Jomres to send logging information to a remote syslog server.
<span class="label label-success">Feature</span> Added functionality to list log files.

<span class="label label-warning">Change</span> Turkish language file added to system, many thanks Sarper
<span class="label label-warning">Change</span> Spanish, Italian and German language files updated.
<span class="label label-warning">Change</span> Tweaked the new user language string sent when a user is created on booking to be function agnostic. Allows us to use the feature for other things.
<span class="label label-warning">Change</span> User creation process, typically used when non-registered users create bookings, changed to use email addresses instead of trying to create usernames based on the guest's names. This is because the regex used to determine the username fails to work properly on non-latin alphabets.
<span class="label label-warning">Change</span> Previous database audit messages are now saved to logs.
<span class="label label-warning">Change</span> Added some friendly notes to property creation.
<span class="label label-warning">Change</span> Modified how gateway plugins are validated to allow another plugin to work differently while still maintaining security.
<span class="label label-warning">Change</span> Added a new Site Configuration setting that allows a site manager to configure a Minimum Deposit amount. This is required because if commission is charged by you and a third party, then the deposit cannot be less than your commission + third party's commission.
<span class="label label-warning">Change</span> Commented a "throw" because spiders are causing error emails to be sent.
<span class="label label-warning">Change</span> Removed some redundant data from a call to process payments.
<span class="label label-warning">Change</span> Improved installer to test for dirs before attempting to create them.
<span class="label label-warning">Change</span> Modified the installer so that failure to create jomres_root.php isn't fatal. It's a silly thing, created to satisfy the Wordpress directory managers, but many servers don't like you to create files in the root for whatever reasons. 
<span class="label label-warning">Change</span> Added old-style router file for users who prefer the pre-9.8.0 urls ( Google love ).
<span class="label label-warning">Change</span> Modified gateway configuration functionality to allow custom code.
<span class="label label-warning">Change</span> Jomres Extras removed from list of our partners as we are integrating their plugins into our own library.
<span class="label label-warning">Change</span> Added a check to ensure that a gateway hasn't been uninstalled before attempting to show it in the booking confirmation page.
<span class="label label-warning">Change</span> Added property uid to data returned by the payment reference class.
<span class="label label-warning">Change</span> Added logging for common curl functionality.
<span class="label label-warning">Change</span> Updated the booking engine to store arrival/departure dates for further use by modules etc.

<span class="label label-important label-danger">Fix</span> Fixed front and backend Bookings charts.
<span class="label label-important label-danger">Fix</span> Fixed a notice when generating log files.
<span class="label label-important label-danger">Fix</span> Fixed a bug in property type specific templating.
<span class="label label-important label-danger">Fix</span> Improved booking engine, some arrival dates from calendar links were being set incorrectly due to a notice fix in the 9.8.
<span class="label label-important label-danger">Fix</span> Resolved a notice in j06005list_gateways_for_invoice.class.php
<span class="label label-important label-danger">Fix</span> Modified how guest details are saved from the booking form to work around an issue where if polylang and permalinks were in use, guest details might not be saved to the temp booking data.


<h3>Jomres 9.8.7 13/07/2016</h3>

<span class="label label-success">Feature</span> New feature : Google map styles

<span class="label label-warning">Change</span> Added logging to email function.
<span class="label label-warning">Change</span> Added a check to ensure that unpublished property types aren't offered in edit property page.
<span class="label label-warning">Change</span> Ensured that we cannot unpublish a property type if there are properties assigned to it.
<span class="label label-warning">Change</span> Updated how jquery is added to site scripts to adjust to a new change in J3.6.
<span class="label label-warning">Change</span> Added additional checks to ensure fatal error is thrown if property uid is incorrect in basic_property_details class.
<span class="label label-warning">Change</span> Modified detect_property_uid function to ensure that detected id actually exist in system.
<span class="label label-warning">Change</span> Modified pathway script to ouput nothing if property uid isn't set.
<span class="label label-warning">Change</span> Improved property singleton so that if we can't get property specific settings then we'll fall-back to the default settings cleanly.
<span class="label label-warning">Change</span> Added mrconfig call to framework.php
<span class="label label-warning">Change</span> Changed how we check for property uid in basic property details to ensure that the correct error is thrown. A script should never get to this point, if it does then a hard exit/error report is the most appropriate way of responding to this current setting.

<span class="label label-important label-danger">Fix</span> Fixed notices that might appear if currency conversion hasn't taken place because of no API key.
<span class="label label-important label-danger">Fix</span> Resolved an issue with ampersands in Business details input fields.
<span class="label label-important label-danger">Fix</span> Resolved notice relating to not published text strings.



<h3>Jomres 9.8.6 07/07/2016</h3>

<span class="label label-important label-danger">Fix</span> Fixed an issue where installer wouldn't redirect properly, giving the impression that the upgrade had failed ( it hadn't, but the lack of redirection gave that impression ).


<h3>Jomres 9.8.5 06/07/2016</h3>

<span class="label label-warning">Change</span> Older Jomres logging retired in favour of monolog logging, introduced in 9.8.
<span class="label label-warning">Change</span> CORS support added to API
<span class="label label-warning">Change</span> Re-added Gmaps API key settings as it looks like Google are re-introducing them.
<span class="label label-warning">Change</span> Modified how we figure out some settings for router to help with searching by town names.
<span class="label label-warning">Change</span> Ensured that job->last_ran from cron jobs is set to an integer, because Rod's a weirdo.
<span class="label label-warning">Change</span> Modified date diff function so that years with 3 characters aren't parsed as valid dates.
<span class="label label-warning">Change</span> Modified fullscreen_view/jomres.php to require framework instead of alt init.
<span class="label label-warning">Change</span> Modified framework.php as occasionally if we're not on a Jomres page the all properties variable isn't set, so added it here.

<span class="label label-important label-danger">Fix</span> Closed a div in the suhosin check.
<span class="label label-important label-danger">Fix</span> Fixed some notices that appear related to user budget.
<span class="label label-important label-danger">Fix</span> Polish lang files converted back to utf8.


<h3>Jomres 9.8.4 23/06/2016</h3>

<span class="label label-warning">Change</span> Minor improvement to language handling in admin area.
<span class="label label-warning">Change</span> Performance improvements in admin area.
<span class="label label-warning">Change</span> List properties modified to improve paths.
<span class="label label-warning">Change</span> Show confirmation improved to calculate taxes for 3rd party plugin prices.
<span class="label label-warning">Change</span> Cleaned up cache related settings for Joomla cms_specific_urls.php
<span class="label label-warning">Change</span> Added checks for alt init plugin to Jomres fullscreen script.
<span class="label label-warning">Change</span> Changed how router.php finds region ids.
<span class="label label-warning">Change</span> Modified how an array element is checked to be empty in media centre images class.
<span class="label label-warning">Change</span> Farsi language file updated, thanks SorooshT.
<span class="label label-warning">Change</span> Property type related changes so that only published property types will show in the property type search dropdown.
<span class="label label-warning">Change</span> Modified property header og:url to point directly at the property details page.
<span class="label label-warning">Change</span> Replaced split with explode as split isn't available in php7.

<span class="label label-important label-danger">Fix</span> Fixed bug caused by apostrophes in currency conversion tooltip.
<span class="label label-important label-danger">Fix</span> Resolved an issue in media centre images when not logged in.
<span class="label label-important label-danger">Fix</span> Fixed a faulty path in functions.php error reporting.
<span class="label label-important label-danger">Fix</span> Added some missing language strings to en-US.php
<span class="label label-important label-danger">Fix</span> Resolved an edge-case issue where bookings might not show up in the dashboard due to notices.
<span class="label label-important label-danger">Fix</span> Fixed a javascript error on edit_my_account.html page.

<h3>Jomres 9.8.3 17/06/2016</h3>

<span class="label label-warning">Change</span> Removed optimise cron job from repository.
<span class="label label-warning">Change</span> Added property name to admin notification email RE approval.
<span class="label label-warning">Change</span> Changed how languages are pulled into framework.
<span class="label label-warning">Change</span> Added a check to view property to ensure that tariffs link isn't shown for Jintour properties.
<span class="label label-warning">Change</span> Improved jomres_properties.class.php, allows us to search on properties even when the first feature doesn't have text.
<span class="label label-warning">Change</span> Added initial changes for Joomla 3.6.
<span class="label label-warning">Change</span> Renamed library for Wordpress CMS bridging from wordpress3 to wordpress, as it's more accurate.
<span class="label label-warning">Change</span> Added link to ASAModule pages to Help section.

<span class="label label-important label-danger">Fix</span> Resolved an issue with media centre extras and room feature images.
<span class="label label-important label-danger">Fix</span> Corrected how "secret" is output for use by cronjobs.

<h3>Jomres 9.8.2 13/06/2016</h3>

<span class="label label-success">Feature</span> Added functionality that allows us to anonymously track usage information of Jomres. Must be manually enabled by Site Admin ( Opt-in, not Opt-out ).

<span class="label label-important label-danger">Fix</span> German language file fixed to remove a need for jr_config that isn't required.
<span class="label label-important label-danger">Fix</span> Significantly rewrote language file handling as it's started to give users problems in recent versions.
<span class="label label-important label-danger">Fix</span> Fixed issues with router causing problems with not routing properly.
<span class="label label-important label-danger">Fix</span> Fixed a typo in obsolete file handling RE old pclzip library.
<span class="label label-important label-danger">Fix</span> Added a tweak to basic property details to ensure that older installations html in property details is properly decoded.


<h3>Jomres 9.8.1 08/06/2016</h3>

<span class="label label-warning">Change</span> Modified show property calendar script so that output now can be passed to it and script can return the calendar if required.
<span class="label label-warning">Change</span> Simplified logic in jomres_media_centre_images
<span class="label label-warning">Change</span> Added more showtime settings to framework.php script.
<span class="label label-warning">Change</span> Custom Field functionality improved for performance.
<span class="label label-warning">Change</span> Modified framework to exit if we can't find the current CMS.
<span class="label label-warning">Change</span> Improved checks for tariffs so that they don't trigger a database error ( dobooking )
<span class="label label-warning">Change</span> Improved basic_contract_details class.

<span class="label label-important label-danger">Fix</span> Fixed a bug in jomSearch that prevented some searching by all regions.
<span class="label label-important label-danger">Fix</span> Fixed issue when showtime pui isn't set on non-jomres pages.

<h3>Jomres 9.8.0 03/06/2016</h3>

<span class="label label-success">Feature</span> This version introduces our new REST API functionality, which securely exposes the Jomres system to remote services. A new tab in the plugin manager will show all API related plugins.
<span class="label label-success">Feature</span> Much functionality moved into standalone classes. Both modernises some of the codebase, and gets functionality ready for introduction of a new Booking Engine later this year.
<span class="label label-success">Feature</span> Property type/room type handling updated to make it easier for managers to create both types and associate them with each other without errors when creating tariffs. Reduces the need to site admins to understand subtle nuances of how Jomres works internally.
<span class="label label-success">Feature</span> Error handling updated significantly.


<span class="label label-warning">Change</span> Removed "published" flag from proprety creation process in new properties class.
<span class="label label-warning">Change</span> Updated media centre images class to ensure that fallback images are always available.
<span class="label label-warning">Change</span> Improved system to make further use of new room types class.
<span class="label label-warning">Change</span> Added new "rooms" class.
<span class="label label-warning">Change</span> Removed default images from scripts as the media centre images class now offers fallback images properly.
<span class="label label-warning">Change</span> Dropped a redundant table.
<span class="label label-warning">Change</span> Performance enhancements to basic_property_details.class.php
<span class="label label-warning">Change</span> Modified response, data is now returned in an object->data and will reduce the number of response codes that a third party developer needs to respond to. Both clarifies and simplifies the response condition handling.
<span class="label label-warning">Change</span> Updated how normal mode tariffs are saved.
<span class="label label-warning">Change</span> Obsoleted several files.
<span class="label label-warning">Change</span> Modified API to ensure that all validated responses are returned in an envelope.
<span class="label label-warning">Change</span> Polish lang file updated, many thanks Patryk.
<span class="label label-warning">Change</span> Added ability to output_now or later to dashboard_insertbooking_ajax script.
<span class="label label-warning">Change</span> Added shortcodes documentation to Help section.
<span class="label label-warning">Change</span> Jomres about page updated.
<span class="label label-warning">Change</span> Added a require once for minor performance improvements.
<span class="label label-warning">Change</span> Guest type functionality updated to use new classes.
<span class="label label-warning">Change</span> Updated functionality to remove the need for gregoriantojd, fixed a couple of notices, and consolidated date diff functionality.
<span class="label label-warning">Change</span> Added caching to property types class.
<span class="label label-warning">Change</span> Changed Warning word to Todo in sanity checks, because that's less scary for managers.

<span class="label label-important label-danger">Fix</span> Modified invoice entering script to account for a notice level change.
<span class="label label-important label-danger">Fix</span> Fixed a notice on jintour properties.
<span class="label label-important label-danger">Fix</span> Removed a reference to $this that shouldn't have been there, replaced with thisJRUser.
<span class="label label-important label-danger">Fix</span> Added a check for an index before attempting to use it.
<span class="label label-important label-danger">Fix</span> Fixed some notice level issues that appear in the API on Wordpress.
<span class="label label-important label-danger">Fix</span> Updated functionality in add plugin script to ensure that 3rd party plugins can be installed.
<span class="label label-important label-danger">Fix</span> Tweaked the find manager script to fix a notice.
<span class="label label-important label-danger">Fix</span> Fixed a problem with room types class caching.
<span class="label label-important label-danger">Fix</span> Added a small tweak to jomres/classes/jomres_check_support_key.class.php to ensure closed Shop is handled without notice level errors.


<h3>Jomres 9.8.-1.1 24/05/2016</h3>

<span class="label label-warning">Change</span> Add site managers to swap currencies in site config, same as can be done in frontend config.
<span class="label label-warning">Change</span> Modified Normal mode tariff saving so that tariffs are saved with tariff type cross referencing, just like micromanage tariffs.
<span class="label label-warning">Change</span> Modified template handling so that override directories can have property type specific template files.
<span class="label label-warning">Change</span> Resized superior image slightly.
<span class="label label-warning">Change</span> Tweaked date output functionality to remove strtotime.
<span class="label label-warning">Change</span> Tidied up module and mambot installation functionality.

<span class="label label-important label-danger">Fix</span> Resolved a notice level issue in booking engine.
<span class="label label-important label-danger">Fix</span> Resolved notice level issues in J3.5 jomres_cmsspecific_getSearchModuleParameters
<span class="label label-important label-danger">Fix</span> Resolved some notice level issues in jomSearch.class.php
<span class="label label-important label-danger">Fix</span> Fixed an issue introduced by removing srp column.
<span class="label label-important label-danger">Fix</span> Added a check to the plugin installer to ensure we're not trying to re-create a directory.


<h3>Jomres 9.8.-1 23/05/2016</h3>

<span class="label label-success">Feature</span> Refactored Property Types and Room Type functionality, Now Property types determine which room types a property can have ( as before, but better ).

<span class="label label-warning">Change</span> Changed the minimum version that Jomres installer will run on to PHP 5.4.
<span class="label label-warning">Change</span> Azabaijani language file added to system. Thanks Hooman.
<span class="label label-warning">Change</span> Show plugins improved to warn of empty plugin data from remote server.
<span class="label label-warning">Change</span> Added a 08000 trigger before redirect to allow watchers to run on redirect.
<span class="label label-warning">Change</span> Added custom methods & logging of replies to API calls.

<span class="label label-important label-danger">Fix</span> Modified booking form date picker to resolve an issue where fixed period dropdowns caused a javascript error.
<span class="label label-important label-danger">Fix</span> Fixed an issue that would occasionally prevent the maps from showing.
<span class="label label-important label-danger">Fix</span> Modified Bootstrap 2 show property extras template to span the entire page instead of half.
<span class="label label-important label-danger">Fix</span> Fixed a bug with unzip path being wrong, and changed to use the built-in php zip archive when extracting Jomres.
<span class="label label-important label-danger">Fix</span> Fixed variables in show plugins that added an extraneous / to the path.

<h3>Jomres 9.8.-2 11/05/2016</h3>

<span class="label label-warning">Change</span> Added a condition so that we can show an error if an obsolete file couldn't be deleted.
<span class="label label-warning">Change</span> Moved API Core plugins to own tab
<span class="label label-warning">Change</span> Added ability to call Jomres framework via a class so that we can use existing functionality in the API, if required.
<span class="label label-warning">Change</span> Modified booking engine so that non-room based Jintour properties can also use coupons.
<span class="label label-warning">Change</span> Added a check for ZipArchive to Add Plugin script.
<span class="label label-warning">Change</span> Improved how paths are determined by API.
<span class="label label-warning">Change</span> Improved jr_user class to ensure that user id is set, means we can use more minicomponents (API/framework related)
<span class="label label-warning">Change</span> j06001dashboard_events_ajax.class.php modified to add output_now to component args, allows me to call the minicomponent in the API for easy use of the data it throws together.
<span class="label label-warning">Change</span> Modified API routes handling to allow for many more files in api features.
<span class="label label-warning">Change</span> Added a new class to validate property access through the db, instead of going through a new api call.
<span class="label label-warning">Change</span> Added a new call api class to Jomres core classes.
<span class="label label-warning">Change</span> Modified wording in edit resources scripts to make associating with room types more logical.
<span class="label label-warning">Change</span> Improved layout of BS2 create new property form.
<span class="label label-warning">Change</span> Improved delete property functionality, minor performance improvement.
<span class="label label-warning">Change</span> Improved sanity checks for tariffs.
<span class="label label-warning">Change</span> Changed how the validate scopes class is called.

<span class="label label-info">Wordpress</span> Improved a cms specific function for finding admin user's ids.

<span class="label label-important label-danger">Fix</span> Fixed a notice in media centre handler
<span class="label label-important label-danger">Fix</span> Fixed a minor bug where badges would show in control panel menu option when they shouldn't.
<span class="label label-important label-danger">Fix</span> Improved new router.php for Joomla functionality, older was giving bad results for more numbers in property uid.
<span class="label label-important label-danger">Fix</span> Tweaked news class to fix notices when couldn't get the latest version.

<h3>Jomres 9.8.-3 05/05/2016</h3>

<span class="label label-important label-danger">Alpha release</span> Be aware that this is an Alpha release of Jomres, so it is *not* considered ready for Production websites. Only install this version if you want to work with new functionality and help with testing updates.

<span class="label label-success">Feature</span> Added new API handling functionality to the core, which is designed to allow 3rd party platforms to communicate with Jomres to add, view, update and remove data remotely. Use of this new functionalty requires the API Core plugin, which allows registered users to create their own API Client keys. Once those keys have been created then Clients can access specially written functionality which is available from API Feature plugins, which are currently under development.

<span class="label label-warning">Change</span> Changed how errors are handled and viewed. This has resulted in considerable changes to Jomres Core and it's plugins to improve performance. Among other things, this has resulted in subtle reworkings to how language strings are handled.

<h3>Jomres 9.7.3 11/04/2016</h3>

<span class="label label-success">Feature</span> Added functionality to support Enhanced Property List Totals plugin.

<span class="label label-warning">Change</span> Modified the showTariffsLink setting in property details to use showTariffsInline instead.
<span class="label label-warning">Change</span> Added a check to dobooking so that if show extras is off, then they're not shown in the booking form.

<h3>Jomres 9.7.2 05/04/2016</h3>

<span class="label label-success">Feature</span> Modified Property type and Room type functionality to provide clearer relationships between property types and room types.
<span class="label label-success">Feature</span> Added warnings to System info and List Room types so that it's clear if a property type requires a room type.
<span class="label label-success">Feature</span> Added code to support trial licenses, which will use encoded versions of plugins so that new users can experiment with the system.

<span class="label label-warning">Change</span> Modified BS2 printable invoice template to make it friendly to pdfs too.
<span class="label label-warning">Change</span> Improved the property creation welcome message email functionality.
<span class="label label-warning">Change</span> Updated a localisation file to ensure that the dashboard works with Chinese languages.
<span class="label label-warning">Change</span> Removed some redundant code from queries.
<span class="label label-warning">Change</span> Tweaked usermanagement to ensure that a query isn't performed when in site admin as it's unnecessary.
<span class="label label-warning">Change</span> Modified two files to ensure they produce PHP7 ready classes in temporary files.

<span class="label label-important label-danger">Fix</span> Fixed a typo in language files where "frontend" was mis-spelled.


<h3>Jomres 9.7.1 22/03/2016</h3>

<span class="label label-success">Feature</span> Modified property list so that images are now shown as a slideshow ( manually triggered ). Looks damn nice too!
<span class="label label-success">Feature</span> Updated BS3 Edit property to provide some form validation and replace the older country selection with ajax country selection. Also improved layout of the form.

<span class="label label-warning">Change</span> Improved the Paging property listing functionality.
<span class="label label-warning">Change</span> Removed some old settings that are no longer relevant vis a vis search limitations.
<span class="label label-warning">Change</span> Modified top template so that property name area will not show if the user's not logged in. Prevents a blank row from showing.
<span class="label label-warning">Change</span> Added indication to reader of which template file it found a fatal error in.
<span class="label label-warning">Change</span> Moved chart templates from frontend to backend.
<span class="label label-warning">Change</span> Improved the jq ui dashboard.
<span class="label label-warning">Change</span> Editing mode dropdown changed to Label Editing Mode for clarity.
<span class="label label-warning">Change</span> Modified BS3 printable invoice template to make it friendly to pdfs too.
<span class="label label-warning">Change</span> Modified edit property to ensure it uses default terms and conditions text which was previously used in the property creation page.

<span class="label label-important label-danger">Fix</span> Removed javascript comment tags intended for validation as they break javascript in Edge.
<span class="label label-important label-danger">Fix</span> Fixed a bug in jq ui dashboard template

<span class="label label-info">Joomla</span> Added a missing check for Joomla 3.5
<span class="label label-info">Joomla</span> Modified how we detect the CMS version due to changes in how J3.5 version class is constructed.

<span class="label label-info">Wordpress</span> Added a warning to ensure that WP users are highlighted to the need for a page with jomres:xx-xx.

<h3>Jomres 9.7.0 15/03/2016 (Happy Birthday Ivan)</h3>

<span class="label label-success">Feature</span> Added new "Shop" functionality to the plugin manager. This allows users to purchase plugins direct through the plugin manager without needing to purchase a full license.

<span class="label label-warning">Change</span> Modified cancel guest booking script so that invoice is cancelled if they cancel the booking.
<span class="label label-warning">Change</span> Removed a few hardcoded strings and replaced them with language definitions.
<span class="label label-warning">Change</span> Renamed Tariff Model Averages to Variable, as that better describes it's function.
<span class="label label-warning">Change</span> Removed 100 property limit from property list as it no longer applies in modern Jomres.
<span class="label label-warning">Change</span> Tweaked dashboard for BS3 so that cancel bar is now sticky just above the bottom ( can't fix to bottom due to full-screen navbar ).

<span class="label label-info">Wordpress</span> Modified functionality so that correct password should be sent to newly created users.

<h3>Jomres 9.6.1 10/03/2016</h3>

<span class="label label-success">Feature</span> Added new functionality that allows us to add any Jomres definition to any template without declaring it in the calling script.

<span class="label label-warning">Change</span> Removed price from module popup contents as it's in the header.
<span class="label label-warning">Change</span> Added language support to new dashboard functionality.
<span class="label label-warning">Change</span> Removed a hard coded string from the list room types template.
<span class="label label-warning">Change</span> Modified dashboard scripts so that more dashboards can be used on the same page.
<span class="label label-warning">Change</span> Changed how date is output due to a bug in Joomla's functionality.
<span class="label label-warning">Change</span> Modified admin list properties to add link to reviews page for a property.
<span class="label label-warning">Change</span> Review requests removed from Administrator area.

<span class="label label-important label-danger">Fix</span> Fixed an issue in the new dashboard with a function not being defined.

<h3>Jomres 9.6.0 03/03/2016</h3>

<span class="label label-success">Feature</span> Dashboard signficantly upgraded. You can now drag/drop to change a booking's dates and room. You can drag a booking to increase/decrease it's length and the drag to cancel area is now clearly visable. 

<span class="label label-warning">Change</span> Modified booking form so that property uid is passed to the booking engine on heartbeat calls.
<span class="label label-warning">Change</span> Added "clear cache" to rebuild registry menu item.
<span class="label label-warning">Change</span> Removed a hardcoded version number for gmaps as google appear to have fixed their bug now.
<span class="label label-warning">Change</span> Modified how property uid is determined when deleting a property.
<span class="label label-warning">Change</span> Modified the printable invoice to include styles.
<span class="label label-warning">Change</span> Modified show property calendar so that asamodule parameters are sent properly.
<span class="label label-warning">Change</span> Added caveats to sanity checks to ensure that they're not run by non-managers.
<span class="label label-warning">Change</span> Google's recaptcha library updated.
<span class="label label-warning">Change</span> Modified how some data is saved in the support key cache file.
<span class="label label-warning">Change</span> Removed some growl output from booking engine.
<span class="label label-warning">Change</span> Modified how cron jobs are triggered.
<span class="label label-warning">Change</span> Review request timer set to 60 seconds from 120.
<span class="label label-warning">Change</span> Added a warning to advise people against upgrading if their license doesn't allow plugin installation.
<span class="label label-warning">Change</span> Polish language file updated.

<span class="label label-important label-danger">Fix</span> Modified booking form in property details tab so that availability calendar is properly opened.
<span class="label label-important label-danger">Fix</span> Fix for modal append to body.


<h3>Jomres 9.5.8 22/02/2016</h3>

<span class="label label-important label-danger">Fix</span> Fixed an issue with a cache file being saved in a way that causes errors.

<h3>Jomres 9.5.7 19/02/2016</h3>

<span class="label label-warning">Change</span> Added Tanzanian Schilling to currency codes class.
<span class="label label-warning">Change</span> Added checks to ensure if Property Name isn't set then user is redirected back to the registration page.
<span class="label label-warning">Change</span> Deligence added to our partner's list.
<span class="label label-warning">Change</span> Added donation buttons to license warning for us and Dog's Trust.
<span class="label label-warning">Change</span> Modified a pricing function to account for links from the jquery ui calendar.
<span class="label label-warning">Change</span> Added code to limit the number of decimal places in charts.
<span class="label label-warning">Change</span> Modified how new black bookings are saved as form action needs to be blank in some circumstances.
<span class="label label-warning">Change</span> Updated language files to say "Contact Yacht" instead of contact hotel.
<span class="label label-warning">Change</span> Renamed an ini file.
<span class="label label-warning">Change</span> Added functionality that pops the departure date picker up when the arrival date has been selected.
<span class="label label-warning">Change</span> Added support for no-plugin licenses.
<span class="label label-warning">Change</span> Modified the site singleton to prevent some notices from showing.
<span class="label label-warning">Change</span> Sanity check tweaked so that only one set of notices is shown if Tariff editing mode is Normal.
<span class="label label-warning">Change</span> Removed gmap sensor as it's depreciated.
<span class="label label-warning">Change</span> Modal popups replaced with direct links to properties. Modal code is still available, but commented out.

<span class="label label-important label-danger">Fix</span> Fixed an issue where FB urls wouldn't always work if SEF enabled.

<h3>Jomres 9.5.6 03/02/2016</h3>

<span class="label label-warning">Change</span> Enabled some new code that allows us to use shortcodes in templates directly, for example {jomres_shortcode show_property_map N&mh=231} will allow us to show a map anywhere in the template that we've determined.
<span class="label label-warning">Change</span> Added a new show_property_qr_code_directions script so that it can be called from anywhere.
<span class="label label-warning">Change</span> Changed the template that's shown when a property is added to the shortlist.
<span class="label label-warning">Change</span> Directions QR code added to property details template.
<span class="label label-warning">Change</span> Added the ability to send a map identifier to the map show script, that can be used instead of the random id tag.
<span class="label label-warning">Change</span> Added ability to pass the required label to the shortlist javascript function.
<span class="label label-warning">Change</span> Updated Property Header, added more useful buttons, move QR code into property details proper. Tweaked some layouts relating to these.
<span class="label label-warning">Change</span> Added a Boostrap Off sanity check to admin area.
<span class="label label-warning">Change</span> Removed "Haven't got any dates yet" checkbox, and added placeholders to generateDateInput.php function.
<span class="label label-warning">Change</span> Modified contact owner so that property header is shown if property uid is set.


<h3>Jomres 9.5.5 01/02/2016</h3>

<span class="label label-important label-danger">Fix</span> Fixed a bug where plugins could not be installed.

<h3>Jomres 9.5.4 29/01/2016</h3>

<span class="label label-warning">Change</span> Added a check for class_exists jomresPHPMailer
<span class="label label-warning">Change</span> Improved license warning output.
<span class="label label-warning">Change</span> Added license key check caching.

<h3>Jomres 9.5.3 27/01/2016</h3>

<span class="label label-warning">Change</span> Added a new modal that warns that you do not have a valid license in the plugin manager.

<span class="label label-important label-danger">Fix</span> Facebook tab filtering based on a wrong setting fixed.

<h3>Jomres 9.5.2 26/01/2016</h3>

<span class="label label-warning">Change</span> Added changes that remove some references to rooms when in an SRP, and renamed Resource type to Sub-type for SRPs.
<span class="label label-warning">Change</span> Tweaked layout of top.html
<span class="label label-warning">Change</span> Modified default property config to ensure that default Facebook page is blank so it doesn't show.
<span class="label label-warning">Change</span> Added a check to ensure that if the mailer exception class already exists, that it can't be created again.
<span class="label label-warning">Change</span> Improved the plugin manager to show most information in modals.
<span class="label label-warning">Change</span> By default, new sites will have Advanced config set to Yes.
<span class="label label-warning">Change</span> Modified map options so that zoom on scroll is off by default.
<span class="label label-warning">Change</span> Modified view property script and composite_property_details_notabs.html so that if the extras information isn't populated, the Extras panel isn't shown.

<span class="label label-important label-danger">Fix</span> Fixed facebook share page, wrong variable was used to get the property uid.
<span class="label label-important label-danger">Fix</span> Resolved a php warning message about an index not being set.
<span class="label label-important label-danger">Fix</span> Added manifest.xml to cms specific installation.

<span class="label label-info">Joomla</span> Improved how Jomres is added to Joomla component menus.

<span class="label label-info">Wordpress</span> Updated the Getting Started instructions for Wordpress users.


<h3>Jomres 9.5.1 21/01/2016</h3>

<span class="label label-warning">Change</span> Added a new jomres_cmsspecific_getcmslang() function to bridge scripts. This allows us to correctly discover Wordpress' current language and switch languages with WP.
<span class="label label-warning">Change</span> Removed session related code from new redirect function.
<span class="label label-warning">Change</span> Finally switched off Jomres language switcher now that CMSs are up to date with multi-language features.

<h3>Jomres 9.5.0 20/01/2016</h3>

<span class="label label-success">Feature</span> Property creation functionality removed from plugin library and re-added to the core system. Now "Free Core" users are able to add new properties too.
<span class="label label-success">Feature</span> Modified the booking engine to use discount codes when booking tours, if the property is a Jintour property.
<span class="label label-success">Feature</span> Following feedback post 9.4.0 release, property header improved by adding direct link to property details page to Property Name, and header text improved by making details scale better in small viewports.
<span class="label label-success">Feature</span> Added javascript to BS3 property header so tapping on the address _should_ open the address in a device's map app.
<span class="label label-success">Feature</span> Added facebook integration code, shows facebook like and share buttons under property header, and a new tab that holds a property facebook page output. New setting in Property Config -> Property details options tab allows input of FB page name.

<span class="label label-warning">Change</span> Modified show property features script so that it has a default option setting for $componentArgs[ 'show_feature_categories' ]
<span class="label label-warning">Change</span> Added some minor tweaks to property config tab layouts.
<span class="label label-warning">Change</span> Added an optional 01070 trigger for displaying after property header is output.
<span class="label label-warning">Change</span> Improved debugging of emailing functionality.
<span class="label label-warning">Change</span> Modified welcome email to use JOMRES_SITEPAGE_URL_NOSEF instead of JOMRES_SITEPAGE_URL for off-site links.
<span class="label label-warning">Change</span> Added some limits to DELETE functionality in deleteproperty class. They're pretty liberal, however.
<span class="label label-warning">Change</span> HTML purifier updated to 4.7
<span class="label label-warning">Change</span> Added download option of contract as ics to edit booking page.
<span class="label label-warning">Change</span> Added export of ics file to list bookings data.
<span class="label label-warning">Change</span> Added black booking flag to dashboard data returned via ajax.
<span class="label label-warning">Change</span> Added new Download common string to language files.
<span class="label label-warning">Change</span> Modified sanity checks to make the global editing mode warning more prominent.
<span class="label label-warning">Change</span> Global editing mode manual page link updated to new manual in language files.
<span class="label label-warning">Change</span> Updated the jomresRedirect function.
<span class="label label-warning">Change</span> Added a warning to plugin manager stating that you should upgrade Jomres before upgrading plugins.
<span class="label label-warning">Change</span> Improved control panel to add a check for max_get_vars value which, if limited, can affect the effectiveness of the table tools ajax.
<span class="label label-warning">Change</span> Updated several language files to swap Resource for Room

<span class="label label-important label-danger">Fix</span> Fixed an incorrect column id in delete property script for jintour properties.
<span class="label label-important label-danger">Fix</span> Fixed an incorrect task name in property registration forms for BS2 and jquery ui.
<span class="label label-important label-danger">Fix</span> Modified list properties so that featured listings no longer always have the "primary" class, meaning that if they're over budget, their class will now be set to over budget.
<span class="label label-important label-danger">Fix</span> Changed how the mailer is determind from the host CMS's settings.

<span class="label label-info">Joomla</span> Added a check for params in the menu option for Jomres in Joomla. If it doesn't exist, we'll add a new menu entry. This counteracts a new change to J3.4.8-ish where older menu options seem to go missing after upgrading Jomres.

<span class="label label-info">Wordpress</span> Renamed class.pop3.php and class.smtp.php files and classes to get around problems with Wordpress throwing errors.


<h3>Jomres 9.4.0 12/01/2016</h3>

<span class="label label-success">Feature</span> Made a number of changes that add a cover to the property header based on the Main property image, added some more elements of interest to guests such as property features, and updated rich snippets so that they validate and we add price + hidden short description.
<span class="label label-success">Feature</span> Added an option to allow property managers to swap the location of the currency symbol in price outputs.

<span class="label label-warning">Change</span> Property header modified to have Add to Favourites ajax icon, so most guest facing pages will benefit from this feature, not just the property lists.
<span class="label label-warning">Change</span> Modified some language strings from Availability Cal. to Calendar as will be used in the booking form.
<span class="label label-warning">Change</span> Modified booking form so that the large calendar is passed back to the dobooking script, instead of output immediately, and the calendar is now in a modal that can be triggered through a button. MRP, Bootstrap 3 only.
<span class="label label-warning">Change</span> Modified view favourites to filter out 0 value array elements.
<span class="label label-warning">Change</span> Term "shortlist" renamed to "favorites".
<span class="label label-warning">Change</span> Tweaked functionality to ensure that if a service is added to a bill, then the bill is marked again as unpaid.
<span class="label label-warning">Change</span> Added Capterra review page link to various administrator area pages.
<span class="label label-warning">Change</span> Improved month short strings in german lang file.
<span class="label label-warning">Change</span> Added ( commented ) agent link calling to property header script.
<span class="label label-warning">Change</span> Added a check to dobooking to ensure that if there are no future tours, guests are redirected to the contact owner form.
<span class="label label-warning">Change</span> Added a check so that Tour type properties wouldn't trigger errors when the booking form is opened.
<span class="label label-warning">Change</span> Added a switch to show_property_features to allow a calling script to disable showing of property feature categories.
<span class="label label-warning">Change</span> Modified property header to show Instant Booking or Booking on Request flags in header.
<span class="label label-warning">Change</span> Added a small tweak to define :::1 as 127.0.0.1 for IP recording reasons.

<span class="label label-important label-danger">Fix</span> Added a small tweak to ensure that chart options with one option are still shown as a dropdown.
<span class="label label-important label-danger">Fix</span> Removed an element from show_property_reviews.html that was preventing micro data from validating.


<h3>Jomres 9.4.-1 05/01/2016</h3>

<span class="label label-warning">Change</span> In List Properties, if the number of property uids = 0, then do nothing. Minor tweak.
<span class="label label-warning">Change</span> Modified calendar month output to account for non-Latin characters. Thanks Nikos.
<span class="label label-warning">Change</span> Tweaked list properties so that if Visitors can book online option is set to No, then Booking On Request is shown instead of the "Instant booking" image overlay.
<span class="label label-warning">Change</span> Added a new show_property_room_types_srp.html template to improve output of SRP property type output in Preview page.
<span class="label label-warning">Change</span> Updated Sanity checks to only show Publish option when other requirements have been met.
<span class="label label-warning">Change</span> Added a 500 record limit to booking data archive script.
<span class="label label-warning">Change</span> Added rel nofollow to calendar links.
<span class="label label-warning">Change</span> Improved manager handling so that a manager user with no properties is reverted back to a non-manager user for security reasons. This is better than simply throwing a fatal error.
<span class="label label-warning">Change</span> Added a new User Feedback function and supporting scripts. Sanity checks are great, but they don't need to be run every time a non-manager user access the page, however we sometimes need to provide feedback to non-manager users ( for example the previous changeset improves how managers with no properties are handled, however there was no reliable way to provide feedback to this user ). Enter, the new "set_user_feedback_message" function.
<span class="label label-warning">Change</span> Added Contact Us string to language files.
<span class="label label-warning">Change</span> Contact Owner script modified to send emails direct to site admin ( using email address set in Site Config -> Your Business Details ) if property uid = 0 to give new property managers a direct link to contact site managers.
<span class="label label-warning">Change</span> Added new language strings to Jomres pertaining to post-property creation emails.
<span class="label label-warning">Change</span> My favourites menu option modified so that property managers can tag a property as a favourite too.
<span class="label label-warning">Change</span> Improved new charting code to show multiple year datasets properly.
<span class="label label-warning">Change</span> Tweaked CMS specific urls to ensure that the site is forced to fullscreen view if the Is Wrapped setting is used.
<span class="label label-warning">Change</span> Added a Jintour Sanity check.
<span class="label label-warning">Change</span> Disabled audit logging, it's not used and unloved.
<span class="label label-warning">Change</span> Disabled audit logging, it's not used and unloved.
<span class="label label-warning">Change</span> Modified Top Level language files to use property specific language strings. Whilst Jomres is capable of managing anything that's booked by the day, 95% of our users are using it for property rental, and having "business" specific language strings is confusing to our users.
<span class="label label-warning">Change</span> Modified the installer to automatically apply upgrades, and then redirect to the administrator area when the autoupgrade flag is set.
<span class="label label-warning">Change</span> Tweaked javascript so that live scolling code isn't triggered in administrator area.

<span class="label label-important label-danger">Fix</span> Added a check to see if the property is a Jintour property, before checking to see if rooms and/or tariffs are available and sending the guest to the contact form if they're not ( as Jintour properties don't have these ).
<span class="label label-important label-danger">Fix</span> Fixed an issue in cms_specific_urls.php for J3.4, j3.5 & wp where the jrConfig setting becomes unset incorrectly, which breaks the Is Wrapped setting ( which forces the Jomres output into fullscreen mode ).
<span class="label label-important label-danger">Fix</span> Fixed a small issue where the Support Tickets page in administrator would throw warnings when used in administrator areas that use https.
<span class="label label-important label-danger">Fix</span> Added a missing multiplier for showing prices per week/month in show tariffs page.
<span class="label label-important label-danger">Fix</span> Tweaked booking insertion code to ensure that if it's a quick booking, then an id is set to an integer.
<span class="label label-important label-danger">Fix</span> Modified checkArrivalDate method to ensure that managers are able to make bookings before the Min Days Before Arrival option kicks in.
<span class="label label-important label-danger">Fix</span> Fixed an issue in installer where `service_qty` column was not being added on installation.


<h3>Jomres 9.4.-3 18/12/2015</h3>

<span class="label label-success">Feature</span> Modified property creation process, drastically reducing the time required to create a new property. Added a number of new sanity checks that will guide the user when creating a new property.

<span class="label label-warning">Change</span> Added Tajikisan Somani to currency codes.
<span class="label label-warning">Change</span> Further improved search functionality related to translated town searches.
<span class="label label-warning">Change</span> Changed site config so that email password input is a password input.
<span class="label label-warning">Change</span> Added tweaks to new user email that's sent, adding carriage returns.
<span class="label label-warning">Change</span> Modified the user budget so that only 10 price ranges are found. Prevents memory errors caused by a wide disparity of different prices.

<span class="label label-important label-danger">Fix</span> Added an option to honour the old "availability calendar off" switch, to new code.
<span class="label label-important label-danger">Fix</span> Tweaked a script so that if the "Show availability calendar inline" setting is off, then the calendar is also not shown in the booking form page.
<span class="label label-important label-danger">Fix</span> Resolved an intermittent issue we discovered from error reports from the userdemo. If search results are 0 before the availability search is performed, we didn't check to see if there uids available returned by other searches. If there are already no results found, we were still doing the availability search, which wasn't ok.
<span class="label label-important label-danger">Fix</span> Solved a weird bug in how the qr code class includes it's library files. For an unknown reason class_exists returned true when it should false, resulting in fatal errors with "Call to undefined method QRcode::png()". Making the class a singleton fixed the issue.

<h3>Jomres 9.3.1 14/12/2015</h3>

<span class="label label-success">Feature</span> Added support for exporting bookings as iCal files ( new plugin in plugin manager ) via the Bookings list.

<span class="label label-warning">Change</span> Polish language file updated, thanks Patryk.
<span class="label label-warning">Change</span> Added "reviewed item" to review snippets and associated templates.
<span class="label label-warning">Change</span> Improved query used for searching town names.

<span class="label label-important label-danger">Fix</span> Fixed a bug that caused the dashboard new booking functionality to not work.
<span class="label label-important label-danger">Fix</span> Modified the agent plugin so that it doesn't output that no agent information is available if it's not. 
<span class="label label-important label-danger">Fix</span> Added a missing class for the SRP calendar legend.
<span class="label label-important label-danger">Fix</span> Fixed a bug in templates that prevented multiple years from showing correctly. (New charting functionality )

<h3>Jomres 9.3.0 09/12/2015</h3>

<span class="label label-success">Feature</span> Added a feature to allow extra services to have quantities ( mainly as a feature request from Marhinio ).
<span class="label label-success">Feature</span> Added the foundation of new Partner related functionality. Allows a user who is defined as a partner to make bookings on behalf of third parties.
<span class="label label-success">Feature</span> Added functionality that allows us to limit which optional extras to show based on room types of rooms already selected. 
<span class="label label-success">Feature</span> Added new availability calendars, which are improved and tidied up versions of the older calendars. These babies are much easier to maintain than the older code. Existing MRP and SRP calendars will be left in-place as we're aware that site users have made significant use of the older calendars and simply removing them will potentially detrimentally affect these users on upgrade. Delivering both side-by-side for a period of time will give those users a chance to change their code to take advantage of the new, improved ones.

<span class="label label-warning">Change</span> Added commented out property image code to module_popup script.
<span class="label label-warning">Change</span> Hid the javascript caching setting until we can rework the feature.
<span class="label label-warning">Change</span> Changed the item we're searching for when doing an upgrade, to see if we're upgrading or installing for the first time.
<span class="label label-warning">Change</span> Added username to Profile Edit page.
<span class="label label-warning">Change</span> Tweaked datatable javascript so that default ordering is descending ( i.e. new stuff at the top of tables by default )
<span class="label label-warning">Change</span> Modified booking confirmation page to clarify what's a booking, and what's a booking request.
<span class="label label-warning">Change</span> Added a tweak to SRP availability calendar for when room uid isn't sent in the component args variable.
<span class="label label-warning">Change</span> Modified the  confirmation page to use the JOMRES_ROOT_DIRECTORY variable when building the path to gateway images.
<span class="label label-warning">Change</span> Added functionality that allows us to anonymously track Jomres usage. Feature is disabled by default, and it's not currently enabled as we need to figure out how/if we're going to use it.
<span class="label label-warning">Change</span> Modified several items so that they are shown by default, not when Advanced Site Config is enabled.
<span class="label label-warning">Change</span> Modified the list invoices ajax task to not show the Pay Now button if the booking hasn't been approved yet.
<span class="label label-warning">Change</span> Removed some superfluous periods from language files.
<span class="label label-warning">Change</span> Added functionality to record page views for use by stats functionality that's under development ( not related to anon jomres usage tracking ).
<span class="label label-warning">Change</span> Added ability for us to pass a referrer to the booking contract.
<span class="label label-warning">Change</span> Added a missing check for the secret when running the invoice cron job.
<span class="label label-warning">Change</span> Modified dashboard script to order rooms by room number first, then room name.
<span class="label label-warning">Change</span> Added a new show_property_calendar script for the benefit of shortcode lovers, and updated existing scripts to ensure sufficient validation is done of the user to ensure only allowed users can see new scripts.
<span class="label label-warning">Change</span> Increased timetout calls for cron jobs, and added places where cron functionality is called. This should allow cron stuff to happen more often.


<span class="label label-important label-danger">Fix</span> Added fixes for javascript showing when editing mode enabled in calendar and backend property list.
<span class="label label-important label-danger">Fix</span> Updated an error log message for send admin email newbooking to ensure that the email address is reported correctly.
<span class="label label-important label-danger">Fix</span> Fixed the cron job class to return null, not some nonsense data.

<span class="label label-info">Wordpress</span> Changed editinplace functionality to use a different input name to resolve issues found on some servers.
<span class="label label-info">Wordpress</span> Re-added some older globals that are used in wp

<h3>Jomres 9.2.2 11/11/2015</h3>

<span class="label label-success">Feature</span> Added Joomla 3.5 related changes. 

<span class="label label-warning">Change</span> Improved buttons/language strings so that Booking Enquiry related functionality is more logical.
<span class="label label-warning">Change</span> Modified edit resource as SRP room type was missed in last version.
<span class="label label-warning">Change</span> Added email obfuscation to view_agent page.
<span class="label label-warning">Change</span> Minor fix added to jr gettext to prevent some variables being added to urls.
<span class="label label-warning">Change</span> Improved bootstrap multiselect css.
<span class="label label-warning">Change</span> Changed some forms to use JOMRES_SITEPAGE_URL_NOSEF instead of JOMRES_SITEPAGE_URL.

<span class="label label-important label-danger">Fix</span> Added some changes to room type output that went missing after a script change.
<span class="label label-important label-danger">Fix</span> Fixed a bug where modal terms wasn't available to noroom bookings, and reduced the size of the button so that it's not confused with the Completion button.
<span class="label label-important label-danger">Fix</span> Tweaked view property page to not show book now button if is a real estate listing.

<span class="label label-info">Wordpress</span> Updated the editinplace functionality. Wordpress doesn't like it when you use "name" as a POST variable and returns 404 ( Seriously, WP? ) so edited editinplace to not do that.
<span class="label label-info">Wordpress</span> Modified the WP initialisation script to not show an error as the setting is NA in WP.
<span class="label label-info">Wordpress</span> Fixed an issue where some WP installations would throw a 404 error when saving normal tariffs.


<h3>Jomres 9.2.1 05/11/2015</h3>

<span class="label label-success">Feature</span> Added a new tab to site configuration called Contact settings. From here you can (optionally) override all properties contact details (email, phone, fax) so all communication with guests will be sent to you and not to the property owners. Property owners are free to add contact information to email templates that are sent after bookings are taken, but prior to that, all communications must go through the site administrators. This should prevent property owners depriving site managers of booking commission by taking bookings offline.

<span class="label label-warning">Change</span> Tweaked sanity check to not show on edit resource page.
<span class="label label-warning">Change</span> Added "Email templates" string to lang files and ensured that the correct call is used when building menus.
<span class="label label-warning">Change</span> Modified get_plugin_settings function to use override option from admin edit gateways area.
<span class="label label-warning">Change</span> Added checks to frontend property config gateway code to see if override is set to Yes. If so, settings for that gateway aren't shown.
<span class="label label-warning">Change</span> Tweaked insertbooking invoice script so that initial status is Pending in most cases. Previously, with deposits disabled, the status would be 0 with precluded further payments.
<span class="label label-warning">Change</span> Many thanks Patryk for your Polish language contributions.
<span class="label label-warning">Change</span> Modified ui availability calendar to use get_showtime property uid variable if available, as last resort.


<span class="label label-important label-danger">Fix</span> Fixed a bug where the calendar would not show if Show Only Avl Calendar option was set to yes in property config.
<span class="label label-important label-danger">Fix</span> Fixed review site text so that the correct urls are shown dependant on the CMS.
<span class="label label-important label-danger">Fix</span> Resolved issue where wrong Active setting was seen in admin list gateways.
<span class="label label-important label-danger">Fix</span> Improved new property type switching functionality.
<span class="label label-important label-danger">Fix</span> Fixed an issue when finding payment gateways. If the gateway was set to override then the correct gateway settings couldn't be found.

<span class="label label-info">Wordpress</span> Changed the Save hotel settings form action so that it doesn't trigger 404 errors in WP

<h3>Jomres 9.2.0 23/10/2015</h3>

<span class="label label-success">Feature</span> Rewrote how the property details page is built, retired older viewproperty and composite property details scripts as they were ugly. Replaced by more flexible 06000 scripts. We've identified a strong need for single property site developers to be able to include various sections of the Jomres output in pages independently of the main Jomres plugin. This allows them to configure their property in one place ( Jomres itself ) and for the output to be mirrored in numerous pages of their choosing. 
<span class="label label-success">Feature</span> Added new functionality to Jomres to allow users to switch a property between MRPs and SRPs. Requires addition of scripts that'll create the invisible room. Normal Tariff Editing mode does it already, however Advanced/Micromanage didn't, which could prove confusing, therefore added scripts that are referred to in the Sanity Checks and linked to if vital data is missing. With the introduction of the Single Property Wordpress Quickstart, we realised that some users would want to switch a property from MRP to SRP or vice versa. Rather than produce two Quickstarts it made sense to re-introduce this functionality and improve how it works.
<span class="label label-success">Feature</span> Added Farsi language file, thanks Soroosh. Files have been visually checked and a few issues resolved, however we can't find a Farsi language file for J3.x so haven't been able to definitively confirm that it's working. Please let us know if you have any issues with it.

<span class="label label-warning">Change</span> Added a tweak so that the control panel will attempt to create a missing working directory before checking it for writability.
<span class="label label-warning">Change</span> Added mambot parsing code for use in templates for testing. (Currently disabled while we determine if we can use it)
<span class="label label-warning">Change</span> Added a function to make it easy for scripts to tell if users should be viewing snippets.
<span class="label label-warning">Change</span> Added a check for CURL before trying to call partners servers for plugin lists.
<span class="label label-warning">Change</span> Added a way to not show property header via a switch in the url.
<span class="label label-warning">Change</span> Added a small plugin to show property description on it's own if required.
<span class="label label-warning">Change</span> Removed rooms slideshow from rooms list, as it's already a separate plugin which can be called independently.
<span class="label label-warning">Change</span> Updated Polish lang file, many thanks Patryk.
<span class="label label-warning">Change</span> Added new functionality related to domain name binding.
<span class="label label-warning">Change</span> Improved license failure output messages and added a new message to the Misc tab in Site Config if the license isn't valid. This is just for user information.
<span class="label label-warning">Change</span> Added new definitions to language files.
<span class="label label-warning">Change</span> Added functionality that allows us to have a search different search template for Single Property sites.
<span class="label label-warning">Change</span> Changed default map width and height to 300.
<span class="label label-warning">Change</span> Added a check for a flag in $_REQUEST. If found we will show the last set of search results. ( list properties )
<span class="label label-warning">Change</span> Added a check to see if the JomresRouter class doesn't already exist.
<span class="label label-warning">Change</span> Added a check to see if a language file exists before trying to include it if the file was added by a developer.
<span class="label label-warning">Change</span> Removed superfluous periods from language files, thanks JK.
<span class="label label-warning">Change</span> Removed an un-necessary section of code in contactowner script.
<span class="label label-warning">Change</span> Tweaked the currency codes class to show currency codes if the open exchange rates api key isn't set.
<span class="label label-warning">Change</span> Updated a language string that refers to the different license packages in Jomres.
<span class="label label-warning">Change</span> Added more information to the No Room Types warning in Normal Tariff editing mode script.
<span class="label label-warning">Change</span> Modified system so that Manager's menus will still show after an error is thrown.
<span class="label label-warning">Change</span> Added a check for a null value in the media centre class.

<span class="label label-important label-danger">Fix</span> Fixed issues where optional extras weren't showing the correct currency codes.

<span class="label label-info">Wordpress</span> Added fixes so that internal update feature can be used on WP
<span class="label label-info">Wordpress</span> Added a check to see if the web installer has been left inside the wp-content/plugins/jomres directory. If it has, we'll remove it.
<span class="label label-info">Wordpress</span> Fixed an issue where some smtp settings weren't being set correctly in WP
<span class="label label-info">Wordpress</span> Wordpress Added changes related to sef/permalinks.
<span class="label label-info">Wordpress</span> Tweaked page and action to ensure that they're defined variables if not previously set.
<span class="label label-info">Wordpress</span> wp jomres.php modified to tally with that on wp.org (svn)
<span class="label label-info">Wordpress</span> Tweaked the query that searches for [jomres] in WP posts to find pages with [jomres] in to determine the page ID because javascript editors can add html to the page and make the query fail, thereby breaking the ajax in the dashboard calendar.
<span class="label label-info">Wordpress</span> Updated Wordpress files to negate some NOTICE warnings.
<span class="label label-info">Wordpress</span> Add defined('WPINC') or die; to WP specific scripts. Yay!


<h3>Jomres 9.1.6 13/10/2015</h3>

<span class="label label-warning">Change</span> Applied a minor correction to how the availability calendar is called to make sure the trigger number is correct in case we change how the mcHandler class works in the future.
<span class="label label-warning">Change</span> Tweaked how Jomres figures out which bootstrap flavour to use in the administrator area.
<span class="label label-warning">Change</span> Modified Show Confirmation page in BS3 to show terms and conditions as a modal.
<span class="label label-warning">Change</span> Added some default terms and conditions to language files.
<span class="label label-warning">Change</span> Added a new show property room types 06000 script, removed some redundant and no longer working room feature and room type code from property header and replaced with new code to output the modern data.
<span class="label label-warning">Change</span> Added a variety of changes that allow us to have a search "widget" for Wordpress too, which is in addition to the existing ajax search functionality.
<span class="label label-warning">Change</span> Tweaked date inputs to ensure that they can't be manually entered.
<span class="label label-warning">Change</span> Updated booking data archive template to use new tabletools functionality.
<span class="label label-warning">Change</span> Added a check for no room types for this property type mrp/srp combination and will throw an error if there's an issue. New functionality in the property creation script will prevent users from creating for example Cottages as MRPs, so these two changes together should prevent people from generating this kind of issue.
<span class="label label-warning">Change</span> Removed a definition of MRP/SRP that should have been a dynamically added string.
<span class="label label-warning">Change</span> Removed some obsolete javascript files.
<span class="label label-warning">Change</span> Obsoleted jLabels javascript file, removed references from templates.
<span class="label label-warning">Change</span> Obsoleted an old jgrowl css file.
<span class="label label-warning">Change</span> Updated data tables templates code in cron and access control templates.
<span class="label label-warning">Change</span> Added a call to a file in case site config needs to be adjusted via frontend scripts.
<span class="label label-warning">Change</span> Modified saveSiteConfig function so that it doesn't redirect if there are some overrides set.
<span class="label label-warning">Change</span> Added a new 06000 script "property_details" that allows us to call Jomres via the asamodule mambot.
<span class="label label-warning">Change</span> Added ability for script to check for "property_uid" as well as "id" in the url (module_popup)
<span class="label label-warning">Change</span> Tweaked contact owner script to accept property_uid in the url.
<span class="label label-warning">Change</span> Audit functionality will be disabed by default.
<span class="label label-warning">Change</span> Javascript caching tweaked to not include datatables.
<span class="label label-warning">Change</span> Added an older datatables file to the obsolete files list.
<span class="label label-warning">Change</span> Retired the jQuery Growl popups, they don't work well on mobile devices so instead the previous messages are output to the next page shown.
<span class="label label-warning">Change</span> Joined several javascript and css files together, they're very rarely changed so lumping them together will give us a small overall speed improvement.
<span class="label label-warning">Change</span> Updated the Property registration templates to improve validation of the form.
<span class="label label-warning">Change</span> Javascript caching feature disabled temporarily as we have doubts about it's effectiveness. This will be reworked for the next version.


<span class="label label-important label-danger">Fix</span> Fixed an issue where the payment reference class was looking for a contract uid where sometimes it didn't exist.
<span class="label label-important label-danger">Fix</span> Modified the integrated search template to use a SEF url.
<span class="label label-important label-danger">Fix</span> Added fix to new code to ensure that buttons in datatables don't overlap.
<span class="label label-important label-danger">Fix</span> Added a tweak to the version of Gmaps we call to see if that fixes an intermittent problem that they seem to be having with their v3.22 version of G maps.

<span class="label label-info">Wordpress</span> Added functionality to Jomres patTemplate reader to use Template overrides in Wordpress as well as Joomla.
<span class="label label-info">Wordpress</span> Added more template override classes for wordpress to minicomponent_registry.class.php
<span class="label label-info">Wordpress</span> Added a variety of changes that allow us to have a search "widget" for Wordpress too, which is in addition to the existing ajax search functionality.
<span class="label label-info">Wordpress</span> Added more changes to the Jomres WP bridging code which are mostly javascript related.
<span class="label label-info">Wordpress</span> Figured out how to drop the administrator area JQ UI templates, and switch Wordpress users over to use bootstrap in the Jomres administrator area. You lucky, lucky bunnies.
<span class="label label-info">Wordpress</span> Tweaked the Fullscreen version of the Jomres bootstrap wrapper .less file.
<span class="label label-info">Wordpress</span> Added tweaks to wordpress related files to resolve animation issues.

<h3>Jomres 9.1.5 30/09/2015</h3>

<span class="label label-warning">Change</span> Re-added some css classes that had previously been removed.
<span class="label label-warning">Change</span> Added a triple check for file creation before site settings table is removed.
<span class="label label-warning">Change</span> Modified functionality so that javascript cache files are rebuilt on rebuild registry or save site config.
<span class="label label-warning">Change</span> Removed an icon from a template.

<span class="label label-info">Wordpress</span> Improved the WP bridging functionality. Good work Aladar.
<span class="label label-info">Wordpress</span> Modified how the jomres_template_version javascript variable is generated because it's possible to have non-BS in the admin area, and BS in the frontend ( Wordpress ).
<span class="label label-info">Wordpress</span> Added more Wordpress related tweaks to do with script registration/deregistration.
<span class="label label-info">Wordpress</span> Fixed a large whitespace problem in jq ui admin area.
<span class="label label-info">Wordpress</span> Added widget related functionality to ensure that Jomres javascript/css files are loaded when needed.

<span class="label label-important label-danger">Fix</span> Added code to check for errors in JShrink and automatically disable javascript caching if they arise. A number of users have been seeing "Unclosed regex pattern at position:" errors when trying to use any page with Jomres on it. We THINK that this is related to the new Table Tools implementation in the previous version of Jomres, and the javascript minification functionality of JShrink. This fix will detect the error and automatically switch off the minification feature in the site settings, then re-direct the user to the same page again effectively making the error invisible to users. Admins will also receive a message saying that this has been done.

<h3>Jomres 9.1.4 27/09/2015</h3>

<span class="label label-success">Feature</span> Updated datatables to the most recent version.

<span class="label label-warning">Change</span> Modified the calendar icon in BS3 so that it's clickable ( Cheers Allan ).
<span class="label label-warning">Change</span> Added more translation functionality to room features.
<span class="label label-warning">Change</span> Upadated the link to the manual to point to the new manual.

<span class="label label-important label-danger">Fix</span> Resolved a few Strict errors.
<span class="label label-important label-danger">Fix</span> Removed a reference to adobe_mktime that was added way back in the dark mists of time, when dinosaurs ( PHP4 ) ruled the earth.
<span class="label label-important label-danger">Fix</span> Solved an obscure bug with guest types and amending bookings.
<span class="label label-important label-danger">Fix</span> Fixed an incorrect url used when filtering invoices in administrator area.
<span class="label label-important label-danger">Fix</span> Fixed an incorrect placeholder in edit_guest.html template. Thanks Nikos.
<span class="label label-important label-danger">Fix</span> Resolved an issue where recent changes would trigger issues with modal common strings.
<span class="label label-important label-danger">Fix</span> Resolved a really obscure issue with Wiseprice and PPPN invoices not showing the correct figure in invoices.
<span class="label label-important label-danger">Fix</span> Modified the cancel booking url
<span class="label label-important label-danger">Fix</span> Fixed some javascript that's prevented gmaps from showing in fullscreen since Google changed a url.
<span class="label label-important label-danger">Fix</span> Jquery UI css files updated.
<span class="label label-important label-danger">Fix</span> Added a check for NULL when building room types, because, you know, Peter.

<span class="label label-info">Wordpress</span> Added a tweak to WP to check for a server variable used by Page Builder when saving data through ajax, although this may need more investigation.
<span class="label label-info">Wordpress</span> Updated the Jomres fullscreen for Wordpress.


<h3>Jomres 9.1.3 17/08/2015</h3>

<span class="label label-success">Feature</span> Dashboard templates updated to add periodic update of dashboard so that new bookings are added in almost-realtime.
<span class="label label-success">Feature</span> Added new functionality to allow undoing of checking in/out guests.

<span class="label label-warning">Change</span> Tweaked how new override changes are implemented so that managers can see the deposit price too.
<span class="label label-warning">Change</span> Changed how wiseprice discount is displayed in invoice line items.
<span class="label label-warning">Change</span> Improved how ampersands are rendered in Optional Extras.
<span class="label label-warning">Change</span> Added checks to payment reference class to check for overriding of the PP gateway, plus added the booking number to the invoice object that's passed to the gateway.
<span class="label label-warning">Change</span> Gmaps changes. Most layers except transit and POIs removed from Gmaps, so options removed from Jomres site config and associated template files. URL fixed too.
<span class="label label-warning">Change</span> Added ability for site admins to see invoices that haven't yet been issued to property managers. Typically subscription/commission invoices.
<span class="label label-warning">Change</span> Tweaked css caller to ensure datatables css file is loaded if the user is registered.
<span class="label label-warning">Change</span> Added fixed width and height of room type images in site structure.
<span class="label label-warning">Change</span> Small layout tweak to BS3 dobooking room features.
<span class="label label-warning">Change</span> Removed room features tooltips from BS2 dobooking template to improve layout.
<span class="label label-warning">Change</span> Modified View Agent functionality to improve how agent information is displayed, added ability to call the script from another script via REQUEST, componentArgs or directly.
<span class="label label-warning">Change</span> Modified payment reference class to include the payers address in the invoice object as passed to gateways.

<span class="label label-important label-danger">Fix</span> Fixed an sql error that sometimes appears.
<span class="label label-important label-danger">Fix</span> Fixed a bug that was preventing second guest types from being selected when amending a booking.


<h3>Jomres 9.1.2 28/07/2015</h3>

<span class="label label-warning">Change</span> Added code to add a diagonal line to the old SRP availability calendar to denote cross-over days.
<span class="label label-warning">Change</span> Tweaked BS3 booking form, moved Coupon and Price override panels to beside the guest input area.
<span class="label label-warning">Change</span> Improved Agent image and gateway icon output in property list BS3.
<span class="label label-warning">Change</span> Improved Classic rooms list output, adding per night, per week etc notification next to price.
<span class="label label-warning">Change</span> Removed ini set of memory as we would prefer this to be set via php.ini etc.
<span class="label label-warning">Change</span> Tweaked patTemplate reader to ensure that sites with > 4 Jomsearch mN modules can also override their template files.
<span class="label label-warning">Change</span> Modified booking engine so that option extras are only reloaded via ajax when the dates in the booking have changed.
<span class="label label-warning">Change</span> Improved how the ajax url is generated to be used in the dashboard.
<span class="label label-warning">Change</span> Changed the booking engine to ensure that optional extra prices are re-calculated at a different point.
<span class="label label-warning">Change</span> Changed booking engine to override deposit to 0, and make sure that the deposit overridden isn't greater than the grand total.
<span class="label label-warning">Change</span> Updated show confirmation pages to not show gateway output if no gateways configured.
<span class="label label-warning">Change</span> Updated Polish language file. Many thanks Patryk.
<span class="label label-warning">Change</span> Removed smoking and disabled access functionality from room details. With the full implementation of Room Features these features are now no longer required.

<span class="label label-important label-danger">Fix</span> Fixed an erroneous "hack attempt" error that Jomres would report on Jintour properties.
<span class="label label-important label-danger">Fix</span> Fixed a PDO error reported when submitting a booking and tariffs don't exist for jintour properties.
<span class="label label-important label-danger">Fix</span> Found an errant space broke a bold tag in the spanish language file.
<span class="label label-important label-danger">Fix</span> Fixed a link to Max Input Vars link that broke when we updatd the ticket system.
<span class="label label-important label-danger">Fix</span> Tweaked new functionality that wasn't adding GBP to currency codes dropdown.
<span class="label label-important label-danger">Fix</span> Extended length of line item name column to 255 to account for new functionality generating longer names now.
<span class="label label-important label-danger">Fix</span> Found and fixed cause of "Hack attempt" messages appearing in error.
<span class="label label-important label-danger">Fix</span> Temporarily commented out a call that was multiplying prices twice, resulting in Per week prices in the booking form that were multiplied 7x7.

<h3>Jomres 9.1.1 20/07/2015</h3>

<span class="label label-success">Feature</span> Added guest detail dropdown to Quick booking modal popup on dashboard.

<span class="label label-warning">Change</span> Tweaked image uploader to change non-alphanumeric characters to - instead of _
<span class="label label-warning">Change</span> Changed how dashboard cancel booking ajax works. Removed some "exits" that were preventing other code from running later on.
<span class="label label-warning">Change</span> Modified how the gif creation script works to remove non-image files from an array before they're used.

<span class="label label-important label-danger">Fix</span> Improved get_plugin_settings to fix a bug where the wrong settings might get pulled from the plugins table.

<h3>Jomres 9.1.0 13/07/2015</h3>

<span class="label label-success">Feature</span> Updated gateway handling so that guests can pay booking invoices. Currently only supported by Paypal, other gateways will need to be brought up-to-date to use new functionality.
<span class="label label-success">Feature</span> Added property feature categories. Property features can be referenced with Property Feature Categories in Administrator area, allowing us to nicely group property features in property details page.
<span class="label label-success">Feature</span> Modified slideshow feature to show multiple slideshows on a page.
<span class="label label-success">Feature</span> Modified show rooms list to show a small slideshow for each room's images.
<span class="label label-success">Feature</span> Improved room type layout in property details page ( Bootstrap 3 only ).

<span class="label label-warning">Change</span> Updated asamodule report to show a few more, recently added, links.
<span class="label label-warning">Change</span> Forced shortlisted properties to use live scrolling as pagination will not work.
<span class="label label-warning">Change</span> Updated Russian language file added to repository.
<span class="label label-warning">Change</span> Modified functionality so that reviews link in property list now goes to a BS modal where appropriate, not an older Jquery UI modal.
<span class="label label-warning">Change</span> Improved how room features are shown in the booking form.
<span class="label label-warning">Change</span> Changed a word from Status to Edit in administrator area list properties page.
<span class="label label-warning">Change</span> Removed the "Use online payment gateways" switch as it's not really required, we can count the number of active gateways to decide if we need to show gateway stuff.
<span class="label label-warning">Change</span> Tweaked booking engine so that coupon output only appears if valid coupons for current dates.
<span class="label label-warning">Change</span> Updated fontawesome's font files.
<span class="label label-warning">Change</span> Updated jomres_user_budget class to take jintour kid's prices into account too.
<span class="label label-warning">Change</span> Changed the invoice payment received script to redirect to list_invoices when completed.
<span class="label label-warning">Change</span> Modified Show Confirmation to show the configured gateway even if there's only one gateway available.
<span class="label label-warning">Change</span> Modified show confirmation so that it also shows the backend Paypal option if override is set to Yes.
<span class="label label-warning">Change</span> Tweaked touch template script to work with subscription functionality.

<span class="label label-important label-danger">Fix</span> Resolved an issue where Jintour bookings wouldn't work with new optional extras functionality.
<span class="label label-important label-danger">Fix</span> Modified a Joomla 3.4 specific function. Parameters now need to be specified when creating new users.
<span class="label label-important label-danger">Fix</span> Fixed an issue where the wrong index was used to find the property telephone number. Thanks Marhinio.
<span class="label label-important label-danger">Fix</span> Fixed a bug where new user creation query would fail on PDO.

<h3>Jomres 9.0.1 25/06/2015</h3>

<span class="label label-warning">Change</span> Improved layout of new optional extras output, including adding as a tab.
<span class="label label-warning">Change</span> Added a new method of saving settings.
<span class="label label-warning">Change</span> Polish language file updated, many thanks Patryk.

<span class="label label-important label-danger">Fix</span> Fixed an issue where optional extras wouldn't show in the booking form.
<span class="label label-important label-danger">Fix</span> Tweaked output of the property name so that apostrophes are returned to apostrophes in the breadcrumbs and meta title.
<span class="label label-important label-danger">Fix</span> Fixed an issue where Featured Properties listing in admin area could trigger a fatal error.
<span class="label label-important label-danger">Fix</span> Fixed an issue where the new Percentage based extras use the wrong tax rate.
<span class="label label-important label-danger">Fix</span> Tweaked tab content to ensure rooms list isn't shown in an SRP





<h3>Jomres 9.0.0 24/06/2015</h3>

<span class="label label-success">Feature</span> Subscription package and Commission functionality has been completely overhauled, you can now offer a variety of subscription related packages and renewals, and various standard Jomres core features can be added to a subscription package.

<span class="label label-success">Feature</span> Added PDO support to Jomres database functions and classes.

<span class="label label-success">Feature</span> Updated Jomres to use Open Exchange Rates as our exchange rate source. Note that you will need a ( free ) API key from Open Exchange Rates to perform currency conversion. Paid keys are only required for sites that make over 1000 queries a month, Jomres caching means that this query is only done once a day.
<span class="label label-success">Feature</span> Added functionality to allow payment gateways to send and receive data to gateway services, and to mark invoices paid. Note, it will take some time for Gateway developers to catch up. Currently this is for Commission and Subscription invoices only, may be extended to booking invoices later.
<span class="label label-success">Feature</span> Added functionality to support uploading of room features and optional extras images and showing these in the booking form.
<span class="label label-success">Feature</span> Added Guest image to booking display page, if the guest has uploaded an image.
<span class="label label-success">Feature</span> Added a feature where a property manager can make an optional extra show only if the arrival date falls within two dates. Additional filtering based on room types may be added later.
<span class="label label-success">Feature</span> Added a feature where a property manager can make an optional extra a commission percentage of the room price.
<span class="label label-success">Feature</span> Room feature images added to classic rooms list layout in the booking form, and room feature checkboxes tweaked so that images are clickable. This favours using smaller room feature images/icons (BS3 only).
<span class="label label-success">Feature</span> Modified the view shortlist and mu view favourites functionality. View favourites now used the property list template, rather than it's own template, to list properties. This allows us to re-use the shortlist array to show selected, shortlisted properties. Short listed properties are now added to favourites if the user's logged in. Unfortunately it's not possible to transfer items that were added to the shortlist before the user was logged in because the act of logging in creates a new session and the old session data is lost.
<span class="label label-success">Feature</span> Room type and Property Feature Images updated with modern feel and associated templates modified to adapt (only affects new installations).
<span class="label label-success">Feature</span> Added a new panel to the composite_property_details_notabs.html template which shows the Optional Extras which property offers in the booking form.
<span class="label label-success">Feature</span> Added a new standalone script for viewing a property's rooms, added a new property room features singleton. 
<span class="label label-success">Feature</span> Retired old stats functionality, and introduced new stats functionality that's responsive and easier to write for.

<span class="label label-warning">Change</span> Added error log clean to a daily pseudocron job instead of running every time Jomres runs.
<span class="label label-warning">Change</span> Replaced require with require_once in language class for performance improvements.
<span class="label label-warning">Change</span> Improved property type specific language file handling.
<span class="label label-warning">Change</span> Removed some template files from repo as no longer used.
<span class="label label-warning">Change</span> Added search dates to property list header for possible future use.
<span class="label label-warning">Change</span> Modified tax class to be a singleton.
<span class="label label-warning">Change</span> Added referrer to error log.
<span class="label label-warning">Change</span> Changed VEB to VEF to allow conversion of Venezuelan Bolivar.
<span class="label label-warning">Change</span> Removed auto-triggering of tooltip code from bottom.html as it causes problems.
<span class="label label-warning">Change</span> Tweaked Jomres lang class to save lang_shortcode to the showtime var.
<span class="label label-warning">Change</span> Finally got around to replacing all php4 constructors with proper __construct syntax.
<span class="label label-warning">Change</span> Removed an erroneous message from the control panel. Refers to the old plugin shop that's no longer available.
<span class="label label-warning">Change</span> Added a variety of changes to queries related to integers, for a small performance improvement.
<span class="label label-warning">Change</span> Removed a duplicate constructor in patError.php
<span class="label label-warning">Change</span> Reworked site configuration functionality, improving performance slightly for loading site settings, improved considerably saving site settings.
<span class="label label-warning">Change</span> Tabs are loaded a-la frontend property configuration tabs, through their own minicomponent. 
<span class="label label-warning">Change</span> License key moved from mrConfig to jrConfig 
<span class="label label-warning">Change</span> Commented the modal popup setting as it's no longer valid.
<span class="label label-warning">Change</span> Tweaked how the category in the Jomres main menu works so that non-Latin characters are upper-cased using multi-byte.
<span class="label label-warning">Change</span> Added a List Gateways for Invoice ID minicomponent for use by other minicomponents.
<span class="label label-warning">Change</span> Temporarily commentend out code that shows the Product Tour code that displays online help, it's not heavily used and the javascript doesn't play nicely with different flavours of jQuery on different CMSs. 
<span class="label label-warning">Change</span> Updated Site Config's default commission rate to 1 instead of the older string value.
<span class="label label-warning">Change</span> Modified the jr user class to contain profile information, and add profile information if it doesn't exist when creating a new user when making a booking.
<span class="label label-warning">Change</span> Updated the Contact Owner form to use ReCaptcha V2. 

<span class="label label-important label-danger">Fix</span> Tweaked a previous change so that published properties are not incorrectly marked as unpublished in the Sanity check.
<span class="label label-important label-danger">Fix</span> Changed path to Jomres logo in installer.
<span class="label label-important label-danger">Fix</span> Added some tweaks to resolve issues where incorrect dates could be built in urls, thereby triggering errors to be sent to site managers.
<span class="label label-important label-danger">Fix</span> Updated basic_property_details class, solved a property with property names, made some minor tweaks and removed a redundant array.
<span class="label label-important label-danger">Fix</span> Modified the router.php to account for slightly changed Joomla code used when building routes.
<span class="label label-important label-danger">Fix</span> Fixed a small bug in image uploader where if the image uploaded is a png and the medium and thumbnail images are the same size as the original uploaded image, then images aren't converted to jpegs from pngs.


<h3>Jomres 8.2.1 16/04/2015</h3>

<span class="label label-warning">Change</span> Updated propertyrental english language files to refer to Property, not Business.
<span class="label label-warning">Change</span> Updated English lang propertyrental language files to refer to Rooms instead of Resources.
<span class="label label-warning">Change</span> Fontawesome updated to 4.3
<span class="label label-warning">Change</span> Removed old invoice functions that are no longer in use.
Tweaked how languages are stored internally to reduce incidence of blank array keys, which can hinder translation in Microsoft Translation feature.

<span class="label label-important label-danger">Fix</span> Modified booking engine to ensure discounts array is reset correctly, and modified invoice insertion to tidy up dates in the Accommodation line item.
<span class="label label-important label-danger">Fix</span> Tweaked a new change for invoices, so that invoices are correct when micromanage is enabled.

<h3>Jomres 8.2.0 13/04/2015</h3>

<span class="label label-success">Feature</span> Completely reworked the invoicing system to make it clearer what discounts etc have been added, balance payments are more obvious etc.
<span class="label label-success">Feature</span> Added new functionality to show slideshow in the rooms list.
<span class="label label-success">Feature</span> Added functionality to Email Settings tab in Site Config that allows you to test your email settings on the fly.
<span class="label label-success">Feature</span> Added a nod to Sir Terry Pratchett.

<span class="label label-warning">Change</span> Updated Polish lang file, thanks Patryk.
<span class="label label-warning">Change</span> Removed one stray reference to Joomla from the getting started page, that shouldn't be there.
<span class="label label-warning">Change</span> Changed how a "force consolidation" flag is used in css and js caching classes.
<span class="label label-warning">Change</span> Modifed a template to ensure that administrator area templates are forced to use BS2 where applicable.
<span class="label label-warning">Change</span> Improved J3.4 router.php
<span class="label label-warning">Change</span> jr_gettext.php cleaned up, removing older comments and tidied up formatting.
<span class="label label-warning">Change</span> Added property address details to generic booking email class.
<span class="label label-warning">Change</span> The administrator BS3 template set was added in anticipation of Joomla adopting BS3 in the backend of J, however that hasn't happened so for now we will delete this directory's contents to ensure there isn't any confusion.
<span class="label label-warning">Change</span> Administrator area's List Bookings view has been removed from the administrator menu.
<span class="label label-warning">Change</span> Added Chinese language file mark for javascript calendar.
<span class="label label-warning">Change</span> Depreciated phpmailer 5.2.6 in favour of 5.2.9
<span class="label label-warning">Change</span> Renamed Alternate SMTP settings to Email settings.
<span class="label label-warning">Change</span> Tweaked how the last viewed property uid is figured out.
<span class="label label-warning">Change</span> Booking form in modal popup option removed from Bootstrap 2 & 3, the calendar doesn't stack properly within BS modals.
<span class="label label-warning">Change</span> Updated the max input vars warning with a new url.
<span class="label label-warning">Change</span> Added ability for generic booking cancel class to change a booking number. Beds24 bookings can be moved from property to property. To support that functionality we need to cancel the original booking so this change allows the beds24 plugin to change the original booking's booking number.
<span class="label label-warning">Change</span> Renamed nicetime function to ensure that there isn't a conflict with Alpha User Points.
<span class="label label-warning">Change</span> Changed when the cms specific functions file is included.


<span class="label label-important label-danger">Fix</span> Tweaked how og: tags are created as they weren't working since a jomres_decode change.
<span class="label label-important label-danger">Fix</span> Made a small tweak to the BS3 dashboard template to fix a label colour.
<span class="label label-important label-danger">Fix</span> Fixed a jquery version included in WP fullsreen view.
<span class="label label-important label-danger">Fix</span> Modified the J3.4 router, removing the xx-XX url that's now being added to urls. Doesn't affect functionality, this is for aesthetics only.
<span class="label label-important label-danger">Fix</span> Added edit_tariffs_normal to sanity checks, prevents the tariffs warning from showing when on the edit_tariffs_normal page.
<span class="label label-important label-danger">Fix</span> Fixed an issue where the modal could be behind the overlay in rooms list.
<span class="label label-important label-danger">Fix</span> Changed BS3 sanity checks template css from error to danger.
<span class="label label-important label-danger">Fix</span> Tweaked javascript script so that jquery is used in J2.5.

<h3>Jomres 8.1.20 27/02/2015</h3>

<span class="label label-success">Feature</span> Booking cancelled emails added to manager modifyable templates. Contributed by Rod at Jomres Plugins, many thanks mate.

<span class="label label-warning">Change</span> After previous version's changes to improve date handling, now we make proper use of the mindaysbeforearrival setting.

<span class="label label-important label-danger">Fix</span>  Removed title from Address inputs of booking form as the tooltips were making the form difficult to use.
<span class="label label-important label-danger">Fix</span> Modified new column adding code to not use "after" to resolve issues that users were having after installing a third party plugin that adds it's own column.
<span class="label label-important label-danger">Fix</span> Changed the process payment url to NOSEF as one particular implementation was causing incorrect redirects to gateways.

<h3>Jomres 8.1.19 19/02/2015</h3>

<span class="label label-success">Feature</span> New feature in list bookings and list properties, can now sort by last changed state.
<span class="label label-success">Feature</span> New functionality to support a new Latest bookings since last active plugin for property managers

<span class="label label-warning">Change</span> Moved Polish zloty notation to end of currency instead of beginning.
<span class="label label-warning">Change</span> Emptied cache before importing eu tax rates.
<span class="label label-warning">Change</span> Updated table-tools calling function in jomres.js to use updated cols.
<span class="label label-warning">Change</span> Updated Polish lang file, thanks Patryk.
<span class="label label-warning">Change</span> Added font awesome switch to jq ui backend for wordpress uses.
<span class="label label-warning">Change</span> Added language to common template vars with the intention that this will allow users to use conditionals in templates for different languages.
<span class="label label-warning">Change</span> Added a new column "is eu country" flag to tax rates table. Added lang and code changes to allow us to flag a country as an eu country or not.
<span class="label label-warning">Change</span> Added Croatia to EU countries.
<span class="label label-warning">Change</span> Added j03020insertbooking_amendinvoice.class.php to obsolete files.
<span class="label label-warning">Change</span> Modified booking engine to use Sleeps search results where possible when populating the required guest numbers field in the booking form.
<span class="label label-warning">Change</span> Updated several tables with indexing.
<span class="label label-warning">Change</span> Modified a query to use IN instead of OR in search queries for a performance improvement.
<span class="label label-warning">Change</span> Modified how the QR code url is constructed to improve functionality in Mexican addresses.
<span class="label label-warning">Change</span> Added functionality to facilitate searching by translated town name.
<span class="label label-warning">Change</span> Added language index for custom text table.
<span class="label label-warning">Change</span> Modified the booking engine so that the next date a room is free is selected if a date isn't passed via url.
<span class="label label-warning">Change</span> Tweaked map template to show maps in BS3 templates more reliably.
<span class="label label-warning">Change</span> Modified the generic booking insert class to accept 0 deposit.
<span class="label label-warning">Change</span> Moved caching options into new tab
<span class="label label-warning">Change</span> Move commission rate site config option to ROI tab.
<span class="label label-warning">Change</span> Tweaked booking engine so that guests from all manager's properties are shown in the guest dropdown.
<span class="label label-warning">Change</span> Added patTemplate caching feature.
<span class="label label-warning">Change</span> Undid a change related to live scrolling.
<span class="label label-warning">Change</span> Modified datatable call so that most recent additions are listed first by default.
<span class="label label-warning">Change</span> Modified frontend show rooms list page to use bs modals instead of older jquery ui modals in BS templates.
<span class="label label-warning">Change</span> Modified Jomres main menu generator to accept multi-dimensional arrays as values when building menus.
<span class="label label-warning">Change</span> Modified recaptcha to ensure https used where relevant.
<span class="label label-warning">Change</span> Updated Datatables javascript files.
<span class="label label-warning">Change</span> Improved how dates are handled when passed to the booking form.
<span class="label label-warning">Change</span> Added a library for http_build_url as some server's don't have pecl http.
<span class="label label-warning">Change</span> Added Joomla 3.4 specific code.

<span class="label label-important label-danger">Fix</span> Improved how images for gateways are found for display in list properties page.
<span class="label label-important label-danger">Fix</span> Resolved an issue with double inclusion of a javascript file when caching enabled.
<span class="label label-important label-danger">Fix</span> Tweaked the module popup class so that bookings are actually shown if the calendar code is enabled to be shown.
<span class="label label-important label-danger">Fix</span> Fixed issue where buttons etc would be shown even for non-existant bookings.
<span class="label label-important label-danger">Fix</span> Added a variety of changes to fix some javascript issues that intermittently appear.

<h3>Jomres 8.1.18 04/12/2014</h3>

<span class="label label-success">Feature</span> Added Multisite support to Jomres, first iteration that supports property sharing.

<span class="label label-warning">Change</span> Updated galleria slideshow plugin to 1.4.2
<span class="label label-warning">Change</span> Updated Polish lang file, thanks Patryk.
<span class="label label-warning">Change</span> Updated datatables version.


<span class="label label-warning">Change</span> Small tweak to jomres toolbar to ensure that we use the correct version of bootstrap in the admin area.
<span class="label label-warning">Change</span> Improved how we tidy up temp booking data when amending bookings to prevent intermittent error logs of contract ids not set.
<span class="label label-warning">Change</span> Tweaked list properties to ensure search results from ajax are loaded correctly when changing pages.
<span class="label label-warning">Change</span> Fullscreeen view, BS3, updated.
<span class="label label-warning">Change</span> Modified how property list prices are figured out RE arrival date in ajax search
<span class="label label-warning">Change</span> Modified a variety of files so that we use IN in sql queries instead of OR, as it's demonstrated to be up to 3 times faster.
<span class="label label-warning">Change</span> Added a clause to property_list prices class to check that certain fields are populated before setting the arrival date.
<span class="label label-warning">Change</span> Added tariff description for micormanaged tariffs to classic rooms list.
<span class="label label-warning">Change</span> Modified payment methods class to ensure results are cached in memory.
<span class="label label-warning">Change</span> Updated BS2 composite_property_details_notabs.html
<span class="label label-warning">Change</span> Changed how we figure the current url is determined by the error logging function.
<span class="label label-warning">Change</span> Modified payment methods class to ensure results are cached in memory.
<span class="label label-warning">Change</span> Updated how temp booking data is stored.
<span class="label label-warning">Change</span> Modified a url to ensure that the jr_printable flag is set to 1 where appropriate.
<span class="label label-warning">Change</span> Updated composite property details script so that appropriate data is passed to the template if printable is enabled.

<span class="label label-important label-danger">Fix</span> Modified booking confirmation page so that modifications of amended bookings are redirected through the amendBooking task first, to ensure that previously booked rooms appear in the room selection list second time around.
<span class="label label-important label-danger">Fix</span> Modified new functionality to correctly determine the path to a template file.
<span class="label label-important label-danger">Fix</span> BS3 solved a problem when filtering ajax tables.



<h3>Jomres 8.1.17 11/11/2014</h3>

<span class="label label-warning">Change</span> Updated bootstrap 3 edit property pages so that features are laid out correctly.
<span class="label label-warning">Change</span> Added a note to invoice handler
<span class="label label-warning">Change</span> Updated the table tools ajax scripts to cope with large queries.
<span class="label label-warning">Change</span> Tweaked dobooking insertion script to ignore quick booking bookings as the booking data archive doesn't exist for them.
<span class="label label-warning">Change</span> Updated Core Bootstrap 3 frontend templates. They look a lot like the demo template layout now. Converted icons to use Font Awesome icons.
<span class="label label-warning">Change</span> Updated site configuration default image sizes to correspond with BS3 template layout changes. Existing installations won't be affected, just new installations.
<span class="label label-warning">Change</span> Added a vertical template to basic module output.
<span class="label label-warning">Change</span> Updated the error logging to include the url that was called.
<span class="label label-warning">Change</span> Added embed to input filtering.
<span class="label label-warning">Change</span> Hardened output filtering to defend against cross site scripting vectors.
<span class="label label-warning">Change</span> Generic booking insert script updated to ensure temporary data is reset after insertion.
<span class="label label-warning">Change</span> Added a call to jomres_database for later use.
<span class="label label-warning">Change</span> Added some tweaks to support having different template files in Joomla templates (overrides). Involves jomsearch_mN modules srch.html templates being renamed to the module's name.
<span class="label label-warning">Change</span> Modified show property header script so that we're not over-purifying the og description.
<span class="label label-warning">Change</span> Added a class that collects gateway information for display in property list.
<span class="label label-warning">Change</span> Removed a no-longer needed css class from jomresHTML.class.php

<span class="label label-important label-danger">Fix</span> Fixed an intermittent issue where bookings might not get inserted to the booking data archive due to html tags.

<h3>Jomres 8.1.16 23/10/2014</h3>

<span class="label label-success">Feature</span> Added a new column booking_language to contracts table so that confirmation emails can be sent to the guest in their own language.

<span class="label label-warning">Change</span> Removed some unnecessary directory scanning that was in place to discover the location of Jomres. As this file is now created in the installer, the scanning is no longer necessary.
<span class="label label-warning">Change</span> Added new functionality that supports javascript required by the booking form classic rooms list modals.
<span class="label label-warning">Change</span> Removed some depreciated functions that have been commented out for some time.
<span class="label label-warning">Change</span> Compare properties script updated to use font-awesome icons.
<span class="label label-warning">Change</span> Tweaked module popup contents template to cope with oversize images.
<span class="label label-warning">Change</span> Modified how the booking engine saves last minute discount text as new javascript was causing mysql errors.
<span class="label label-warning">Change</span> Modified Add Service to Bill functionality so that freebies can be added to the bill.
<span class="label label-warning">Change</span> Modified how urls are stored in the register property template.
<span class="label label-warning">Change</span> Updated bootstrap 3 edit property pages so that features are laid out correctly.
<span class="label label-warning">Change</span> Removed a definition from the Jomres BS3 supplementary file.
<span class="label label-warning">Change</span> Added a couple of tasks to the sanity check class to prevent the no tariffs warning from showing on the edit and list tariffs pages.
<span class="label label-warning">Change</span> Updated a variety of redirects to ensure the redirected url uses jomresURL appropriately.
<span class="label label-warning">Change</span> Removed form-control css class from dropdown generation class.
<span class="label label-warning">Change</span> Modified how save property script redirects to resolve intermittent issues.

<span class="label label-important label-danger">Fix</span> Updated a variety of redirects to ensure the redirected url uses jomresURL appropriately.
<span class="label label-important label-danger">Fix</span> Fixed an issue where gmaps wouldn't show in fullscreen view.
<span class="label label-important label-danger">Fix</span> Resolved an issue where slideshow div loads images before showing gallery.
<span class="label label-important label-danger">Fix</span> Added a flag that prevents the contact us link from showing twice on a page intermittently.


<h3>Jomres 8.1.15 09/10/2014</h3>

<span class="label label-success">Feature</span> Added new functionality so that Jomres can discover minicomponents in /templates/jr_leohtian/html/com_jomres/subdir which allows us to deliver templates with Jomres customisations which are specific only to that template.
<span class="label label-warning">Change</span> Added IP numbers to error logs.
<span class="label label-warning">Change</span> Added translation of guest types to basic_contract_details class.
<span class="label label-important label-danger">Fix</span> Re-added a salutation that was inadvertently removed, to language files.

<h3>Jomres 8.1.14 01/10/2014</h3>

<span class="label label-important label-danger">Fix</span> Fixed a bug where a manager could modify bookings that they aren't authorised to modify. Medium level security bug.

<h3>Jomres 8.1.13 30/09/2014</h3>

<span class="label label-warning">Change</span> Added shortlist templates to list properties.
<span class="label label-warning">Change</span> Added custom properties fields snippet to list_properties.html

<span class="label label-important label-danger">Fix</span> Modified the generatedateinput function as it was creating several issues on non-search based forms that required dates to be entered.

<h3>Jomres 8.1.12 26/09/2014</h3>

<span class="label label-warning">Change</span> Improved media centre icons
<span class="label label-warning">Change</span> Tweaked urls to gmaps to ensure that https is used.
<span class="label label-warning">Change</span> Added font awesome to administrator area.
<span class="label label-warning">Change</span> Modified how live scrolling feature appends results to existing div.
<span class="label label-warning">Change</span> Added code to support calculated total price conversion in property list.
<span class="label label-warning">Change</span> Modified how the shortlist feature works, ajax output is now sent via templates. This allows us to override the response with something like FA icons.
<span class="label label-warning">Change</span> Modified layout of output price template slightly.
<span class="label label-warning">Change</span> Tweaked css to make over budget properties opacity more pronounced.
<span class="label label-warning">Change</span> Updated Polish lang files, thanks Patryk.
<span class="label label-warning">Change</span> Added a new lang string to differentiate properties in list properties and property details that have deferred bookings.
<span class="label label-warning">Change</span> Tweaked bottom slightly to change the tooltip binding.
<span class="label label-warning">Change</span> Updated module popup contents to improve layout in BS3.
<span class="label label-warning">Change</span> Added date/time to the error report.
<span class="label label-warning">Change</span> Changed location of qr codes 
<span class="label label-warning">Change</span> Improved searching so that if arrival and departure dates are the same then the min interval is set to 1. This is for users of "by day" functionality as opposed to "by night".

<span class="label label-important label-danger">Fix</span> Fixed an issue where carriage returns in output_price.html causes javascript errors in the booking form.
<span class="label label-important label-danger">Fix</span> Fixed a faulty path to the calendar icon for non-BS3 installations.
<span class="label label-important label-danger">Fix</span> Resolved an issue where duplicate records could be created in the booking data archive.

<h3>Jomres 8.1.11 23/09/2014</h3>

<span class="label label-warning">Change</span> Modified the dashboard to use language strings from Jomres lang files instead of strings coded into the javascript file to define month and day names.
<span class="label label-warning">Change</span> Modified system to provide language strings for table tools (flash buttons cannot yet be translated).
<span class="label label-warning">Change</span> Added new administrator area feature to show our Jomres Partners and their plugins.
<span class="label label-warning">Change</span> Modified generateDateInput.php so that it will also recognise asc_arrivalDate to setup javascript that'll change the departure date automatic changes too. This (in a roundabout sort of way) allows us to use ajax search composite on pages that include the booking form. Previously having ASC on pages with the booking form, the booking engine could erroneously pull the arrival date from ajax search composite's form, potentially screwing with the booking engine's dates. We got around that previously by not showing ASC on pages that showed the booking form. Now, we don't need to do that.
<span class="label label-warning">Change</span> Improved the BS2 flat property details template to add more output.
<span class="label label-warning">Change</span> Polish lang file updated, thanks Patryk.
<span class="label label-warning">Change</span> Added a new minicomponent designed to aggregate code from elsewhere so that ajax search can "inherit" search selections from the simple search modules.
<span class="label label-warning">Change</span> Modified paging feature so that PAGING is added to list properties templates, rather than being echoed by 1010listproperties.
<span class="label label-warning">Change</span> Modified Jomres so that optional 99999 triggers are always run if available.
<span class="label label-warning">Change</span> Modified list properties so that imagethumb etc have blank images if no property images are available.
<span class="label label-warning">Change</span> Changed how the property name dropdown is built to account for a recent tweak in property name/description searching.
<span class="label label-warning">Change</span> Restored a commented out setting in property config referring to minimum intervals.
<span class="label label-warning">Change</span> Removed a class from the language dropdown that's no longer required.
<span class="label label-warning">Change</span> Added new strings to lang files relevant to Instant v Deferred booking tags in property list.
<span class="label label-warning">Change</span> Removed overlay snippet code that was added last version, it has been put back into the list properties due to other changes added because of changes being made to the demo.
<span class="label label-warning">Change</span> Added reviews information for use in property details page, not just tabs.
<span class="label label-warning">Change</span> Hardened media centre scripts against spambot intrusion.
<span class="label label-warning">Change</span> Modified the booking form slightly so that the address details slide up/down when sufficient booking details are known, rather than simply fading in/out. This means that the initial booking form area on in flat property details template takes up less space.
<span class="label label-warning">Change</span> Removed some un-needed template files.
<span class="label label-warning">Change</span> Replaced some BS2 hidden classes with their corresponding BS3 classes in room type list.
<span class="label label-warning">Change</span> Added code to allow automatic triggering of bootstrap tooltips on page load and binding to dynamic events.
<span class="label label-warning">Change</span> Modified output price function so that if using bootstrap then original price (price in brackets) is now shown in a tooltip.
<span class="label label-warning">Change</span> Changed Arrival and Departure strings to Check-in and Check-out in english language files.
<span class="label label-warning">Change</span> Added Font Awesome as an optional css library. Many BS2 Joomla templates exclude glyph icons, or name the icons differently, meaning we can't always rely on a template to provide the required icons, so we'll add our own. Switchable because all BS3 joomla templates so far seem to include FA icon sets by default.
<span class="label label-warning">Change</span> Modified the Booking Engine and Search functionality so that calendars now use calendar icons instead of the old calendar image. Makes styling much easier and looks neater.
<span class="label label-warning">Change</span> The clear dates checkbox can now be added to a search template via {CLEARDATES_CHECKBOX} (and associated checkbox can be removed from the js_calendar_input.html template. This helps with styling.
<span class="label label-warning">Change</span> Output price has been changed to use an icon instead of a link on the price to allow users to see the converted price.
<span class="label label-warning">Change</span> Added a new optional trigger to listProperties.

<span class="label label-important label-danger">Fix</span> Fixed BS3 edit property template to ensure previously selected features are checked.
<span class="label label-important label-danger">Fix</span> Fixed an issue where review results could be incorrectly attributed.
<span class="label label-important label-danger">Fix</span> Fixed a bug that prevented stars from showing in property list.
<span class="label label-important label-danger">Fix</span> Fixed a bug where un-published properties could show in the agent's page.


<h3>Jomres 8.1.10 01/09/2014</h3>

<span class="label label-success">Feature</span> Added new functionality to allow site managers to choose whether or not to show the property list paginated, or to use the older Infinite Scrolling feature.

<span class="label label-warning">Change</span> Modified the image uploader to automatically crop images.
<span class="label label-warning">Change</span> Added modules srch.html templates to files that can be overridden via the Joomla method.
<span class="label label-warning">Change</span> Added a change to ensure that the correct version of editable's css file is called if we're in the administrator area.
<span class="label label-warning">Change</span> Tweaked a path to the dobooking script. (tab contents related)
<span class="label label-warning">Change</span> Added error codes to track obscure upload issues if they exist. (Plugin manager)
<span class="label label-warning">Change</span> Modified the Japanese date pickers file reference.
<span class="label label-warning">Change</span> Removed a stray </select> from the search generation code.
<span class="label label-warning">Change</span> Added quick info output text to property module data script.
<span class="label label-warning">Change</span> Removed some stray spaces from code that was upsetting adaptations of the JavaScript drop downs.
<span class="label label-warning">Change</span> Added a tweak to how property name searching is done so if only one property of a given name exists then the user's directed straight to that property instead of being shown the property list.
<span class="label label-warning">Change</span> Implemented new code for searching by property name, thanks for the contribution Rod.
<span class="label label-warning">Change</span> Added two new triggers for publishing properties ( 02273 for after a property has been successfully published and 02274 for when it has been unpublished ), at the request of a third party developer.
<span class="label label-warning">Change</span> Modified the Bootstrap 3 flat template to allow us to select which elements do not appear in tabs.
<span class="label label-warning">Change</span> Polish lang file updated, many thanks Patryk.
<span class="label label-warning">Change</span> Tweaked how list bookings is shown in ajax loaded tables for JQ UI
<span class="label label-warning">Change</span> Tweaked admin script to ensure temp .js files are deleted for refresh whenever on main control panel or Site Config pages.
<span class="label label-warning">Change</span> Modified "search by" language strings to make them more compact.
<span class="label label-warning">Change</span> Tweaked a condition relating to how budget is shown in the property list.
<span class="label label-warning">Change</span> Added some small changes to currency conversion class to relating to alternate templates.
<span class="label label-warning">Change</span> Added animation delay variable to get_property_module_data.php
<span class="label label-warning">Change</span> Updated the Star image.
<span class="label label-warning">Change</span> Changed search feature to adapt to the search order formula chosen in site config.
<span class="label label-warning">Change</span> Modified layout of module popup for bootstrap3.
<span class="label label-warning">Change</span> Tweaked how chained combo boxes are built.


<h3>Jomres 8.1.9 07/08/2014</h3>

<span class="label label-success">Feature</span> Added Japanese language file. Many thanks Jeff.

<span class="label label-warning">Change</span> Improved icons in the BS3 media centre templates.
<span class="label label-warning">Change</span> Updated a version number in an xml file.
<span class="label label-warning">Change</span> Minor tweak to control panel to add the Date to the news output.
<span class="label label-warning">Change</span> Updated Jomres' images to the new logo.
<span class="label label-warning">Change</span> Added an option to use templates to build the currency conversion selector rather than plain old dropdowns, which allows us to add the dropdown to bootstrap toolbars.
<span class="label label-warning">Change</span> Changed the name of the default property created on Jomres installation.

<span class="label label-important label-danger">Fix</span> Fixed a misplaced bracket in patTemplate class. Thanks Maritn.
<span class="label label-important label-danger">Fix</span> Changed how files are read into the js and css cache classes.
<span class="label label-important label-danger">Fix</span> Tweaked how a disabled task's name is determined.


<h3>Jomres 8.1.8 31/07/2014</h3>

<span class="label label-success">Feature</span> Refactored javascript and css file handling. Older method was growing to become clumsy, new process automatically creates consolidation scripts (where as many .js files as is practical are presented as one file) and .js and .css files are automatically minified. All new .js and .css files can be supplied un-minified, if the file is ever modifed the served, minified and/or consolidated version of that file is automatically updated.
<span class="label label-success">Feature</span> Updated dump template vars functionality (Site Configuration -> Debugging). Instead of using older patTemplate dump function we now output the name of the individual template and on hover the variables available to the template are shown. It's not pretty, but it makes it very easy for site integrators to identify Jomres template files that they may wish to modify.

<span class="label label-warning">Change</span> Improved price overlay, added ability to switch it on and off, changed the output a little to use new strings and calculations based on how prices are stored.
<span class="label label-warning">Change</span> Improved new functionality related to finding the number of days in the property list search results.
<span class="label label-warning">Change</span> Added a trap to capture what looks like Bots attempting to access the booking form. As the bots can't use the booking engine they're going to the confirmation page without the property uid being set, so we'll redirect these back to the default Jomres page.
<span class="label label-warning">Change</span> Added changes so that custom fields are viewable in show confirmation.
<span class="label label-warning">Change</span> Reworked how the fullpage jomres.php file copying is performed so that it's only done when needed.

<span class="label label-important label-danger">Fix</span> Changed how some urls are using in the booking form as they're better "built" and less likely to cause odd redirection behaviour on certain systems.
<span class="label label-important label-danger">Fix</span> Fixed a z-index issue in the dashboard calendar.
<span class="label label-important label-danger">Fix</span> Fixed a broken link to the ajax animation when live scrolling.

<span class="label label-info">Wordpress</span> Wordpress : Changed how javascript is queued in wp
<span class="label label-info">Wordpress</span> Changed how WP registers the bootstrap tour script so that it doesn't cause .js errors.
<span class="label label-info">Wordpress</span> Fixed a path in management view to the logo
<span class="label label-info">Wordpress</span> Added a check for the wp_jomres class in a function to prevent it from being run if we're outside a Jomres page.
<span class="label label-info">Wordpress</span> Updated the getting started notes to be a bit more relevant to WP users.

<span class="label label-info">Joomla</span> Modified the template reader script to allow Joomla overrides-esque functionality. 
Put templates from /jomres/templates/xxxx/frontend and /jomres/templates/xxxx/backend into /templates/templatename/html/com_jomres or /jomres/templates/xxx/admin into /administrator/templates/templatename/html/com_jomres to override the core Jomres templates.
Existing template editing functionality is retained, however a file placed into a com_jomres directory will override a customisation created using the template editing feature. If there is no file in com_jomres then existing customisations will still be used.
Advantage : People who're familiar with Joomla template overrides can use their favourite functionality still, however
Disadvantage : you cannot have different templates for different property types.


<h3>Jomres 8.1.7 13/06/2014</h3>

<span class="label label-success">Feature</span> Added the calendar to the module popup contents.
<span class="label label-success">Feature</span> Added ability to view the changelog in administrator -> developer tools. Reformatted the changelog so that we can start making use of BS labels to make it more readable.
<span class="label label-success">Feature</span> Added a new image overlay tag to property list that shows the cumulative price calculated from the dates in ajax search's dates.

<span class="label label-warning">Change</span> Prevent resources menu option from showing if is Jintour or real-estate property
<span class="label label-warning">Change</span> Changed how currency codes are pulled for listing against invoices.
<span class="label label-warning">Change</span> Changed how invoice creation is done when Booking Approvals are enabled.
<span class="label label-warning">Change</span> Added a tweak to correctly use https if needed when initialising the live_site variable in Joomla.
<span class="label label-warning">Change</span> Added a tweak to correctly use https if needed when initialising the live_site variable in Joomla 2.5
<span class="label label-warning">Change</span> Tweaked detect_cms.php to only define JPATH_PLATFORM if it's not already defined.
<span class="label label-warning">Change</span> Modified basic contract details so that country name is returned instead of country code. 
<span class="label label-warning">Change</span> Added a new country_code array index to ensure that this is also available if needed, in line with basic_property_details functionality.
<span class="label label-warning">Change</span> Added functionality to translate room types for SRPs.
<span class="label label-warning">Change</span> Changed some "exits" to "thrown" errors.
<span class="label label-warning">Change</span> Added code to set_booking_number function so that if the booking number is already set, then it won't be changed.
<span class="label label-warning">Change</span> Added code to allow calling services to pre-select adult and child numbers (change added for beds24 but can be used elsewhere). Add adultnum=N&childnum=N to have adult and child numbers pre-selected in the booking form.
<span class="label label-warning">Change</span> Added requireApproval to the default property settings script.
<span class="label label-warning">Change</span> Added a new function get_periods that'll take (UK formatted dd/mm/yyyy) datetime and return the dates in that period.
<span class="label label-warning">Change</span> Added unconverted price to returned results of jomres/classes/jomres_property_list_prices.class.php
<span class="label label-warning">Change</span> Tweaked the generic booking email class to offer invoice to all templates.
<span class="label label-warning">Change</span> Improved the geo coder templates and how the marker is placed.
<span class="label label-warning">Change</span> Updated news section in control panel to look brighter.

<span class="label label-important label-danger">Fix</span> Resolved an issue where a duplicate map marker could be created.
<span class="label label-important label-danger">Fix</span> Moved script tag to underneath the images output to see if it resolves a (very rare) timeout issue.
<span class="label label-important label-danger">Fix</span> Modified the view agent list to not show properties that haven't been approved yet.
<span class="label label-important label-danger">Fix</span> Changed the name of an image.

<span class="label label-info">Wordpress</span> Resolved an issue with ajax based calls being unable to find a property uid due to the url structure.


<h3>Jomres 8.1.6 13/06/2014</h3>

<span class="label label-success">Feature</span> Added ability to flag plugins as retired, to advise managers to uninstall older plugins that will not work with current versions of Jomres.

<span class="label label-warning">Change</span> integration.php updated with a small routine to try to determine which file has failed to call jomres_root.php, if JOMRES_ROOT_DIRECTORY isn't set.
<span class="label label-warning">Change</span> Added email_text to allowed fields for input filtering, and improved the allowed tags list to be a little more lenient.
<span class="label label-warning">Change</span> Changed property header to use the large property image in accordance with the advice here https://developers.facebook.com/docs/opengraph/howtos/maximizing-distribution-media-content  This is an image associated with your media. We suggest that you use an image of at least 1200x630 pixels.
<span class="label label-warning">Change</span> Modified save country and save region scripts to redirect back to the associated lists on save.
<span class="label label-warning">Change</span> Added notes to the top of the guest's view booking page to indicate if a booking has been cancelled.
<span class="label label-warning">Change</span> Hide the cancel button when a booking has been cancelled, from the user's view of the booking.
<span class="label label-warning">Change</span> Broke several functions out of functions.php so that they can be overridden in plugins.
<span class="label label-warning">Change</span> Tweaked the confirmation letter popup to display better.
<span class="label label-warning">Change</span> Added a message to say that the confirmation email has been sent.
<span class="label label-warning">Change</span> Added a button to the administrator control panel that links direct to the front page of the site. Should make it clearer to new users how to go about managing properties.
<span class="label label-warning">Change</span> Updated detect_cms.php to adjust to Joomla's new upgrade strategy, information relating to the problem is provided and an error is thrown.
<span class="label label-warning">Change</span> Updated the Italian language file, many thanks Pierangela.
<span class="label label-warning">Change</span> Added a definition for JPATH_PLATFORM as the Joomla version file uses that instead of _JEXEC when checking to see if the file can be called.

<span class="label label-important label-danger">Fix</span> Fixed a broken path to gateway directory to ensure that the gateway logo is shown correctly.
<span class="label label-important label-danger">Fix</span> Solved a missing property type image problem in query ui booking form classic room list.
<span class="label label-important label-danger">Fix</span> Fixed a bug where wrong users were getting emailed php errors.
<span class="label label-important label-danger">Fix</span> Updated how Jomres handle's custom fields in the booking form so that required fields are properly highlighted again.
<span class="label label-important label-danger">Fix</span> Modified the installer, added `secret_key_used` column to create contracts table.

<h3>Jomres 8.1.5 23/05/2014</h3>

<span class="label label-warning">Change</span> Added a new 99994 trigger point at the end of jomres.php's run. 
<span class="label label-warning">Change</span> Added new 99994 trigger to jomresRedirect function to ensure that 99994 actions are performed both when Jomres finishes running jomres.php, and when calls are redirected to another task.
<span class="label label-warning">Change</span> Changed ajax insert booking so that it doens't exit at the end of it's run, instead it returns.
<span class="label label-warning">Change</span> Disabled a system/misc logging event as it's not needed.
<span class="label label-warning">Change</span> Added a quarter hourly cron job option to the cron class.
<span class="label label-warning">Change</span> Added contract uid and booking number to showtime after quickbooking.
<span class="label label-warning">Change</span> Removed an unnecessary call to close session.
<span class="label label-warning">Change</span> Added several flags to showtime for booking insertion, to store references to amended contract uids.

<span class="label label-important label-danger">Fix</span> Fixed an issue where the Product Tour (inline help feature) caused a javascript error on Reg Prop 2.

<span class="label label-info">Wordpress</span> Tweaked the WP cms specific urls functionality to enable Jomres to work on WP sites that have permalinks enabled. This doesn't provide pretty urls, but it does fix an issue where Jomres wouldn't work on sites with permalinks switched on.
<span class="label label-info">Wordpress</span> Improved how WP specific functionality detects if we're in admin area or not. Fixes an issue where admin media centre doesn't know where it is and results in a "something seriously wrong" message.

<h3>Jomres 8.1.4 12/05/2014</h3>

<span class="label label-success">Feature</span>  Added an is_child flag to the customer types table.

<span class="label label-warning">Change</span> Tweaked list properties to not build the budget class if the feature isn't used. Minor performance improvement.

<span class="label label-important label-danger">Fix</span> Confirmation letter script was sending wrong email template.

<h3>Jomres 8.1.3 09/05/2014</h3>

<span class="label label-warning">Change</span> Disabled asamodule report from showing on WP, due to how urls are generated the report doesn't make sense on WP installations.
<span class="label label-warning">Change</span> Changed the extraservices warning from a danger to a warning level report in the installer.
<span class="label label-warning">Change</span> Disabled/removed some old functionality that was designed for Jomres Standalone and is no longer applicable.

<span class="label label-info">Wordpress</span> Improved how installation on wordpress is detected.

<h3>Jomres 8.1.2 07/05/2014</h3>

<span class="label label-warning">Change</span> Updated Polish lang files, thanks Patryk
<span class="label label-warning">Change</span> German language file updated.
<span class="label label-warning">Change</span> Improved a path problem caused by the latest fix.
<span class="label label-warning">Change</span> Added ids to town, street and posted in edit and register property templates to aid geocoder listener.

<span class="label label-important label-danger">Fix</span> Fixed a missing image problem on Jquery ui bookingform.
<span class="label label-important label-danger">Fix</span> Corrected a path for editing room types, image path was incorrect after new 8.1 path changes.
<span class="label label-important label-danger">Fix</span> Updated the wp plugin files to fix a bug with new paths.

<h3>Jomres 8.1.1 29/04/2014</h3>

<span class="label label-important label-danger">Fix</span> Fixed an issue where registry paths were being saved incorrectly, causing errors and blank pages when trying to run Jomres.

<h3>Jomres 8.1.0 28/04/2014</h3>

<span class="label label-success">Feature</span> Added buttons to sanity checks to take the user to the appropriate link to fix the problem.

<span class="label label-warning">Change</span> Modified the ui availability calendar to use an existing option and set the first day of week to Sunday or Monday.
<span class="label label-warning">Change</span> Modified userbudget so that converted price isn't shown in property list header dropdown.
<span class="label label-warning">Change</span> Added changes that support Jomres working in a directory other than "jomres". 
<span class="label label-warning">Change</span> Changed a check to ensure jquery isn't included in Joomla 3.3.
<span class="label label-warning">Change</span> Moved Budget switch to Search tab in site config.
<span class="label label-warning">Change</span> Removed short property feature list from property list page.

<span class="label label-important label-danger">Fix</span> Fixed an issue where navbar is always inversed when not in component area.
<span class="label label-important label-danger">Fix</span> Fixed Fawlty Tower's default property features on installation.
<span class="label label-important label-danger">Fix</span> Fixed an issue where panel-info wasn't being applied if featured properties plugin is not installed.
<span class="label label-important label-danger">Fix</span> Added a couple of tweaks for modal popups in BS3, ensures that the modal appears above the background and fixes the position of the thumbnail in the modal popup.

<h3>Jomres 8.1.-2 16/04/2014</h3>

<span class="label label-success">Feature</span> Added a new "budget" option to property list toolbar, which allows users to see at a glance which properties are within their budget.
<span class="label label-success">Feature</span>  Added functionality to give javascript files a version (based on the update time). This means that when a site's updated browsers will be triggered to download the javascript files again. This prevents changes in js files from causing a site to appear to not function if that js file has different functionality.
<span class="label label-success">Feature</span> Added the option to switch off the Powered by Jomres link via site config, and by default this is set to No.
<span class="label label-success">Feature</span> Added lowest prices to property details page.
<span class="label label-success">Feature</span> Added Bootstrap 3 panels to Bootstrap 2 and modified property list template to use.
<span class="label label-success">Feature</span> Added a new css class .property-list-overbudget-properties so that if the budget dropdown is used and a property is over-budget we make it slightly opaque to emphasise those properties that are under budget. Feature properties are not affected by these changes, they use the panel-primary class to stand out.

<span class="label label-warning">Change</span> Simplified the book/check in/out feature, Booking in/out is done through the list bookings page now.
<span class="label label-warning">Change</span> Added a check for secret key so that required custom fields are stored correctly.
<span class="label label-warning">Change</span> Modified the generic booking insert class to ensure that it uses currency codes, otherwise bookings later on will not show correctly.
<span class="label label-warning">Change</span> Added a way to update site settings with last update time, for use later by, among other things, javascript versioning.
<span class="label label-warning">Change</span> Updated the Polish lang files. Thanks Patryk.
<span class="label label-warning">Change</span> Changed an int to a float for a 3PD.
<span class="label label-warning">Change</span> Tweaked new functionality so that if book in/out plugin not installed then the check in/out options aren't offered in the bookings list.
<span class="label label-warning">Change</span> Email template editing instructions updated.
<span class="label label-warning">Change</span> Installer improved. Given a makeover and added functionality to rename a table if possible, or warn and give directions if not possible.
<span class="label label-warning">Change</span> Obsoleted the old Joomla 3.0 and 3.1 specific functionality as they're no longer supported. 
<span class="label label-warning">Change</span> Added UI availability calendar to the asamodule report page.
<span class="label label-warning">Change</span> Changed property list header buttons to small.
<span class="label label-warning">Change</span> Re-added _JOMRES_FRONT_MR_EMAIL_TEXT_NAME that was inadvertently removed when adding the email editing feature.
<span class="label label-warning">Change</span> Updated budget site config description to note that the featured listings wrapping class that highlights featured listings is changed when the budget feature is enabled.

<span class="label label-important label-danger">Fix</span> Removed a stray hyphen from the phrase "Property details".
<span class="label label-important label-danger">Fix</span> Corrected "rows" to "row" in BS3 skin.
<span class="label label-important label-danger">Fix</span> Added code to ensure that the property's currency code is entered into the contracts table during the booking phase. Without this change, if a property changes it's currency code then the prices in the bookings list are incorrect.
<span class="label label-important label-danger">Fix</span> Modified menu generator to show HELP when bootstrap is enabled, even if the CMS is not Joomla 3+

<span class="label label-info">Joomla</span> Added Joomla 3.3 CMS specific files and functionality.
<span class="label label-info">Joomla</span> Removed redundant javascript caching code from J2.5/J3 cms specific functionality.
<span class="label label-info">Joomla</span> Obsoleted the old Joomla 3.0 and 3.1 specific functionality as they're no longer supported. 
<span class="label label-info">Joomla</span> Modified cms specific functionality that includes css to ensure that css is correctly included in the administrator area.

<span class="label label-info">Wordpress</span> Solved a problem where page id wsan't set in ajax urls, so links from javascript urls didn't work.
<span class="label label-info">Wordpress</span> Changed how the editor is called in WP so that managers can use html editors.
<span class="label label-info">Wordpress</span> Changed how date is returned from the cms specific function that formats dates.
<span class="label label-info">Wordpress</span> Improved the WP plugins and how they're used to allow things like .js and .css files to be integrated into the head properly.
<span class="label label-info">Wordpress</span> Refactored functionality to improve functionality in WP. Session handling/CMS specific functionality/Javascript file inclusion/Editing mode.
<span class="label label-info">Wordpress</span> Further changes so that when we store some user settings we also save them in the session files. Not really needed in Joomla, but important in Wordpress.
<span class="label label-info">Wordpress</span> Updated Admin's first run instructions to adapt to being installed in Wordpress.
<span class="label label-info">Wordpress</span> Changed how ajax is called via the frontend.
<span class="label label-info">Wordpress</span> Changed the widget installer so that plugin_info is put back into the core plugin folder it originated in so that we can see if a widget is installed.
<span class="label label-info">Wordpress</span> Fixed an issue where WP wysiwyg editor wouldn't be shown in fullscreen view.


<h3>Jomres 8.1.-3 01/04/2014</h3>

<span class="label label-success">Feature</span> Added a new Booking Approval feature that allows managers to screen bookings before they're approved and the booking is inserted into the system.
<span class="label label-success">Feature</span> Added new email template editing feature for managers.
<span class="label label-success">Feature</span> Added support for Wordpress, to allow Jomres to work inside wordpress.
<span class="label label-success">Feature</span> Implemented new functionality that will make error logging and tracking more visible and viewable. Some errors will trigger, among other things, errors being emailed to admin users.
<span class="label label-success">Feature</span> Added ability to filter by property type in the list properties table.

<span class="label label-warning">Change</span> Changed how the manual link is exported to the template in the Plugin Manager.
<span class="label label-warning">Change</span> Added a condition to check that if the user's changing the View of the property list, if so we'll reuse the previous search results.
<span class="label label-warning">Change</span> Code tidyup in router files to remove some duplicates.
<span class="label label-warning">Change</span> Small tweak to management view to update copyright and improve css.
<span class="label label-warning">Change</span> Tweaked the generic booking insert class to allow tax rates of 0.
<span class="label label-warning">Change</span> Changed the upgrade script to use the installer, as the installation code is valid during upgrades too and it saves having duplicate code.
<span class="label label-warning">Change</span> Added check to the installer to see if the manager's table is already populated. If it is, we will not add default data (again).
<span class="label label-warning">Change</span> Added some new translations to the German language file. Thanks Alexander.
<span class="label label-warning">Change</span> Updated some Getting Started text with who's links were broken by the manual update.
<span class="label label-warning">Change</span> Added a check to pathway script to not run if the CMS is not Joomla.
<span class="label label-warning">Change</span> Modified how the installer redirects to the administrator area after upgrade.
<span class="label label-warning">Change</span> Modified the installer to use get_showtime( "db" ) as this is the proper way to find the database.
<span class="label label-warning">Change</span> Tweaked custom text save function to allow meta data to be saved as blank.
<span class="label label-warning">Change</span> Rewrote the Reservation details page to use a new basic_contract_details class.
<span class="label label-warning">Change</span> Reworked the help popover system to use a new "official" version of the bootstrap product tour javascript system. 
<span class="label label-warning">Change</span> Modified updater to ensure jomres.zip is deleted after files are extracted from it.
<span class="label label-warning">Change</span> Added a pull-left to composite property details bs3 to ensure that all button layouts are the same. ( BS3 template )
<span class="label label-warning">Change</span> Changed line item initial quantity from int to float at request of third party dev.
<span class="label label-warning">Change</span> Obsoleted the old javascript packer class and minicomp.
<span class="label label-warning">Change</span> Added new contract uid column to the booking data archive.
<span class="label label-warning">Change</span> Added new secret key and booking data archive id to contracts table. 
<span class="label label-warning">Change</span> Added code to basic contract details class to use the new columns in the contracts table.
<span class="label label-warning">Change</span> Changed the default Production/Development setting to Development, bally thing keeps deleting my installer during dev :D
<span class="label label-warning">Change</span> Editing mode dropdown in BS3 renabled after it's hiatus.
<span class="label label-warning">Change</span> Added Bootstrap 3 versions of x-editable to js library.
<span class="label label-warning">Change</span> Replaced "Click for a map" with "Map" in several language files.
<span class="label label-warning">Change</span> Replaced a / with JRDS in temp booking handler. No errors have been reported, but it's nice to do things properly.
<span class="label label-warning">Change</span> Improved how the find region name function works.
<span class="label label-warning">Change</span> Removed an obsolete reference to JOMRES_MOBILE, a definition that's no longer used.
<span class="label label-warning">Change</span> Changed how an error is triggered in basic property details.

<span class="label label-important label-danger">Fix</span> Fixed a typo in admin's edit invoice, thanks Rod.
<span class="label label-important label-danger">Fix</span> Changed how listeners and drag and drop is done in geocoder code, as IE doesn't play nicely.
<span class="label label-important label-danger">Fix</span> Tweaked show profiles, added trims to prevent usernames with spaces on the end from causing problems.
<span class="label label-important label-danger">Fix</span> IE was playing silly bu^H^Hboys and wouldn't load without using (window).load, however if we use that then the map will not run in module popups, so we need to change the loading trigger depending on the "task".
<span class="label label-important label-danger">Fix</span> Fixed a small bug where if the booker returns to the booking form using the "amend booking" button on the confirmation page, the quantity dropdown of extras was still disabled. Now it's enabled.
<span class="label label-important label-danger">Fix</span> Modified management view to change the url a user gets directed to if they're on the completebk task. If they switch views from normal to full-screen when on that task then duplicate bookings are created, so we've modified the class so that if we're on that page the next page we're directed to is the dashboard.
<span class="label label-important label-danger">Fix</span> Renamed extraServices table to extraservices.
<span class="label label-important label-danger">Fix</span> CSS fix for popovers in fullscreen http://www.jomres.net/jomres-forum/Bugs/22196-product-tour-popups-and-help-definitions-bug
<span class="label label-important label-danger">Fix</span> Tweaked the booking engine so that an edge case that resulted in prices for each room in the booking form rooms list not always showing the price is resolved.
<span class="label label-important label-danger">Fix</span> Made a small change to the BS3 top template to remove a div that no longer has a place due to the management view trigger being moved.
<span class="label label-important label-danger">Fix</span> Modified the Jomres "tmpl" script so that users who name their installations *jomres* don't have problems with jquery being loaded twice in fullscreen/management view. Thanks for the bug report Rod.
<span class="label label-important label-danger">Fix</span> Tweaked the agent view to output the region correctly.

<span class="label label-info">Wordpress</span> Added a new function to determine if we're running Wordpress.
<span class="label label-info">Wordpress</span> Modified the logout minicomp so that it has a clause for non-Joomla CMSs.
<span class="label label-info">Wordpress</span> Updated the wordpress cms specific functions to provide login/out urls.
<span class="label label-info">Wordpress</span> Fixed an issue in control panel where modules dir doesn't exist in WP and shouldn't be included in the writability test.
<span class="label label-info">Wordpress</span> Added a new jomres wp css file for compatability with Wordpress.
<span class="label label-info">Wordpress</span> Implemented a different feature for redirection because Wordpress outputs html before Jomres has done it's thing so header() will not work.
<span class="label label-info">Wordpress</span> Commented out the body of a cms specific function which is used primarily for making url safe strings for url routing.
<span class="label label-info">Wordpress</span> Disabled this "is wrapped" switch if the cms is WP, it's only appropriate to Joomla installations.
<span class="label label-info">Wordpress</span> Renamed the WP admin.php to trigger.php to prevent confusion.
<span class="label label-info">Wordpress</span> Added Main menu dashboard link to WP Admin for Wordpress super property managers.


<h3>Jomres 8.0.1 07/02/2014</h3>

<span class="label label-warning">Change</span> Modified list invoices More dropdowns so that link to print also uses . '&tmpl='.get_showtime("tmplcomponent") so that Jomres modules aren't also included.
<span class="label label-warning">Change</span> Reset a couple of arrays on request of a 3PD to ensure his own functionality works as anticipated.
<span class="label label-warning">Change</span> Modified jomSearch so that unpublished properties are filtered out at an earlier point.
<span class="label label-warning">Change</span> Modified the router. In the previous version we improved searching by Region by using region ids and not region names. This change adapts to that improvement by ensuring that SEF urls still show region names.

<span class="label label-important label-danger">Fix</span> Fixed a wee bug in the Property List dropdown where if there are only two properties the bally Radio button javascript tries to furtle with them, causing an error.
<span class="label label-important label-danger">Fix</span> Resolved an issue where "Showing x of y entries" was not translatable.
<span class="label label-important label-danger">Fix</span> Corrected a function to ensure that the month names are displayed in the stats page.
<span class="label label-important label-danger">Fix</span> Moved the language dropdown outside of the div row declaration as it was causing smaller screens to render incorrectly in the administrator area.
<span class="label label-important label-danger">Fix</span> Fixed a typo for xs columns in BS3 templates.


<h3>Jomres 8.0.0 28/01/2014</h3>

<span class="label label-success">Feature</span> Added functionality to listen to changes to street/town/postcode in edit property pages so that the map marker will be moved when updating the address.
<span class="label label-success">Feature</span> By popular demand, the Active property switcher has been re-added to the menubar. If in management view, then you can use the property selector dropdown in the main menu to quickly change your active property, but be aware if you have a lot of properties this will slow your page rendering down.

<span class="label label-warning">Change</span> Improved the property list. If a property no longer has tariffs valid for "today" then POA is shown in the Price area of the property list.
<span class="label label-warning">Change</span> Changed the editing mode dropdown form class.
<span class="label label-warning">Change</span> Tweaked layout in management_top.html
<span class="label label-warning">Change</span> Modified the new property list selector so that it's put into the showtime var, therefore it's available to both the menu and top templates.
<span class="label label-warning">Change</span> Tweaked the property list so that the region search url uses the region id, not the region name.
<span class="label label-warning">Change</span> Changed where the property dropdown switch will show.
<span class="label label-warning">Change</span> Added some security hardening.
<span class="label label-warning">Change</span> Added Bootstrap 3 js and css for use in the Management view for when BS3 is switched on in Site Config.
<span class="label label-warning">Change</span> Changed how ajax lists parse data as some hosts were unable to use the older functionality.

<span class="label label-important label-danger">Fix</span> Fixed a minor issue where Resource Features was hard coded into the show room details template.

<h3>Jomres 8.0.-1 24/01/2014</h3>

<span class="label label-success">Feature</span> Added new functionality to allow us to implement our own tmpl=jomres layout to Joomla templates. Jomres Fullscreen view is the best interface for managing properties however many Joomla templates do not always support the Joomla functionality required to do this properly. As a result we've implemented new functionality that will allow us to use our own code to ensure that the layout is of the high quality you've come to expect from Jomres.
<span class="label label-success">Feature</span> Implemented blockUI in plugin manager to provide feedback that plugins are being updated and you should not interrupt the page. Thank you Rod, you lovely man.

<span class="label label-warning">Change</span> Jomres' Polish lang files updated to 8.0.-2 lang strings. Many thanks Patryk.
<span class="label label-warning">Change</span> Enabled the Bootstrap 2/3 switch in site config.
<span class="label label-warning">Change</span> Changed the url that the Preview menu option points to.
<span class="label label-warning">Change</span> Modified plugin manager so that disabled links inadvertently clicked will not attempt to install a plugin that user has not rights to install. It will just end in a fatal error if they do because the plugin is never returned.
<span class="label label-warning">Change</span> Changed a condition to ensure that the correct version of Jomres' css file is called if Bootstrap 3 enabled.
<span class="label label-warning">Change</span> Updated help topics for those pages we feel needed an update.
<span class="label label-warning">Change</span> Improved input filtering. Whilst javascript cannot be entered in a meaningful way to cause XSS problems, we've added a check for "; and '; anyway to further confound attempts.
<span class="label label-warning">Change</span> Modified 3.2 cms_specific_functions.php so that editor readmore etc buttons are not shown.

<span class="label label-important label-danger">Fix</span> Fixed an issue where if a guest is already registered but not booked before their region would default to the wrong region.

<h3>Jomres 8.0.-2 20/01/2014</h3>

<span class="label label-success">Feature</span> Added a new feature so that managers can easily make multiple rooms of a given type.

<span class="label label-warning">Change</span> Added show/hide column javascript for tabletools to jq ui templates.
<span class="label label-warning">Change</span> Removed format=raw, not all joomla template support this and it`s not really needed anymore
<span class="label label-warning">Change</span> Changed management view for the links to be SEF'd when switching from fullscreen to normal.
<span class="label label-warning">Change</span> Toolbar buttons are separated. Having them grouped together makes them a long unresponsive bar in certain pages.
<span class="label label-warning">Change</span> Changed the trigger point the property config uses to detect if Advanced/Micromanage plugin is installer so that Advanced and Micromanage modes are offered in the dropdown so that they can be chosen.
<span class="label label-warning">Change</span> Added a line number to patTemplate debug backtrace to help us to identify missing templates.
<span class="label label-warning">Change</span> Added code to remove some older directories that are empty. Will also be useful for deleting entire directories in future.
<span class="label label-warning">Change</span> Removed blockUI functionality from Jomres Plugin manager, doesn't trigger at the correct point (might be an issue with FF debugger and the trigger order) so will revert to a simple alert for now.
<span class="label label-warning">Change</span> Implemented some caching for plugin manager badges, Jomres version and News to reduce load on the plugin server.


<span class="label label-important label-danger">Fix</span> Added some missing templates to jq ui and bs2 template dirs. They're not needed (currently) but patTemplate throws a wobbly without them.
<span class="label label-important label-danger">Fix</span> Modified dashboard so that it's not run if on a Jintour property.

<h3>Jomres 8.0.-3 17/01/2014</h3>

<span class="label label-success">Feature</span> Completely revamped the guests, property and invoice listings pages, you can see invoices for all properties or just the active one, filter by various options and configure the columns to suit your specific requirements. Virtually all tabulated data is loaded via ajax, improving page response times when dealing with large amounts of data.
<span class="label label-success">Feature</span> Tariffs, rooms and room types have been moved into their own pages, they're no longer all part of the same page.
<span class="label label-success">Feature</span> Improved the dashboard further, bookings are easily viewed as their indicators span multiple dates.
<span class="label label-success">Feature</span> Added the ability to enter your own deposit amount on the enter deposit page of a booking.
<span class="label label-success">Feature</span> Improved show property review page, converted rating numbers to progressbars. Added a new function calc_rating_progressbar_colour to functions.php
<span class="label label-success">Feature</span> Added new Jomres css file for BS3, config panel and toolbar classes. Edited many templates.
<span class="label label-success">Feature</span> Removed the switch property feature, now properties can be switched from the list properties table.
<span class="label label-success">Feature</span> Updated the Jomres Main Menu, added options to Site Config so that managers can choose where the menu is located (default, top or bottom) and whether or not it's colour is inverted. Added a Search input to the menu to allow managers to easily search for bookings by their booking number. (Management view only).
<span class="label label-success">Feature</span> Added a variety of changes that allow us to have a Bootstrap 3 set of templates. BS3 is becoming more popular, more and more Joomla templates are appearing and later versions of Joomla will support BS3 so it'll be nice to pre-empt those changes beforehand.
<span class="label label-success">Feature</span> Added an experimental feature to prevent caching ajax reponses so that jomres can work with joomla caching enabled

<span class="label label-warning">Change</span> Changed menu options around to bring them a little more in line with industry standard.
<span class="label label-warning">Change</span> Added links to top of the guest confirmation email which will take the guest to the property and to their booking.
<span class="label label-warning">Change</span> Added currently active property string to the top template.
<span class="label label-warning">Change</span> Removed some code that we added a year ago as many people do not use unique names for tariffs, consequentially their tariff list was becoming unordered.
<span class="label label-warning">Change</span> Modified the Bootstrapped Management view, remove left columns and moved some stuff around.
<span class="label label-warning">Change</span> Re-organised property settings making their placement more logical for property managers.
<span class="label label-warning">Change</span> Changed how the Minimise configuration options in Site Config works. If this option is set to No then non-managers will see a new toolbar in Site Config that allows them to set whether they see Simple or Extended configuration options. Super Managers will see this all the time.
<span class="label label-warning">Change</span> Changed how the showconfirmation page works so that Jintour/norooms based bookings can have their own template.
<span class="label label-warning">Change</span> Disabled timezone functionality in Jomres as Joomla is capable of setting time zones for users. (Was relevant for older versions of Joomla, but not any more).
<span class="label label-warning">Change</span> Experimentally removing a redirect from the usermanagement script.
<span class="label label-warning">Change</span> Added the ability to create new Common strings that are available to all templates through a minicomponent.
<span class="label label-warning">Change</span> Improved the property list prices class to ensure that the lowest price found is correct. Thanks Rodrigo!
<span class="label label-warning">Change</span> Added a check to see if a room is already in the user's cart, if it is then the room lock isn't released.
<span class="label label-warning">Change</span> Changed alert regarding updates so that it is a link that goes direct to the updates page.
<span class="label label-warning">Change</span> Added page blocking when Upgrade All Plugins is clicking in Plugin Manager. Provides feedback to users ensuring that they do not attempt to use the page until the plugin upgrade process has been done (essential on systems with slower internet connections).
<span class="label label-warning">Change</span> Added HELP targets to the srp dobooking page.
<span class="label label-warning">Change</span> Updated language files so that help comments make sense for Jomres 8's new dashboard.
<span class="label label-warning">Change</span> Added support for listing guests for all manager`s properties.
<span class="label label-warning">Change</span> Tweaks to have ptype_xref in the features array, so we can use this when filtering by property type id in ajax search composite.
<span class="label label-warning">Change</span> Renamed the listlivebookings task to list_bookings and made it a j06001 minicomponent. Updated various files that use this old task name.
<span class="label label-warning">Change</span> Rewritten and simplified the tag search functionality.
<span class="label label-warning">Change</span> Added a channel manager option to mark certain bookings as channel manager bookings. If they are then the system will not allow channel manager bookings to be cancelled (they have to be cancelled via the original channel's UI, not Jomres).
<span class="label label-warning">Change</span> Removed some special header settings that are no longer required.
<span class="label label-warning">Change</span> Added some changes that tweak how modals in work in new functionality.
<span class="label label-warning">Change</span> Added a pdf clause to php mailer for a third party plugin dev.
<span class="label label-warning">Change</span> Added navbar form css class to language selector dropdown.
<span class="label label-warning">Change</span> AAdded check for bootstrap version to custom template handler.dded form-control css class to dropdown that aren't radio buttons.
<span class="label label-warning">Change</span> Removed the old "report bug" function. It's served it's purpose and is rarely used nowadays.
<span class="label label-warning">Change</span> Further template updates. Added role where required, removed form-horizontal and updated input types in several places. (BS3)
<span class="label label-warning">Change</span> Added placeholder lang definitions and html to templates and supporting classes.
<span class="label label-warning">Change</span> Reworked the jomres_toolbar_bootstrap3.class.php class so that "delete" items are a separate item in the toolbar. Should help prevent fat finger mistakes.
<span class="label label-warning">Change</span> Modified the Jomres main menu so that the Search option is hidden if the site is in Production mode. It is intended for developers to see frontend options like Flipwall etc and not for use by the General users.
<span class="label label-warning">Change</span> Experimentally changed top.html to comment out the editing mode dropdown altogether. This should help us to see just how many people use the editing mode in the frontend. I suspect that the vast majority use the administrator features only.
<span class="label label-warning">Change</span> Modified list properties so that review information in list properties is shown through it's own template (BS3 only). This is because of how we render the list properties template.
<span class="label label-warning">Change</span> Tweaked "Click to show reviews" to say "Show reviews". 
<span class="label label-warning">Change</span> In BS3 modal popups need to be wrapped inside modal-dialog and modal-header so added new output in integration.php and jomres.php that'll call template files that will add that if $_REQUEST includes modal_wrap.
<span class="label label-warning">Change</span> Added a utility function that'll output a simple template (helps with the above change).
<span class="label label-warning">Change</span> Added a new utility function make_modal_button to help us easily create modal links that can be used to create popups for any Jomres page.
<span class="label label-warning">Change</span> Created a new function in input filtering that allows us to convert European entered price values into floats. (replaces , with .).
<span class="label label-warning">Change</span> Mobile device detection and redirection removed from Jomres' functionality. This was added while Joomla 2.5 was the current version, and before Bootstrap and it's mobile-centric functionality was added to Joomla so it's out of date and no longer has a place in the core system.
<span class="label label-warning">Change</span> Deleted the old batchupload.html template files.
<span class="label label-warning">Change</span> Removed 7.5.4 library of the older bootstrap 2 dashboard.
<span class="label label-warning">Change</span> Obsolete file removal changed so that if site is in Development mode then confirmation is required before file deletion.
<span class="label label-warning">Change</span> Created new administrator area media centre templates, because if a site uses BS3 in the frontend, the administrator area will need it's own BS2 versions of those files instead of BS3 versions (for now).
<span class="label label-warning">Change</span> Disabled the Audit Trail feature. We believe it's not used and therefore not worth maintaining. Disabling the feature will allow us to judge if this is the correct action.
<span class="label label-warning">Change</span> Tweaked save language choice script so that if no files are selected then the file normally created is removed.

<span class="label label-important label-danger">Fix</span> Replaced a problem apostrophe with it's entity in the French lang files.
<span class="label label-important label-danger">Fix</span> Removed a width setting to allow the admin's first run popup to show better on smaller screens.
<span class="label label-important label-danger">Fix</span> Dashboard tooltips changed to popovers to avoid conflicts with jquery ui tooltips.
<span class="label label-important label-danger">Fix</span> Modified Bulgarian Lev from BGL to BGN.



<h3>Jomres 7.5.4 19/11/2013</h3>

Fixed an issue in jq ui frontend list properties.
Some improvements to property name search/dropdown generation, also pnames are now sorted alphabetically
Added the item property "telephone" to the header template.
Modified the currency conversion functionality so that it updates less frequently.
Fixed an issue where some users can't see the My Properties list properly.

<h3>Jomres 7.5.3 14/11/2013</h3>

Updated the dashboard, bootstrapped templates (Some J2.5 and all J3.x Joomla installations) have a new purty bootstrapped dashboard.
Added a new feature that loads the My Properties list via ajax. This allows us to load data-heavy pages through an ajax interface, reducing memory load. This change is effectively a prototype for futher changes of it's ilk.

Added a small change to set the component title in Joomla 3.1 & 3.2
Removed the need for the property uid to be in the url when editing a property.
Improved the access control class.
Updated a condition to check for Joomla 3.2.
Added a change that removes some unneeded scripts for J3.2.
Updated the bootstrap editable library.
Added a change to basic property details that stops unpublished property types from being listed.
Added a change that uses gravity setting in tooltips where possible.
Discovered that the J3.x series of installation files weren't moving the updated copy of jomres.php to /components/com_jomres so upgrading users were unable to take advantage of new Jomres/Joomla features.
Removed some tooltip date calls from dashboard calendar as the cms specific date function (I'm looking at you here Joomla) somehow breaks the old-style dashboard.
Further Joomla 3.2 specific changes.
Moved tariff editing dropdown in Property config into it's own tab. Makes it easier to switch it on/off programatically.
Added a new trigger to the save hotel settings page which allows plugins to do some post-save parsing, and even forbid changing of settings altogether.
Added a few improvements to the media centre layout.
Temporarily disabled Jomres' timezone functionality. Joomla is now stable with it's tz handling so Jomres functionality should no longer be required.
Obsoleted the Manager's first run script, as it's superceeded by the new page tour functionality.


<h3>Jomres 7.5.2 07/11/2013</h3>

Added Joomla 3.2 specific changes to Jomres.
Added new functionality to allow easy inclusion of searches for countries, regions, towns and property types as joomla menu items.
Updated both Polish and Catalan language files.
Tweaked how a misc url definitions file is generated.


<h3>Jomres 7.5.1 19/10/2013</h3>

Modified the mailer exception class to check and see if the class already exists and to not include it if it does.
Modified the basic module output to standardise the images available to the template.
Modified search functionality so that the property name dropdown will be shown when the module is used on non-Jomres pages.
Resolved an issue that one user was having where mysql would not accept '' as null for the paid date (because the invoice isn't paid yet).
Fixed wiseprice discount so that it would show in the property details tabs.
Tweaked the edit my account page so that if the site config option "properties are in this country" is used, then by default the edit my account page defaults to that property and the regions are available as appropriate.
Fixed an issue where once a discount coupon code is found to be valid, it's applied to other bookings during that session where the dates are not valid.
Fixed an issue where if captcha was enabled, then messages couldn't be sent.
Modified the installer, changed a column type for new installations to prevent error messages in the installer.


<h3>Jomres 7.5.0 07/10/2013</h3>

Added a new feature that offers integrated help on many of the top level pages in the frontend of Jomres. As this more suitable for property managers we will be retiring the old Manual plugin as that had too much information which wasn't relevant to property managers.


Removed an important hard coded maptab id by mistake, by overwriting an array index. Restored that now.
Fixed an odd bug where some, valid, VAT numbers wouldn't be validated.
Removed some code from the integration script that prevented caching, as the issue it's trying to fix is negligible.
Fixed a bug new to 7.4 where the profiles list was empty.
Property area activities added to a query in the basic property details class.
Modified the custom field handler to cope if the appropriate xreference field is empty.
Moved review and growl messaging javascript into the consolidated minified javascript files.
Disabled a growl popup that has been left in a depreciated javascript function because it causes errors when popups are disabled.
Combined two dynamically generated files into one.
Added new language translations to Polish lang file. Many thanks Patryk.


<h3>Jomres 7.4.0 23/09/2013</h3>

Added a new feature called array cache, which significantly speeds up Jomres performance.
Added the new Jomres Media Centre, which improves the image uploading process. This is available to the frontend for uploading images to properties, and in the backend for uploading room type and property feature images.
Added a complete new global rooms feature that works like business features. This will alow managers to select room features when editing the room, without the need to create them first in the room features tab. The room features tab and functionality is still kept, so managers can still add their own room features too.

Fixed a bug where new user's bookings weren't always being associated with their user ids.
Modified the input filtering functions so that ampersands aren't double encoded.
Removed some unnecessary stripslashes calls.
Removed a couple of no_html hidden inputs that were causing black bookings to give white pages on step 2.
Fixed a bug where language choice selection wasn't being saved, as a result of code hardening.
Added bootstrap multiselect to Jomres.
Changed how the exchange rate dropdown is rendered to fix markup.
Removed a no-longer needed style from Jomres bootstrap css file.
Business features feature has been changed, so now we can assign more property types to one feature instead of duplicating it for each property type where we want to show it.
Added a cms specific change to ensure we're getting the SEF setting correctly.
For Joomla 3.1 installations we've removed Jomres native IDN, as J3.1 has this feature now.
In database.php, we've added query caching. It`s not visible when one guest is visiting the website, but when more are doing it at the same time, queries will be executed once and results provided to all, instead of executing the queries for each guest.
Found and resolved an issue on the booking form when rooms list style is enabled. When deselecting rooms, they were not unlocked.
Added Superior as image, same size as stars. This will make it display better. Also add S to property list list with maps, module popup and ngm module output.
Fixed a minor issue where featured listings css class was not added to the next results displayed when live scrolling.
j16000save_custom_field.class.php moved into the Custom Field plugin, where it belongs.
Modified several default language files so that instead of referring to "Room features" we're using language more appropriate to the situation.
Added a JSON library to adapt to the situation where CERTAIN linux builds do not include JSON in PHP 5.5. It's a pre-emptive strike against silliness.
Tweaked the installer to adapt to the new property type changes, tricked an older upgrade function to not trigger if a new column already exists. 
Added room abbv to showroomdetails output
Modified the tool tip room type template.
Updated the Polish language file, many thanks Patryk.
Added a variety of changes that reduce the amount of calls to gmaps, updated galleria slideshow, and some layout changes for empty tables to improve how they look.
Improved how the immediate pay plugin shows the paypal icon/link.
Removed the hr from the tooltip popups. (Bootstrap)


<h3>Jomres 7.3.2 12/08/2013</h3>

Modified user booking page to ensure that correct prices are shown.
Fixed a counting error in the view invoice script, ensuring that the Amount Already Paid var is set correctly. Thanks Marinhio.
Removed references to no longer used Jomres token functionality.
Resolved an issue where no bookings could be taken. 
Removed contents of $_SERVER magic var from the session file. 


<h3>Jomres 7.3.1 06/08/2013</h3>

Modified the jomres_decode function (the output filter) as it was allowing users to inject javascript into certain pages.
Modified the input filtering script. Ensured that the default value that's passed to the jomresGetParam function is used to set the type of variable that's passed, this is used later on to decide how we'll filter the entered value.
Modified the Edit Profiles function to do nothing if the profile id = 0
Modified the input filtering script. Ensured that the default value that's passed to the jomresGetParam function is used to set the type of variable that's passed, this is used later on to decide how we'll filter the entered value.

Modified show plugins script so that if the license isn't valid or entered, they buttons show but in their disabled state. Makes it more obvious to new users how plugins are obtained.
Fixed a bug in the confirmation letter where qr codes wouldn't show because of image sizes in the html.
Tweaked the confirmation form printout so that quote marks are included where appropriate.
Modified the Jomres mailer functionality to set the image name in the email body, rather than a generic name.
Modified the subscribe script so that only a specific set of circumstances will allow it to proceed, otherwise there's a chance that the script will go into an eternal loop.
Tweaked the layout of the jq ui frontend_view_invoice.html template file.
Fixed a typo that prevented switching from C to F in google map weather layer.
Modified the Approvals menu script to only show the option if automatic approvals are disabled (IE site managers have to manually approve properties).
Simplified the backend a little more so that if Advanced Site Config is set to No then fewer options are viewable.
Removed a recommendation from the Getting Started text that referred to adding a login option. It is redundant now as we've got a link in the Jomres main menu that goes to that form (because people didn't read the getting started and didn't add the module).
Added a new option to site config to set the site into production or development mode. Setting it to development allows us to enable error reporting.
Renamed idna_convert class to jomres_idna_convert because several other Joomla components use this class, and we want to prevent fatal errors because they also include the same class.
Modified invoice output to ensure that the correct outstanding amount is shown.
Tweaked QR code generation and display to ensure that it images in emails work in all devices.
Property name added to module popup.
Changed how Gmaps is called, added gmaps to head of the page and instead of calling it "as needed", we're calling it right at the beginning of the run. When called "as needed" it was loading the gmaps source multiple times which prevented the maps from loading properly.
Solved a problem that's created when all layers are disabled in gmaps.
Modified the printable_invoice.html template to include arrival/departure dates snippets.
Replaced references to html_entities_decode, instead sending the strings to jomres_decode function, which parses strings before output.
Removed some string replace quotes code that's no longer needed.
Modified show property header so that meta data is passed through jomres decode before display.
Modified edit property so that output data is NOT passed through jomres decode.
Modified the call to the layout variable to ensure that it's sanitised properly.
Modified generate control panel script to use the showtime variable.
Worked through the code to ensure that all inputs have been properly sanitised, where appropriate.
Removed several usages of the jomres_decode function that we believe are no longer necessary.
Fixed a bug where bookings from gateways wouldn't be associated with existing users, if they hadn't booked before.
Modified booking insert stage so that if the user isn't an existing guest then the first/surname they entered is used as a reference to who made the booking.



<h3>Jomres 7.3.0 19/07/2013</h3>

Added new functionality that allows Jomres to communicate with the VIES webservice and validate VAT numbers saved when a user enters their account details. (Euro properties only)

Added the qr code library to the core system, and associated code to the email functionality to allow us to include images in emails. 
Added "office use" qr code, which prints a qr code to the edit booking page, and "gmap directions" qr code for users to get directions to their property, to the confirmation email and confirmation letter pages. The QR code in the email is intended to give receptionists a quick way of accessing the booking information page in Jomres, allowing them to book guests in/out while on the move.
Added the ability for the booking form to receive a coupon code via the url. The Coupon code plugin has been updated to allow managers to show lists of coupons with QR codes. These can then be handed out to guests who'd scan the code into their phone and immediately benefit from the discount code in the booking form.
Added gmap qr code to property header for users who want to get directions.

Edit my account form changed, now the region input is a dropdown, not a freeform input.
Modified the booking engine so that the guest region is now a dropdown, rather than the free-form'd input used previously.
Added region dropdowns to the guest admin page(s).

Added new functionality that allows us to offer to import tax rates for all of the EU.

Added a number of changes that allow property managers to store the vat number associated with the property, and managers/receptionists to add a VAT number to a guest's details. (note : guests cannot currently be offered VAT free invoices for bookings, that's specifically disabled, but the code is in-situ to achieve that if desired).
Added functionality to add VAT numbers to the invoice printouts in the frontend.
Added code to help us to determine if a guest should or should not be charged VAT.
Added a new tab to the property configuration area where the property's business details can be added, making them distinct from the property's location. Changed Site Config so that the site business address details country and region are chosen through a dropdown.
Added some changes that allow us to associate a tax code with a commission rate.

Modified the subscription functionality so that it doesn't need the manager to re-enter their details again, fixed an issue where invoices wouldn't be saved (due to our new changes).

Modified functionality of the og code so that it's added to the head of the page instead of the body.
Modified the invoice view to have rows relating to recurring prices added to the template as a snippet from another template.


Added a tweak to allow redirection directly to urls when the active property is changed
Improved a new change that saves space at the top of the page depending on whether timezone/language dropdowns are enabled in Site Config.
Modified the grand total figuring to exclude init totals that're < 0, because they're payment line items which will cause the grand total to show incorrectly.
Added no cache headers to integration.php to prevent IE's developer tools causing problems.
Tweaked some autocomplete = off in inputs to lowercase. 
Changed how a new line in the invoice has the grant total of tax calculated.
Improved the invoice output a little. Commented a couple of columns in the list invoices page to make it fit better, and made the view invoice page only show recurring items if the recurring total is > 0.00
Updated phpmailer to mailer 5.2.6. Made older mailer class obsolete.
Changed how the add your property link is shown in the main menu, so that non-managers can also see that option without the site manger needing to add a module, if they don't want to.
Added some new changes to the printable invoice so that they also show the new grand total outputs.
Removed BOM from a number of files.
Corrected a language string that incorrectly referred to an older implementation of Jomres that no longer exists.
Added nusoap library to Jomres.
Added a new minicomponent that'll return the region dropdown, intended for use via ajax.
Changed the show guest details script to find the region name using the find_region_name function.
Disabled the Jomres caching switch in Site Config. Given the dynamic nature of the system, there's too many things that can change so it's better not to use it atm.
Renamed the Venezuelan region Dependencias Federales to Territorio Insular Francisco de Miranda
Added a number of changes to fix an issue where sometimes the global editing mode wouldn't work in the frontend.
Prevented pathway script from calling basic property details class when it doesn't need to.
Modified pathway functionality so that the urls are sef'd.
Updated the de-authorisation procedure to ensure that manager ids are also removed from the manager/property xref table.
Tweaked the jrportal functionality that calls 07010 (which is mainly used to insert orphan commission line items) so that if the booker is a super manager, then their details aren't used for raising commisssion items.
Added a check to see if the manager trying to log in hasn't got any properties. If they don't, then we back out gracefully.
Added arrival/departure date output to the invoice.
Changed how external urls are filtered before they're shown in the property header.
Changed the point where the shopping cart is emptied after bookings are created.
Ensured that the javascript inclusion plugin imports the IDN conversion script as in some edge cases it wasn't being included beforehand.
Improved the cron invoice logging so that the email address is readable.
Added some changes that (again) prevent double clicking when making payments to prevent the blank emails that some people get.
Added a check to the manager's first run script to ensure that only super property managers see the Wizzard.



<h3>Jomres 7.2.19 11/06/2013</h3>

Reversed the previous change that prevents double clicking as it does not work on Chrome. Special release for this as it's a fairly major issue.

<h3>Jomres 7.2.18 11/06/2013</h3>

Added a new site configuration tab that allows you to enable/disable Google map layers. The choices are Weather/Traffic/Transit/Bicycle & Panoramio. You can also use the same tab to enable/disable the default POIs.
Modified Jomres to add an S after the property header and property list stars, to indicate Superior properties. Added code to make this distinction when editing the property details page.
Added some tweaks to the booking confirmation form to prevent users double clicking the submit button.
Added lines that clarify grand total tax, and grand total ex and inc tax, and the booking number, to the frontend invoice output.
Added options to gmaps to disable the POI layer (so that potential guests can't see your competition on the map).
Added custom language strings to the recaptcha contact_owner.html templates, lang files and minicomponent.
Added metakeywords option to edit property details.
Added noindex,nofollow to the contact owner and booking form pages to prevent spidering on specific pages. Also added code that allows more meta tags if we wish.
Added a function that allows us to get invoices for multiple properties.
Added the Catalan language to the system.
Added a warning RE max input vars to the control panel.

Added new language definitions to Polish language file, many thanks Patryk.
Tweaked how the cron log is shown. dd was actually the week number, now it's the date.
Replaced calls for the function that calls mrConfig with a reference to this->mrConfig. (Booking engine).
Fixed a path to some images in the ratings css.
Added a check to see if JRAJAX is already defined before defining it.
Added some code to check and see if the input filter class already exists.
Modified the basic property details class so that we can pass the property type to the property list.
Tweaked the room type list in Normal editing mode so that SRP and MRP room types are only shown when appropriate.
Added a change to the basic_property_details class so that only room types for this MRP/SRP are pulled out. Makes listing room types when editing tariffs clearer.
Updated our star image to be a larger, golden star.
Improved the exchange rate class file so that it doesn't try to download exchange rates so often.
Modified some code to reduce the amount of times a tariff's periods are called to speed up generation of the rooms list.
Modified sanity check code to see if it's an ajax call. If it is, there's no point in running the check.
Removed a superfluous semi-colon that IE10 has taken a dislike to in the booking engine.
Fixed a bug where if max people in a room was > 10, the single person suppliment wouldn't be set correctly.
Modified edit_my_account.html template to improve responsive layout.
Changed Ukrainian currency code from UAG to UAH
Tweaked handlereq so that the address fades in once, not twice, when a room has been selected.
Tweaked jomres_cron to take into account new IDN related changes, specifically in relation to non-IDN domains.
Added thead/tbody to list_bookings.html to resolve a javascript issue with tableTools javascript.
Modified top template generation so that if lang/timezone/editing mode dropdowns are not available then space at the top isn't used up.
Resized the star image and introduced a small css change to make the S in superior match it's related star in property header.
Fixed recaptcha configuration tab information text.
Fixed an issue where Cron jobs weren't always being triggered correctly.
Improved the backend list invoices script to show guest names, even if the bookers are not registered users.
Improved the growl javascript popup, fixed an issue where the css gradient for jq ui wasn't showing properly, giving a two tone look to the popup if it takes up more than a couple of lines.


<h3>Jomres 7.2.17 14/05/2013</h3>

Added a new switch to allow users to swap between jq 1.8 and jq 2.x
Updated jgrowl and jquery rating javascript libraries. On at least one customer the older libs are triggering js errors due to $.browser not being available in jquery 1.9 and greater, and we're using jq 2.0.

Added <meta property="og:image" content="{IMAGETHUMB}" /> to property header templates.
Updated the Montenegro regions.

<h3>Jomres 7.2.16 13/05/2013</h3>

Updated jQuery library to jQuery 2 as it's faster. Downside of this is that older versions of IE (6/7/8) and v old versions of Firefox etc are no longer supported. We will watch the tickets to see if we need to add jQ 1.9 and an administrator area switch that'll allow those older browsers to work.
Modified save review and save report so that admin emails are sent when a review or report is entered. 
Added a tap to call button to the (bootstrap) property header template, which is viewable when on a phone. Allows phone users to call hotels directly.
Updated the plugin manager so that the "update all plugins" button will only show if the license key is valid.
Added guest address information to the hotel booking email. This has been added only to the output array, it hasn't been added to the template itself, it's for designers to use if they wish.

Added country/region/town to the jomresHTML class to prevent Bootstrapped pages from trying to make them into Yes/No buttons.
Passed region through cms specific string safe function to aid searching translated region names.
Added a new helper function genericLike.
Added a new find region id function to the installer, specifically for the installer. The functions.php version of this function has recently had a call to a Joomla function added. This creates a problem during installation. Rather than making the find_region_id ALWAYS check for the existence of the CMS specific function every time it's run, we'll duplicate the function here instead. find_region_id has the potential to be called many times, so the fewer calls we can make to check if a function exists when 99.99999% if the time it does, the less load we're creating.
Added a flag to the send admin emails function that switches off the contents of $_POST.
Updated Swedish language files.
Tweaked language for the System log name, the security scanner I use to check the safety of language files throws a false positive on it's old name of System log. Changed to Misc now.
Tweaked the Booking Rooms tab to hide the rooms list style if the property is an SRP.
Tweaked the booking engine slightly. When amending a booking, SRPs with fixed period bookings and fixed arrival dates were finding that the stay day period wasn't set, forcing users to reselect the appropriate number of days for the booking before they could proceed. Used some built in variables to reset the stay days in the event that this happens.
Fixed a minor bug with the Add Review label for input set 4.
Changed how session ids are used. These are used to build our own session data, and we've added a cms specific function so that we can reuse J2.5+ session ids instead of the PHP session.
Added old Jomres SA files to the obsolete files list. Nothing's been done to this in quite some time, as everybody uses Joomla.
Improved how the booker's username is added to the database when a booking is created.


<h3>Jomres 7.2.15 20/04/2013</h3>

Fixed the breadcrumb repeating problem. Thanks Raphael Vilela.
Changed the name of the administrator menu used in installation into the administrator area.
Improved a condition that prevents Jomres from loading the jquery core js files if we're running J3.0 or J3.1
Fixed a typo that checks for region or country table existence in the installer.
Added a page-header class definition to booking form template (bootstrap).
Changed an initialising option that defines minimum interval as an intentionally abnormally high figure, to 1.
Changed how jr_gettext figures out if we're in the administrator area.
Updated German, Italian and Hungarian lang files with some new improvements.
Tweaked property list to ensure that the featured listing class is used properly.
Added new code to help users who're upgrading from J2.5 to J3.x. Modified the installer to remove admin.jomres.php and install jomres.php to the administrator/components/com_jomres directory. If you upgrade from J2.5, you will find that you cannot access jomres.php until you run the 7.2.15 version of install_jomres.php
Tidied up a line in the javascript minicomponent that no longer makes sense within the context of J2.5/3.0.
Removed a redundant check that was causing the price summary to sometimes not show due to the order that the minimum interval is calculated.
Tweaked the booking class to show the price in the allocation popup only if a price variable is set and the tariff mode is Average.
Added a caveat in the show confirmation script so that the email address is only updated if the user isn't registered.
Tweaked output so that booking form summary "number of days/weeks" etc is updated correctly. Previously, if Advanced tariff editing is used, and prices stored weekly option is set to yes, the "weekly" price would in fact show the nightly price. A little confusing so this will clarify that output.
Tweaked a method so that pricing output figuring is done by an already existing method.


<h3>Jomres 7.2.14 28/03/2013</h3>

Fixed a bug introduced in the last version that was introduced by some new functionality that helps us deal with IDNs.
Tweaked the position of a patTemplate tag in the plugin manager.

<h3>Jomres 7.2.13 27/03/2013</h3>

Added Joomla 3.1 specific changes. Jomres now works on Joomla 3.1 (beta1, as that's what's available right now).
Added a new button to allow upgrading of all Core plugins on one button click.
Small fix for room names in confirmation page, room were displayed concatenated like name1, name1name2, name1name2name3 and so on instead of name1, name2, name3.
Template fixes, missing / in printable_invoice.html and a /td that shouldn't be in frontend_view_invoice.html in bootstrap.
Tweaked the property list so that if an array's index is null, we find the tariff name through another route.
Changed a url in the cron class to ensure curl calls are sent to the frontend, not the backend.
Fixed a typo that incorrectly set a variable (popup).
Used new simple_tariff_to_date_map variable to provide feedback on properties that use Advanced tariff editing mode, to tell people that they need to select a longer booking.
Disabled the minimum interval input, as it's no longer appropriate due to changes in how the booking engine figures out minimum intervals.
Further tweaks to IDN handling code to ensure that curl calls for cron jobs work as expected.
Changed how the External Link is constructed in the property header, and how it's displayed in the header template(s).
Added a random id to the js date picker so that jquery can use that id to reset the checkbox.
Cleaned up a couple of inputs in edit/register property types to change an input type (templates)
Modified idna url functionality to allow us to choose which method of encoding a url we use (stringURLUnicodeSlug), depending on Joomla's settings.


French lang files updated, many thanks Vincent.
Added Arabic language file to Jomres core.


<h3>Jomres 7.2.12 07/03/2013</h3>

Fixed an incorrect file path in the obsolete file handler.
Fixed filters in show invoices scripts.
Tweaked a new condition that causes some prices to be set to POA if arrival/departure dates are never shown in search module inputs.
Made a small change to the booking engine so that if tariffChargesStoredWeeklyYesNo is to yes, and tariff mode is set to Advanced, then prices will be output correctly. Adds a distinction for those users who've swapped from tariff charges stored weekly/advanced to Micromanage mode. The option is not valid for micromanage users.
Added some part-translated Swedish language files to the Jomres Core system. Many thanks Marinhio, hopefully this will save you hassle when you next upgrade :)
Added functionality to allow Jomres to detect if we're on a punycode (IDN) url, and to convert urls internally to adapt. Without that adaptation ajax will not work in IE because IE thinks that you're attempting cross browser scripting.
Added a space before a string in discount output.
Tweaked output of property details main tab so that Tour properties show the property type text instead of the non-existent room type icons.
Removed not required text from the show tariffs templates.
Improved code that adds property type names to property details main tab so that the property type is translated.
Tweaked list properties. If the installation is set to be a single property installation then as before we will redirect straight to the booking form, however we'll append arrivalDate if it's in the $_REQUEST global variable.
Tweaked edit property page so that the change country warning isn't shown when the site is configured to limit registrations to just one property.
Added a missing <tr> to jq ui dobooking_srp.html
Changed how filter properties works. A couple of users have reported that their installations are reporting that PHP5.3 specific functionality is triggering a fatal error on their installations. PHP5.3 should support anonymous functions, however it appears that some installations don't and report a fatal error so we've tweaked some new sorting code to resolve that.
Fixed a faulty link in list guests invoices script.
Layout tweak to list commission invoices script.
Replaced an icon in the bootstrap toolbar class.
Added jomresDecode to guest's names to allow apostrophes to show properly.
Added a few more tweaks regarding region name translations.
New functionality to render safe urls has broken searching for All regions/towns in the built-in search feature, so we've added a clause to resolve that.
Jquery ui badges mis-behave when using gradient backgrounds, so we've removed the gradients.
Tweaked a javascript void in the cookies.html template so that it doesn't report an error.

<h3>Jomres 7.2.11 21/02/2013</h3>

Added new functionality to disallow re-use of email addresses if the system is configured to create new users when bookings are made.

Improved how some tariff type filtering is done in the booking form.
Filter properties script updated to work with translatable region names.
Tweaks to guest list invoices minicomponent.
Prettified validation in jq ui booking templates.
Updated the version of jquery validate we use
Added itemid to sitepage no sef url.
Backend confirmation letter moved from backend to frontend, so that the Template Editing feature can be used to style it.
Modified show tariffs 01025 script. Allows us to differentiate between Normal and Micromanage modes to tweak the layout slightly.
Fixed the path to the large image in the module popup script.
Tweaked the get_property_price_for_display_in_lists function so that it also checks the temp booking details variable for an arrival date. Ensures that prices shown in properties loaded by live scrolling feature show the correct price based on the date of the previous search.

<h3>Jomres 7.2.10 12/02/2013</h3>

Added queries and html to templates to ensure that the property's fax number is captured in the edit property pages.
Modified the booking engine to ensure prices are output in the price estimate according to the day/week/month settings.
Improved the new tooltips popups by using a new css class. Also removed month picker dropdown if property is an SRP
Fixed a bug where agent details weren't showing correctly.
Added a new language string to language files.
Improved dashboard tooltip classes.
Modified some popup output to ensure that they obey the "Use Jomres Messaging" switch.
Fixed some incorrect definition names in the reg link and search class menu options.
Fixed a typo that prevented property type names being translated in list properties.
Updated some missing strings for touch templating.
Modified sent emails. Added the guest's email address to email text so that those users who's system setup will not allow guest emails to be set as the return email address will still see the guest's email in the body of the message, and use that.
Updated the version of datatables used by Jomres.
Changed the Madagascan currency symbol.
Modified how chains of tariffs are found, fixes a case where tariff counts for days weren't done correctly internally. This part of the code is used to determine if the tariff map has dates for all days in the booking's date range.
Tweaked the BS Cookie template.
Changed how some routing is done, changed our code to ensure it uses the same code that Joomla uses (j2.5 & j3) to aid string comparisons. Improves searching on translated region names.
Improved edit property templates, added inputs for fax numbers.
Corrected a lang definition name used in touch templates.
Removed Joomla 1.6 and 1.7 cms specific functionality. These versions of Joomla are no longer supported and Jomres will not run in them.
Tweaked some new functions to ensure we check to see which script is running first. If we're running the installer some Joomla functions will not be available.
Resolved an issue where regions were showing as region ids in confirmation letters.
Changed how search form submission urls are generated, helping to make Jomres even more SEF friendly.
Changed the template array index for the submission url to SUBMITURL
Changed the confirmation email to the hotel to set the From name to be the guest's name, not the hotel's.
Added some changes to allow Jintour to insert a tab into the edit booking page, for both managers views, and guest's views.

<h3>Jomres 7.2.9 22/01/2013</h3>

Modified a previously removed switch. Put it back in, but changed how it works. Previously we'd removed the "Enable currency conversion" option, because for the shopping cart to work the conversion functionality ALWAYS has to be enabled. Some people didn't like this as they only wanted prices output in one currency, nnn.nn instead of nnn.nn (nnn.nn). To get around this user conflict we've re-added the switch, but changed what it effects. Instead of using it to switch off the conversion functionality internally, we'll leave the functionality enabled, instead we're simply using it to tell the "output_price" function to not output the price in the nnn.nn (nnn.nn) format.
Added some code to ensure that tooltips show correctly in module popups in bootstrap.
Fixed a css class bug in the srp calendar. Thanks David!
Tweaked the UI availability calendar so that Jintour can block out dates.
Added default tooltip popup code for new tooltip class.
Modified flat rate functionality, ensured that the tariff map is always created when calculating prices.
Tweaked list properties script to add telephone number to output.
Added functionality to support having a cms specific output date class that'll use the Joomla language file's settings instead of property configuration settings.
Updated microdata in show_property_reviews.html
Tweaked a path to a loading gif.
Tweaked a few urls in the Jomres code to ensure they're parsed through jomresURL function.
Updated the Spanish language files, many thanks David.

<h3>Jomres 7.2.8 08/01/2013</h3>

Set the default tariff model to Average.
Tweaked flat rate pricing to ensure that the correct tariff uid is selected internally if the property uses Flat rates but micromanage tariff editing.
Modified the booking engine so that the add room and remove room buttons have different icons and colours. (Bootstrap only)
Tweaked the booking engine to deal with an obscure minimum interval issue.
Modified the non-verbose tariff script to show less data, makes the tariff list more readable in the property details/tariffs tab.
Fixed a missing span in the show reviews template.
Added a change that removes Joomla's "base" tag from the page's output. We've updated jquery ui to 1.9.2 and it's tab generation code has changed. The base url is used and if the base url is wrong then the tabs will reload the entire site's content. This tweak gives us forward compatability for when J3's jq ui library is updated to 1.9.x, so that's nice.
Added some wells around the rooms list to improve the output in bootstrap, and we now hide the available rooms div if there aren't any available rooms.
Removed some input filtering that was duplicating some filtering that'd already been done and causing apostrophe's to not be entered properly into the db.
Removed a condition that prevented the availability calendar from showing in the booking page.
Changed the tooltip class as the older beauty tips no longer work in Jq ui 1.9.x
Moved tooltip trigger code into jomres.js
Improved layout of list templates, and tweaked the show reviews page so that google will render the microformat data.

<h3>Jomres 7.2.7 03/01/2013</h3>

Updated jquery ui javascript and css libraries to 1.9.2 as that's required by the new edit in place functionality.

<h3>Jomres 7.2.6 02/01/2013</h3>

Modified booking engine so that the duplicate tariff id check is only done for micromanage tariffs, so that Advanced tariffs, duplicates are returned to the booking form.
Tweaked the price calculation so that the estimate is only performed on micromanaged tariffs in average mode. 
Minor changes to logging to make the booking form log more readable.
Modified output of booking details to reflect a paid invoice's status.
Small tweak to rooms list normal mode tariff editing page.
Added commented out code to show how to add that availability calendar to the property list.
Removed the option to enable/disable currency conversion
Added new code that looks at all tariffs for a property. If ALL tariffs have a specific arrival day of the week set, then the booking calendar popup will only allow those days of the week to be chosen.
Added x-editable to Jomres, which will replace the older editable jquery plugin, as it works with both jq ui and bootstrap.
Removed a defunct call to jrportal.js from fe_stats.
A raft of changes to support new inline text editing functionality. Reduces the number of items that can be changed through the editing mode, to make the feature more user friendly (and less error prone due to mis-use).
Edit show room details so that room name isn't translatable in tabs.
Tweaked the performance monitor to use multiple points with the same name.
Tweaked the pathway to not show if editing mode is enabled.
Tweaked the basic_property_details property details queries to provide a small performance improvement.
Modified the jr_gettext function to call the jr_get_defined function less often.
Added a feature to allow us to switch off region name translation functionality. Due to there being something like 4,000 region names in the db, translation of regions can take up a great deal of memory. Slower machines may suffer so we'll offer people the option to forgo this feature,and it's switched off by default.
Tweaked the J1.5 router.php to ensure that it uses jr_gettext when building urls.
Modified the booking engine, improved how pricing is calculated by making use of the room allocations and tariff map arrays, which are new. Makes the te_setAverageRate method much more readable.
Added some js to the booking form's javascript to close old growl popups before new ones are shown.
Tweaked the new editing mode scripts to ensure .js and .css files are only added to head if editing mode is on (cos the .css file borks the jq ui calendar css, among other reasons).
Added property type to srp's property type tab.
Tweaked bootstrap editable to remove datepicker related css.
Modified the reviews template to include microdata.
Tweaked the tariff estimation code to let it use new functionality to provide pricing estimates.
Improved the booking engine and how tariff types are filtered out to ensure that only the appropriate tariff types are filtered out on room prices being zero.
Added CURL agent to CURL calls.
Modified the search button so that it will use a bootstrapped button when bootstrap enabled. (Search modules).
Updated copyright information.

<h3>Jomres 7.2.5 07/12/2012</h3>

Modified the new badge generation script, stop it from showing on the add plugin page as that script already uses plugin info scripts and an error will be generated and the plugin will not install.

<h3>Jomres 7.2.4 06/12/2012</h3>

Added a new feature that property managers can use to manually approve newly created properties. Until a property has been approved a manager/super manager cannot publish/unpublish a property.
Added new functionality to add badges to administrator menu, and three new scripts to generate items requiring attention badge numbers.
Added a feature to the booking engine that allows Jintour to set the "fully booked dates" javascript array, effectively allowing Jintour to block off calendar dates in the booking form calendar for those dates that don't have a tour available.
Created two new js files, a consolidation js file and an minified version of that file. Many of our .js files have been static for a long time so it makes sense to consolidate those files into one, smaller file.
Added commented out code to contact owner template to show you how you can theme the captcha code.
Modified the booking engine, if using micromanage, then any tariff where zero appears as one of the prices, then the entire tariff type (micromanage tariff) is excluded as a possible choice.

Added a clearfix to the bootstrap basic module output so that the module layout works properly.
Added a super secret, never to be mentioned option to the get_property_module_data so that a calling script can define template paths and template names.
Modified the method that builds the language dropdown so that it can also be used as a configuration option.
Added a configuration option to property config - misc to allow us to set the default language for the property. Not used as yet, but there are plans to use it later.
Added a new 05100 optional minicomponent trigger to the end run of jr_gettext. Currently disabled.
Disabled some joomfish cookie settings as they're N/A in J3.
Modified how the session file is detected.
Modified the slideshow script. If the slideshow images haven't been uploaded, but the main property image exists, then use that instead.
Fixed a bug where new users couldn't be created in J3 when creating bookings.
jrportal's js file consolidated into jomres.js
ui_availability_calendar modified slightly to take into account the possibility of room numbers being changed.
Modified jomres/jomres_config.php to add a new option "property language" and set the default to en-GB.
Modified how regions are constructed as dropdowns, changes the region stored in the DB from the region name to it's ID. Makes cross/language functionality work in the edit property page.
Tweaked the GifCreator to ensure that we're not throwing exceptions to the global scope as we're not using the namespacing.
Updated the prepGeographicSearch function to use translated numeric ids in regions.
Added a missing definition's jr_gettext call to the editpfeature admin script.
Updated ui availability calendar so that it uses random ids, meaning that more than one ui calendar can be used on a page at a time.
Added a clearfix to improve the basic module wrapper display.
Added a missing jr_gettext to the published property feedback message.
Updated the Polish lang files, many thanks Patryk.
Modified the search functionality to search for both region ids and region names in the propertys  table.
Added a new "migrate region names to region ids" function, but will leave it disabled for now. New Jomres functionality forces us to store region names as the database region ids, however we don't want this new functionality to negatively impact users with existing data so search functionality has been updated to search both region names and region ids in the jomres_propertys table. For now we BELIEVE that this will be sufficient to provide a painless upgrade, however we'll keep this migration function in our back pockets in case we find that users benefit from migrating their properties to region ids.
Added room name and number information to confirmation page.
Modified the add plugin functionality. While testing plugin updates it's occasionally necessary to install them through the third party installer to test table update functionality, however previous to this change it wasn't possible to do.
Modified showplugins to use include_once instead of include, as new functionality might end up with scripts including the plugin info scripts several times.
Modified the mailer to change email body's to html so that urls can be linked properly, but only if the email doesn't already content http-equiv code.
Added a change to geocoder to limit the number of decimals used to define the property's location. Without this some properties generate long strings which are too long for the lat/long columns in #__jomres_propertys

<h3>Jomres 7.2.3 20/11/2012</h3>

Added a new feature where property list images are shown as gifs if configuration set to show them, and there are slideshow images. There is also an option to only show featured properties as gifs.
Modified edit my account functionality to allow uploading of images for users.
Added a feature where users can list properties for specific property managers (task is called view_agent). A new image in the property list quick info (taken from the image uploaded via the Edit my Account feature) links to a list of all of the manager's properties.


Removed the loading animation for bootstrap modal popups. Ugly.
A small fix for the dashboard to show the half images when clicking the dashboard menu also otherwise it shows the half images only when logged in and going to the default jomres page.
Modified property list so that if property description is shorter than the description limit, then ... is not shown.
Tweaked a module popup js function to ensure it only triggers if the property uid is set.


<h3>Jomres 7.2.2 13/11/2012</h3>

Added functionality to the database handler that'll allow us to cope with 1and1's socket settings.
Added functionality to allow editing of css files through the template editing feature. Was disabled in the last version due to new template editing functionality, but has now been reworked.

<h3>Jomres 7.2.1 07/11/2012</h3>

Removed a private class definition that was causing errors.
Tweaked the dashboard minicomponent to ensure that the date dropdown is shown if we're actually running the dashboard task.
Fixed an issue where Advanced tariff editing mode tariffs are showing that the min interval needs to be 1000 days.
Tweaked the currency format class so that the integer only price shows correctly on all server configurations.

<h3>Jomres 7.2.0 30/10/2012</h3>

Modified the booking engine to make use of greater flexability offered by upcoming changes to the advanced/micromanage plugin when configuring minimum day settings. The new micromanage functionality allows you to set minimum days for individual days, in the same way that you set individual day's prices.
Added functionality that allows us to have Property Type specific templates.
Added a work-in-progress Thai language file to the Core system.

Changed a call to strtolower to jr_strtolower. Affects categories of the administrator area main menu, ensuring that non-latin characters are lowered correctly.
Tweak to ensure that users clicking on the dashboard link actually see the dashboard.
Added icons and minor layout tweaks to property details buttons.
Adding an experimental php parser function to patTemplate lib.
Updated codemirror lib to v2.34
Added old codemirror scripts to obsolete file list.
Modified obsolete_files_wrapper.html so that obsolete files list is collapsed by default. BS only.
Modified delete template to delete by id instead of template name.
Modified the getPropertyTypeDropdown function to allow blanks in the dropdown list.
Added a property type column to the custom templates table on installation/upgrade.
Modified how the custom template handler works, so that it's able to support property type specific templates.
Modified the getThisMonthName function. Solved a problem where month names are not displayed in the default dashboard
Improved feedback from booking engine to ensure that if the minimum interval isn't reached, then a message is shown. Provided popups to give users hints to how many days they should book for to get certain prices.
Improved list templates page to clarify new functionality's instructions.
Commented out two lines in the router that're causing J3 to throw an error when clicking on dashboard dates. Works around a minor-ish bug in J3.
Modified the Weak input filtering process slightly, apostrophes are changed to Right Acutes.
Added an mb_ucwords and jr_ucwords pair of functions.
Modified the administrator area generate control panel script to us jr_ucwords.

<h3>Jomres 7.1.4 16/10/2012</h3>

Added a new feature so that site managers can configure the default property list view through the site config - search options tab.
Adding some experimental changes that'll allow us to switch languages in the administrator area.

Occasionally it's normal for the session file name to have not been created, added a check to temp booking handler to take that into account.
Added an option to reset the custom text class on the fly.
Changed how administrator editinplace functionality accepts languages. Instead of using showtime 'lang' it now accepts whatever's in the url.
Added a missing div to edit customer type jquery ui template.
Improved the bootstrap html in the plugin manager RE popups.
Modified how the logo is called in the management view.
Language dropdown removed from translation pages, as it's now added to the administrator backend as a whole.
Changed bc_is_even method, probably don't even need it now, and it lowers the bar for installation slightly.
Fixed a typo that was preventing the save to cart text from showing in the booking confirmation page
Removed header declaration from handlereq.php as it's no longer required.
Updated Polish lang files, many thanks for that Patryk

<h3>Jomres 7.1.3 10/10/2012</h3>

Fixed a bug in the region import script which meant that the regions table was being populated with duplicate regions when install_jomres.php was run.
Fixed a small issue where SRP property type selection showed a definition instead of a string when tariff editing mode was advanced/micromanage.

<h3>Jomres 7.1.2 10/10/2012</h3>

Added JOOMLA30 to the list of CMSs that allow us to use JFactory::getLanguage to detect the current language.
Changed the point that we trigger jomres_language to detect the current language in the administrator area.
Broke translation functionality into two new pages, translate locales and translate lang file strings. Added a new feature to check whether the user's a super property manager before attempting to use the translation features, and added the language dropdown to the three translation pages.
Discovered that new language file translation feature doesn't like the < symbol in language file definitions. Forced to modify those definitions to remove the <.

<h3>Jomres 7.1.1 09/10/2012</h3>

Added more strings to be parsed through the jr_gettext function.
Fixed another bootstrap bug where changelog and warning popups weren't showing.

<h3>Jomres 7.1.0 05/10/2012</h3>

Fundamentally changed how language strings are used in Jomres. We no longer use "define"d strings, instead strings are added through a new Jomres function jr_define. This allows us much more flexibility in how languages are used within the system. 
Added new countries and region functionality, allows users to add/edit/remove countries and regions without editing the countries.php file, as old countries/regions are now imported into the db.
Improved Language Translations feature, using newly created language handling functionality. Language Translations now allows you to customise ALL language strings from language files, for the current language context.
Added a new feature that allows you to export definitions created using the Language Translations page as a new file.

Tweaked custom template handler so that it works with bootstrap.
Modified countries.php to update the status of Netherland Antilles (now defunct). Added CW, AW and BQ, but will leave AN in-situ for now as existing customers will be using that.
Removed a check for tmpl in the url that stops the Availability link from being shown.
Some bootstrap tweaks that fix issues with BS 2.1 and hidden-phone definitions. Fixes table layout problems caused by J3B2 going to BS2.1
Changed how property name is found when generating property list in guest's list bookings.
Improved the new auto-detect the guest's country in the booking form feature, by allowing the property manager to define if this option should be used, or if the property manager should set the default country manually.
Modified common scripts in patTemplate, added a new variable COMMON_SOURCE_SCRIPT, which a user can add to a template file to help them figure out which script is calling that template.
Commented out some redundant code from the plugin manager templates.
Undid a previous change that was designed to allow free searching without setting module search options, as it was causing module output to be changed in undesired ways.
Full access control switch hidden in site config. People don't read what it does before enabling it. Basic access control still available.
Modified the composite property details notabs template to make it more obvious how data can be constructed.
Changed how urls are detected at startup, as Joomla's SEF plugins will mangle some urls.
Added list_normalmode_roomtariffs.html in the frontend dirs to the obsolete files list.
Added trim() to save property name 
Updated Polish lang files and countries.php to reflect Poland's 16 regions.
Fixed an issue where live scrolling was only scrolling once, due to a bug introduced in a v6.6.6 change.
Added a hidden input to site config that will automatically change the chosen mainmenu layout to "alternate" so that upgraders will be forced to use the new bootstrap main menu.
Re-enabled management view now that J3 has been released.
Updated jquery and jquery ui to 1.8.2 and 1.8.23 respectively to allow them to work alongside Joomla 3's jquery functionality.
Fixed some incorrect paths to template dirs for obsolete file checking, and removed some older .js files that are no longer used.
Added some changes so that plugin descriptions work on click in plugin manager.
Added radio button js to management bottom.
Updated basic_property_details to include property type string.
Updated a variety of output strings to ensure they're passed through jr_gettext
Small tweak to ensure that Jomres doesn't try to apply radio buttons to commission rate dropdown.
Added j00501editingmode.class.php to the obsolete file list.
Added a space between subject and hotel name in contact owner page.


<h3>Jomres 7.0.2 11/09/2012</h3>

Added a couple of small changes to ensure that Jomres will install on Joomla 3, Beta 1.
Added img src to default html purifier options.
Fixed a bug where the invoices table wasn't being created due to a new feature added in the last version.
Added warning to administrator area if Beez3 is the default site template, and a few minor tweaks to other template files (Joomla 3)
Split dashboard functionality out into it's own 06000 script.
Added a ; to stop falang from throwing a wobbly.
Tweaked new dashboard functionality to allow switching on and off of legend and month dropdown.
Modified a file's name to ensure it includes the country in the file's name.
Default language context set back to Nothing.
Changed how the default bootstrap/non-bootstrap settings are chosen in site config.
Removed a defunct settings that was only used during beta development from site config setting array.
Disabled plugin shop in the plugin manager.
Improved the domain determining function.
Brought admin's first run instructions up to date.
Fixed an issue in rooms list caused by BS 2.1 changes.
Added guest types to BS radio exceptions.
Single person suppliment data isn't output in the booking form if it's disabled in configuration.
Added some changes to use the geo_located country instead of the old mrConfig country.
Fixed some edit guest inputs that were incorrectly labelled. (Bootstrap)


<h3>Jomres 7.0.1 06/09/2012</h3>

Added a new feature where plugins which are required by other plugins are installed automagically.
Removed some depreciated "split"s and replaced with explode. Other changes to resolve JCE's strict error level settings causing problems.
Added a timed redirect to the bootstrapped plugin installation advisory page.
Added a space that would appear between "price" and "poa" for properties that don't have prices set.
Added a missing template to the jquery ui library.
Bootstrapped the installer.
Fixed issue where wrong query was resulting in the wrong property type in the pathway script. As the pathway is run pretty early on this was then setting the property type wrong in lots of other places due to caching of output text in the jr_gettext function.
Changed the install plugin link, removed no_html as it's no longer appropriate now that we've added the installation feedback output.
Corrected some url generation.
Removed the ability for users to enable bootstrapped Jomres templates in the administrator area if they're not using Joomla 3+
Added a couple of images to our image library.
css and html for photo view to make it more responsive and fit properly ...the last version had problems when clicking on modal...also made it use the bootstrap modal instead of jui one.
Added functionality to provide output in the event of an error finding paths in patTemplate.



<h3>Jomres 7.0.0 31/08/2012</h3>

Changed the REQUEST element checked before outputting hotel details to property_uid from id.
Added some more bootstrap specific labels to the my commission invoices script.
Added a new no image thumbnail image
Added two new common lang strings, Edit and Copy, to lang files.
Added bootstrap code to the Back to property details and open booking form links shown when the booking form is coded to show as a popup.
Modified the show reviews template to use bootstrap's blockquote styling.
Corrected a price input into a number type in edit extra
Changed normal mode tariffs so that the price input is a html5 number type.
Modified a number of templates & scripts to use a more aesthetically pleasing dropdown & edit icon in various lists.
List extras and list customer types modified so that publish button is more obvious (and coloured).
Added a new data tables function and removed an experimental .js script that was used in the plugin manager.
Improved the bootstrap plugin manager layout further.
Changed how data sent from the plugin manager is sanitised (not that we expect this data to be suspicious, but it never hurts to be careful).
Temporarily disabled management view in J3 until at least Joomla 3's formal release.
Added site config switches to decide if we should use bootstrap or not.


<h3>Jomres 7.-1.0 29/08/2012</h3>

Disabled the Jomres text editor in J2.5 More trouble than it is worth atm, if somebody enters something that creates a javascript error the editor crashes and burns
Added slideshow to pathway
Various list invoices tweaks.
Moved jomres_alternate_menu_position outside jomres_content_area so that we retain the menu if ajax search composite is used.
Disabled a new js function's bells as it doesn't whistle on the ipad.



Jomres 7.0.-2

Tweaked show hotel details page so that it can be viewed via a direct url, as well as called from another plugin.
Updated asamodule report functionality to output more information.
Changed some wording in lang files, replaced Book now and Book a room with Book now! and More Info with Read more (as that's more in tune with Joomla's UI)
Featured listings has a new feature where featured properties can have a class applied to them so they shop up emphasised in the property list, added changes to Jomres property list functionality to support this feature. 
Changed how powered by is added to bottom of the page, and changed how radio button rendering code in frontend is built so that if using  bootstrap on j2.5, then the radio buttons will still work.
Tweaks to some J3 BS templates, including how the map is rendered so that it's width is responsive.
Re-enabled the function getbookingguestdata, thought to be depreciated, but the paypal gateway plugin uses it.
Fixed a bug where IE wouldn't disable the cookies pane.
Added property name to reviews dialogue.
Added order by property name to property list in Show Profiles.
Added radio button group styles to Jomres bootstrap css script, as they're likely to be missing in some J3 BS templates.
Added code to disable magic quotes if it's enabled, due to one funny server (I'm looking at you, exploretravel!)
Tooltip tweaks to allow tooltips to work in module popups.
Removed dialog alert class from image popup function.
Various bootstrap template improvements to account for using BS 2.1.
contact form tweaked to have a page title and sub-text
Invoices changed to display page even if no invoices, when using the filtering
Added a new method to count the number of guests, and added a count that says if there's only one guest type then don't offer 0 as an option in the guest number dropdown.
Added guest id to invoices list, ensured that it's added to the invoice table when a new booking is made and when the guest list is viewed invoice buttons are associated with guest ids.
Added jquery easing and a new slide and toggle jquery function.
Disabled the Jomres text editor in J2.5 
More trouble than it is worth atm, if somebody enters something that creates a javascript error the editor crashes and burns
Pathway functionality updated to work with J2.5 & 3, and search functionality modified so that a setting doesn't need to be enabled in a module for the setting to kick in during searching.
Layout and css tweaks to new bootstrap templates.


Jomres 7.0.-3

***
* Summary 
*
* The main changes in Jomres 7 refer to using Jomres in Joomla 3, adapting it's templates to work seamlessly through Twitter's Bootstrap CSS framework.
*
***
Added microdata ( http://support.google.com/webmasters/bin/answer.py?hl=en&answer=176035 ) to property header.
Updated composite property details to resolve issues of the gmap not rendering in old style templates.
Fixed a bug where the currency wasn't always being shown in property lists.
Solved an issue where property addresses weren't being shown correctly in favourites list.
Changed a minicomponent to be touch templatable so that the Invoices word can be translated.
Fixed a bug where the shopping cart's price was set to twice the deposit actually required, when the price is sent to paypal.
Tweaked currency code dropdown creation method so that if global currencies is off, and currency conversion is disabled, the dropdown will still be shown in the tariffs and currencies tab of Property Config.
Added cache enabled warning to admin area control panel for j2.5
Made a lot of preliminary changes to simplify the defined urls used in Jomres, ensuring that there are dedicated ajax urls for both site and administrator areas, and that they're used in favour of other, older urls.
Fixed paths for manager selection
Implemented a new cms specific file that allows us to do some "post run" stuff. Joomla 3 insists on outputting html despite tmpl=component being set, which basically blows everybody's ajax out of the water. The new endrun file includes JFactory::getApplication()->close(); if it's an ajax call, which effectively tells Joomla to stop what it's doing and behave.
Added common Action and View language strings.
Improved the plugin reporting on the control panel.
Modified plugin manager to use a template for most (not all) of it's information generation. 
Changed which variable is used in the classic rooms list, means that price is output inc tax, if the property prices are configured to be gross.
Tidied up the tax calculation method in the booking engine, removed some obsolete stuff.
Changed wording in English lang files to clarify Gross and Nett setting in tariffs and currencies.
Blank option in Tariffs and Currencies tax code dropdown removed. This had been left in-situ when we first adapted Jomres to calculate ex-tax prices in the booking engine. Now that proper tax breakdowns are used everywhere it makes sense to remove the blank option from the tax codes dropdown, thereby forcing all new users to select a tax code when configuring.
Modified property switcher to ensure that nofollowtmpl is used.
Added an extra check for curl init to one control panel function.
Re-organised when the Jomres main menu is triggered.
Rewrote admin.php and obsolete file handling to allow us to "templateise" the administrator control panel.
Deleted some scripts, images and templates that are no longer part of Jomres, added them to the obsolete files list.
Inserted a space between terms and conditions text and it's associated link.
Made "propertyrental" the default language context.
Modified showplugins so that if the server was unable to communicate with the Jomres server to get a price, then a comms error is reported, rather than erroneously reporting the price of a plugin as 0 (free).
Tweaked how the mailer works, solves a problem where emails passed as array were not found correctly, the code was missing if the "use jomres email checker" is set to no. 
Modified show confirmation so that "Guests" output isn't shown if get_showtime('include_room_booking_functionality') is false.
Moved functions out of integration.php, and into function files of their own, or into functions.php
Identified and disabled (commented out) a host of depreciated functions.
Updated html purifier to 4.4, modified input filtering to offer a number of different ways that inputs can be filtered (new tab in site config).
Disabled Jomres editor (for now) as it's not very robust.
Added input filtering defaults to site config panels.
Input filtering rejigged slightly, now the allowed html inputs are defined in 00003, before the first jomresGetParam call is made. If we don't do this, the allowed inputs will never be set.
Added a recursive directory scanning function.
Removed htmlpurifier-4.3.0-standalone directory from repository.
Added htmlpurifier-4.3.0-standalone to obsolete file list.
Modified the scan dir function to also filter on extensions as an option.
Modified control panel to silently remove .js files from /jomres/temp, keeps temporary javascript files fresh.
Added compare url to misc defines temp js file.
Added a no search results minicomponent, outputs a styled template with message.
Updated jeditable, improved it's functionality.
Added djris's dashboard colour changes.

Generally, these are bootstrap specific changes :

Rooms list configuration options disabled in property config as the rooms list is now templatised. It is more logical than having these options in the property config area.
Integrated Bootstrap templates into Jomres. Joomla 3 cms specific functionality included, but not yet tested against Joomla 3, so will need revisiting.
CSS and layout tweaks for Jomres 7
Tweaked the rooms list in the booking form
Moved a button's position so that it's inside the form elements.
Added an option to enable programatically disabling Joomla's cache feature for certain pages.
Implemented changes to allow Jomres to switch the date input's class depending on whether or not we're running bootstrap.
Added a new switch to enable/disable bootstrap templates in J2.5. This is a temporary option to be used during development.
Added a BR to the js_calendar_input.html template to allow a line break after the departure date input.
Corrected a template error where the wrong data was shown in property details.
Fixed a bug where prices weren't being shown for mrps/srps.
Bootstrap dobooking tweaks to make the booking estimate warning smaller.
Tweaked new functionality to ensure that max people in room number is shown in rooms lists in the booking form.
Added a minwidth setting to the booking form.
Numerous changes to facilitate Bootstrap in the administrator area of Jomres.
Made a variety to changes to ensure that Jomres will install and run in Joomla 3 alpha 1.
Renamed joomla 3 cms specific files dir from joomla3 to joomla 30
Removed some stray code from the edit_SRP_propertytype.html template. Cheers David.
Added a feature that allows us to use bootstrap radio buttons if an option (ie dropdown) has only two choices.
Added tweaks and notes to main menu wrapper alternate. This is fast becoming the "default" main menu wrapper, the accordion is likely to go the way of the dodo. As a result, it's worth considering renaming these menu templates altogether before Jr7 is released, removing obsolete ones and making this template's name more self explanatory.
Added a Back to top button that appears bottom right when a user scrolls down.
Tweaked new functionality to ensure that the bootstrap Yes/No buttons javascript isn't output if the call is via ajax.
Some url tweaks to ensure that ajax continues to work successfully in J2.5.
Various tweaks to allow modules to install and work in Joomla 3.0
Added a missing line to Jomres J1.5 url generation script. This was as a result of previous, post 6.6.7 url tweaks that provide more concise url definitions.
Setting a default, development option to No.
Modified javascript initialisation minicomponent to no longer include scripts that are not needed when using bootstrap.
Modified how dropdowns are generated to take advantage of joomla's new radio button selection functionality. 
Tweaked control panel's layout.
Modified partners templates to use new urls defined in patTemplates.
Added code to create global scope javascript variables for Jomres javascripts to decide if we're using bootstrap or not and make decisions based on that.
Changed the mobile device wrapped setting to off by default, pointless now that we've got bootstrap, may well remove those settings altogether.
Tweaks to how Jomres News is output in the control panel.
Modified cms_specific/joomla30/cms_specific_installation.php to remove "ordering" column from menu installation query, as it's no longer in J3.
Tweaked the obsolete files delete link so that it's a button, not just a link. Makes it more visible.
Removed "property_management" from the list of possible dropdowns that can have spiffy Yes/No themes applied.
Removed some javascript variables from templates as they're no longer appropriate.
Modified the booking form's calendar popup, if we're using bootstrap we'll let the number of months = 1, otherwise the popup doesn't look good on phones.
Tweaked the booking forms, the /form element was in the wrong place for modal popup booking forms.
Modified sanity check to add a br after the warning.
Added some js to bottom.html that makes radio buttons in the frontend render properly, as J3 pre-alpha 2 is currently missing this. Might need to/be able to remove this at a later date.
Added a slash to ensure that the paypal logo shows in view invoice page.
Removed the booking panel summary as slider option from J3 site config as it's no longer applicable.
Added a toggle button state js function
Fixed editing mode not switching.


<h3>Jomres 6.6.7 28/06/2012</h3>

Fixed an issue where users could not choose managers in Show Profiles.


<h3>Jomres 6.6.6 27/06/2012</h3>

Contact owner captcha replaced with reCaptcha (remember to set the public and private keys in Site Config)
Added a new feature to lock rooms in the booking form. To prevent the danger of rooms being double booked when they're added to a shopping cart a room lock will prevent a room from being added to another user's booking form (rather, from being shown in the available rooms list) if the dates of their booking coincide with the dates of another user's booking being made at the same time.
Added a new editor to Jomres.
Modified the functionality that generates the module popup .js file to include the domain, prevents issues where users are using multiple domains from having cross domain problems.
Modified currency codes class to exclude those code which cannot be converted. If we don't a property can choose an unconvertable code then the cart stops showing the correct figures.
Modified the insert booking function to copy over guest details, allows a property manager to put two bookings into the cart against two different guests.
Shopping cart modified to show prices converted to the global currency code. Without this change, if two bookings are saved to the cart, if they're using different currencies then the wrong prices will be shown on the cart.
Tweaked module installer so that modules that already exist shouldn't require uninstalling before they're upgraded.
A variety of changes to separate the rooms lists in the booking form's html from the booking engine.
Modified singleton abstract class so that plugin dirs can be scanned for abstract classes.
Added new code that allows us to have some language strings available to all templates.
Modified various templates to further standardise layout in templates, and finally, after 7 years, template-ified the list properties page. 
Changed how the edit booking page is rendered, finally moved various output data into their own templates.
Added a new feature that tells a user they've clicked on a link for a task where the plugin has not yet been installed, and gives them a link to that plugin in the plugin manager.
Made plugin names human readable in the plugin manager.
A variety of changes to improve consistency with input and output filtering. Resolves an issue where guests with cities with an apostrophe weren't being encoded then decoded properly. For legacy reasons elements of the booking engine used older escaping functionality, by changing the filtering to filter_input we can easily decode the sanitised strings. Not security related, just aesthetics related.
The Google map has been moved out of it's own tab and into the first, Property Description tab instead.

Image path fixes for paypal in invoices.
Small tweak to make the deposit the entire booking's price if the deposit is set to be the first night's price, and the booking's only for one night.
Tweak to the drop image function to ensure that medium thumbs are also deleted when other images are deleted.
Improved multibyte handling.
Tweak to ensure SEF'd urls don't bork form action search urls.
Improved how the booking engine finds free slots when the booking form is first generated.
Added an updated Polish language file to the system.
Solved a problem with the reviews average rating and number of reviews not being shown in property list.
Added a new language definition POA to language files. Modified the price output function to output POA if price isn't otherwise set. Got sick of seeing $0.00 when tariffs were not available for a property.
Further improvements to the code added to speed up generation of the booking form if the property is using fixed arrival days.
Removed some spans from dropdown creation functions.
Improved new code in output_price which allows 0.00 to be output in certain circumstances.
Modified how links to invoices in different states are constructed in templates.
Changed the validation js file called, as the minified version is no longer shipped with Jomres.
Added a cancel word to addreview script.
toptemplate functionality tweaked to enable menu generator to use the various top template dropdowns.
Modified switch property feature to use template when generating buttons.
Modified sanity check functionality to remove html out of code and into it's corresponding template.
Tweaked how report bug information is built.
Updated list guests invoices script to account for new links.
Tweaked editproperty to provide further output for url/text separation in templates.
Modifed saveproperty so that if the property name is blank, the old property name is reused.
Edited new black booking template so that new text separation functionality is used.
Further layout separation tweaks to the rooms list and edit room and edit room feature pages.
Layout tweaks to list_property_bookings.html
Tweaked edit booking related pages, made it so that add/edit notes doesn't try to close the page, and that cancel booking/edit deposit pages return to the edit booking page when cancel clicked.
Modified the add header code in cms_specific/joomla25/cms_specific_functions.php so that if the filename isn't set, then the add to header functionality for that file is abandoned (allows us to disable some .js or .css scripts programatically)
Added loading animation to bottom of live scrolling feature so that user can tell if a new property is being loaded.
Show property reviews code and html separation changes
Modified geocoder script so that if mobile detected, then show a halfsize map instead of the originally defined size.
Modified dobooking to ensure estimate warning is available to the booking form template.
A number of changes made to jomres.js to allow the system to resize modal popups depending on the client device's resolution. These sizes are arbitrary currently and will need to be reviewed.
Modified input select functionality to automatically add class="input-medium", this will probably need to change in the future, but it'll do for now.
Modified the property header script to add the default thumb if the property doesn't have an image uploaded.
Removed some redundant code from dobooking.php
Removed span classes from countries.php dropdowns.
Added odd/even rows to list properties for use in templates.
Modified temp booking handler and booking engine to ensure that the property's currency code is stored along with the rest of the booking information. This allows us to build the cart later with the correct converted prices.
Confirmation form updated to correctly show new template changes.
Updated galleria slideshow to the responsive 1.2.7
Added a new class to the composite property details that'll help activate bootstrap'd tabs.
Added a strip tags and removed parse by bots from list properties. Breaks too much css if left in.
Added a display errors off to init_config_vars.php for Joomla 2.5
Modified show profiles, it'll be seen in the administrator's menu regardless of the advanced config option setting.
Changed temp booking handler so that administrator's sessions go into their own directories.
Changed file write functionality to use file get and file put instead of fopen.
Added some new classes for use in bootstrapped template booking forms. (dobooking.class.php)
Recent changes to the patTemplate livesite variable necessitate changing the name of one of the urls passed to the dobooking templates to ensure that the form can be submitted.
Updated the version of jquery validate
LIVESITE in booking completed script renamed to RETURN_URL to prevent conflicts with new LIVESITE patTemplate variable.
Javascript changes to support bootstrap dialog popups.
Added some extra data to booking form elements so that we can use control groups properly.

Tracked and chased down an error where logged in user's bookings weren't getting inserted when being paid through a payment gateway.
Problem was caused by changeset 2215 ( https://jomres.trac.cvsdude.com/Jomres_core_v4/changeset/2215 ) the addition of the userid to the salt which helps make the filename difficult to find. The idea of the change was resolve an issue where a user could log out, however their address details would still be in the temp guest data if they'd visited the confirm booking stage, so even after logging out a user could go to the booking form and retrieve those details. 
Whilst the fix changed that, unbenownst to us the payment gateways now could not insert a booking because the wrong session file was being found.

The fix involves removing that user id so that gateways can pass payment information back and bookings can be inserted, and adding a new logout task to the Jomres toolbar. When this is used the user is one-click logged out of Joomla, and their temporary data is destroyed.

<h3>Jomres 6.6.5 10/05/2012</h3>

Tweaked the booking engine to only output discount information if the "task" is set to "handlereq". This allows us to use the booking class outside of just the booking form. Add the ability to completely suppress any output that the booking engine would normally generate (and cleaned up a couple of superfluous lines).
Added a check to see if the booking class exists before trying to create it.
Further improvements to the exchange rate selector. I don't know what the heck Yahoo's doing, but hopefully these changes resolve the issues.
Moved a definition of module popup url to the javascript initialisation minicomp.
Removed a line that was preventing the correct language from showing in the module popup.
Disabling some output if departure date not to be shown option is set to Yes.
Added a flag to tell the patTemplate library to output variables as json encoded instead of rendered template output.
Permanently disabled caching feature, it creates more problems than it solves.
Changed the live scrolling number of properties from 1 to 3.
Fixed a bug where intermittently stars wouldn't show in the dashboard calendar to indicate an arrival.

<h3>Jomres 6.6.4 04/05/2012</h3>

Slideshow image handling modified. Images are now copied to uploadedimages/N/joomla/large,medium,small on upload. Existing images are also copied to those directories when install_jomres.php is run. This facilitates the possibility of using Joomla gallery/slideshow mambots.
Added code to set defaults for mrConfig 'booking_form_daily_weekly_monthly' if it hasn't already been set elsewhere.
Added per day/week/month output to show tariff pages too.
Added a default setting for the price multiplier.
Removed a multiplier that was incorrectly added for Jintour based properties.
Ensured that multiplier's not used if the tariff charges are already stored weekly, and that the correct pppn/pn text is used.
Changed how mambots (Joomla plugins) are called in J2.5.
Modified how we check when to show the pay now button. In the event that a user doesn't choose to pay for the subscription immediately, the button will now show next to the invoice.
Added some image sizing to dashboard star image, as it can't be seen on some J templates.
Some further improvements to how the paypal button is shown in the list invoices page.
Allowed super property managers to see their commission invoices in the frontend.
Fixed an issue where the minimum days before arrival option wasn't being used in the booking form, due to a change in the last version.
Modified how maps are generated in list properties, enabled the ability for layout plugins to set map sizes and if the map should be shown at all.
Timezone setting tweaks.
<span class="label label-important label-danger">Fix</span> Address and Tel in module popup are translatable.
Rewrote currency conversion functionality to be more robust.
<span class="label label-important label-danger">Fix</span> paypal button is shown on the commission invoices list.
Changed how javascript/css is implemented, files are now added through a minicomponent.
Made a change to ensure that add_gmaps_source(); is used regardless of other map settings in list properties. Without this, the module popup map will not show.
Moved template path definitions. Paths are now defined in a 00004 minicomponent, allowing us to use 00003 minicomps to set our own paths.
Tweaked patTemplates to output the path to the template if an error is triggered.
Added a "safe mode" feature that can disable all plugins. Useful for debugging client sites.
Changed how the mobile detection minicomp works. Doesn't return if the Jomres javascript files have already been called.
Added a check for the existence of the exchange rate temporary file.


<h3>Jomres 6.6.3 25/04/2012</h3>

Added a new trigger 00004 which allows us to set up JavaScript and css files via a minicomp. This makes it possible to programatically replace, among other things, the jquery core, ui and ui themes via a plugin.
Improved Jomres' mobile device detection, added a simulation option and a new define _JOMRES_MOBILE which mobile sensitive plugins would be expected to use.
Modified the live site url to ensure that the current language is always passed in the urls.
Fixed a not defined error message in Jomres SA.
Moved some jquery binding from list properties javascript file into a template. Reason being, if list properties.js is on the same page as the property details template, the book a room etc buttons have the binding applied twice, doubling their size. With the advent of the parse_ajax_returned_scripts js function, this isn't required, we can put the binding into the list properties header script so that it's only applied if the property list is returned.
Plugin manager updated to use anchors to make it a little more user friendly.
Moved rebuild registry code to ensure that the registry is rebuilt after a plugin is installed.
Modified templates to stop register property step two from checking data has been entered into the property description field, because it's not possible to check if a field has been populated when the editor is used.
Modified the get_property_price_for_display_in_lists function to use per day/night/week/month texts in property lists, modules etc.
Added some "true" options to redirects to see if this resolves an obscure 500 somebody on fastCGI is seeing.

<h3>Jomres 6.6.2 16/04/2012</h3>

Modified jomresRedirect function, replaced &amp; with & when redirecting, otherwise the correct url isn't used.
Removed some commenting that prevents javascript in the body being ignored by validators, as it causes the DOM to not see the globally scoped compare_url var.
Added a new javascript function that allows us to parse js returned by ajax functionality to find and trigger any javascript in the returned data.
Credit : http://www.developersnippets.com/2009/05/20/evaluate-scripts-while-working-on-ajax-requests/

<h3>Jomres 6.6.1 10/04/2012</h3>

Set review popup width/height to 800/500 respectively (swapped from 500/800)
Modified list properties default layout to show images as thumbs, not the medium images.
Fixed a parse error in SA's cms_specific_urls.php
Added a "no items in shortlist" lang definition for when no items have been selected.
Tweaked how the property list is generated, added an option that effectively allows calling scripts to disable the live scrolling effect.
Jomres SA. Modified warning so that if your password is still "welcome" then it will not show up when ajax queries are done.
Small tweak to the booking engine. If the property is configured to show dropdowns in the booking form for date selection, then subtract 1 from the staydays.
